/**
 * 度数の検定
 * １×２表(正確二項検定)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var elmCount = 2;

	var result = confirm("データを消去します");
	if (result === true) {
		document.getElementById("cell_1").value = "";
		document.getElementById("cell_2").value = "";

		errorClearCell(elmCount, "");

		document.getElementById("cell_sum").value = "";
		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 1;
	var iCount = 1;
	var jCount = 2;
	var elmCount = iCount * jCount;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 1; i < elmCount + 1; i++) {
			if (document.getElementById("cell_" + i).value === "") {
				errorCellNum = i;
			}
		}

		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			sum();
			mainCalc_1x2();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		conditionalBranch();
		copipe("CandPArea", "text");
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
		sum();
		checkCellData();
	}
}
// スタック形式ならクロス集計に分岐
function conditionalBranch() {
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	if (dd.length > 1 * 2) {
		crossTabulate();
	}
}
// スタック形式をクロス集計する
function crossTabulate() {
	var i = 0;

	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var err = false;

	if (err === false) {
		for (i = 0; i < dd.length; i++) {
			if (isNaN(dd[i]) === false) {
				if ((parseInt(dd[i]) == 1) || (parseInt(dd[i]) == 2)) {
					err = false;
				} else {
					err = true;
					break;
				}
			}
		}

		if (err === false) {
			var groupValue = [];
			groupValue[0] = 0;
			groupValue[1] = 0;

			for (i = 0; i < dd.length; i++) {
				groupValue[dd[i] - 1]++;
			}

			var strArray = [];
			strArray.push(groupValue[0]);
			strArray.push("\t");
			strArray.push(groupValue[1]);
			strArray.push("\n");
			document.getElementById("CandPArea").value = strArray.join("");
		} else {
			document.getElementById("CandPArea").value = "";
			alert("データ形式が正しくありません。");
		}
	} else {
		document.getElementById("CandPArea").value = "";
		alert("データ形式が正しくありません。");
	}
}
// メインの計算
function mainCalc_1x2() {
	var i = 0;
	var j = 0;
	var k = 0;
	var h = 0;
	var DD1 = parseInt(document.getElementById("cell_1").value);
	var DD2 = parseInt(document.getElementById("cell_2").value);

	var NN = DD1 + DD2;
	document.getElementById("cell_sum").value = NN;

	var DS1 = (DD1 / NN).toFixed(4); //グラフに渡す値
	var DS2 = (DD2 / NN).toFixed(4);

	var effectSizeG = Math.abs(0.5000 - DS1);

	var strArray = [];
	var rcmArray = [];

	var PP2 = 0;   //両側確率
	var PP = 0;    //片側確率

	var minD = Math.min(DD1, DD2);

	var P = [];
	for (var R = 0; R < NN + 1; R++) {
		P[R] = Math.exp(LogCombination(NN, R) + R * Math.log(0.5) + (NN - R) * Math.log(0.5));
		// P[R] = Math.exp(LogCombination(NN, R) + R * Math.log(母比率１) + (NN - R) * Math.log(母比率２));
	}

	//ベイズファクタの計算
	var ds = P[DD1]; //帰無仮説の事後の的中確率：観測値１の偶然確率
	var BF = 1 / (NN + 1) / ds;

	for (i = 0; i < minD + 1; i++) {
		// PP = PP + Math.exp(LogCombination(NN, i) + NN * Math.log(0.5));
		PP = PP + P[i];
	}

	PP2 = PP * 2;
	if (PP2 >= 1) {
		PP2 = 0.9999;
	}

	// var pp2Str = "";
	// if (PP2 < 0.01) {
	// 	pp2Str = "   ** (p<.01)";
	// } else if (PP2 < 0.05) {
	// 	pp2Str = "   *  (p<.05)";
	// } else if (PP2 < 0.10) {
	// 	pp2Str = "   +  (.05<p<.10)";
	// } else {
	// 	pp2Str = "   ns (.10<p)";
	// }

	// var ppStr = "";
	// if (PP < 0.01) {
	// 	ppStr = "   ** (p<.01)";
	// } else if (PP < 0.05) {
	// 	ppStr = "   *  (p<.05)";
	// } else if (PP < 0.10) {
	// 	ppStr = "   +  (.05<p<.10)";
	// } else {
	// 	ppStr = "   ns (.10<p)";
	// }

	var ppRlt = [[], [], []];
	//両側検定
	if (PP < 0.005) {
		ppRlt[0][0] = "** (p<.005)";
	} else {
		ppRlt[0][0] = "ns (p<.005)";
	}
	if (PP < 0.025) {
		ppRlt[1][0] = "*  (p<.025)";
	} else {
		ppRlt[1][0] = "ns (p<.025)";
	}
	if (PP < 0.05) {
		ppRlt[2][0] = "+  (.025<p<.05)";
	} else {
		ppRlt[2][0] = "ns (.025<p<.05)";
	}

	//片側検定
	if (PP < 0.01) {
		ppRlt[0][1] = "** (p<.01)";
	} else {
		ppRlt[0][1] = "ns (p<.01)";
	}
	if (PP < 0.05) {
		ppRlt[1][1] = "*  (p<.05)";
	} else {
		ppRlt[1][1] = "ns (p<.05)";
	}
	if (PP < 0.10) {
		ppRlt[2][1] = "+  (.05<p<.10)";
	} else {
		ppRlt[2][1] = "ns (.05<p<.10)";
	}

	var ppStr = "";
	ppStr += "p=" + PP.toFixed(4) + "（片側確率）\n\n";

	ppStr += " \t両側検定\t片側検定\n";
	ppStr += "-----------------------------------------\n";
	ppStr += "α=.01\t" + ppRlt[0][0] + "\t" + ppRlt[0][1] + "\n";
	if (ppRlt[0][0].match(/ns/)) {
		ppStr += "α=.05\t" + ppRlt[1][0] + "\t" + ppRlt[1][1] + "\n";
	}
	if (ppRlt[1][0].match(/ns/)) {
		ppStr += "α=.10\t" + ppRlt[2][0] + "\t" + ppRlt[2][1] + "\n";
	}

	strArray.push("[直接確率計算１×２]\n\n");
	strArray.push("観測値１\t観測値２\n");
	strArray.push("-----------------------------------------\n");
	strArray.push(DD1 + "\t" + DD2 + "\n");
	strArray.push("(" + DS1 + ")" + "\t" + "(" + DS2 + ")" + "\n");
	strArray.push("-----------------------------------------\n\n");
	// strArray.push("両側検定  :  p=" + PP2.toFixed(4) + pp2Str + "\n");
	// strArray.push("片側検定  :  p=" + PP.toFixed(4) + ppStr + "\n\n");
	strArray.push(ppStr + "\n");

	strArray.push("効果量 : g=" + effectSizeG.toFixed(4) + "\n");
	strArray.push("ベイズファクタ : BF=" + BF.toFixed(3) + "　※事前分布はBeta(1, 1)を設定\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	if (document.getElementById("RltAdd").checked) {
		document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	} else {
		document.getElementById("RltArea").value = strArray.join("");
	}
	strArray = null;

	var RltAreaObj = document.getElementById("RltArea");
	RltAreaObj.focus();
	RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
	RltAreaObj.scrollTop = 0;

	//Ｒプログラム
	(function () {

		if (document.getElementById("Bayes").checked) {
			rcmArray.push("##### BF_正確二項検定\n");
			rcmArray.push("\n");
			rcmArray.push("# パッケージ BayesFactor が必要\n");
			rcmArray.push("\n");
		} else {
			rcmArray.push("##### １×２表(正確二項検定)\n");
			rcmArray.push("\n");
		}

		rcmArray.push("### js-STARからの入力\n");
		rcmArray.push("ds1=" + DD1 + "  # 度数１\n");
		rcmArray.push("ds2=" + DD2 + "  # 度数２\n");
		rcmArray.push("\n");
		rcmArray.push("bo1=0.50      # 母比率１\n");

		if (document.getElementById("Bayes").checked === false) {
			var shinrai = document.getElementById("shinrai").value;
			rcmArray.push("shinrai= " + shinrai + " # 信頼水準\n");
			rcmArray.push("\n");
		}

		rcmArray.push("### js-STARから入力おわり\n");
		rcmArray.push("\n");

		document.getElementById("RcmArea").value = rcmArray.join("");
		rcmArray = null;

		//ベイズへの分岐
		if (document.getElementById("Bayes").checked) {
			outputR_Bayes_1x2();
		} else {
			outputR_1x2();
		}

	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		if (document.getElementById("RltAdd").checked === false) {
			chartClear();
		}

		var parent = document.getElementById("chart");
		var childElementCount = parent.childElementCount;

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg" + childElementCount;
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < 2; i++) {
			data[i] = [];
		}
		data[0][0] = (DS1 * 100).toFixed(4);
		data[0][1] = 50;
		data[1][0] = (DS2 * 100).toFixed(4);
		data[1][1] = 50;

		var datasetKey = [];
		for (i = 0; i < 2; i++) {
			datasetKey[i] = [];
		}
		for (i = 0; i < 2; i++) {
			datasetKey[i].label = '値' + (i + 1);
			datasetKey[i].data = data[i];
			datasetKey[i].backgroundColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
			datasetKey[i].borderColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
			datasetKey[i].borderWidth = 1;
		}

		var datasetData = [];
		// var dataset = [datas[0], datas[1]];
		for (i = 0; i < 2; i++) {
			datasetData[i] = datasetKey[i];
		}
		var myChart = new Chart(ctx, {
			type: 'horizontalBar',
			data: {
				labels: ['標本比率', '母比率'],
				datasets: datasetData
			},
			options: {
				title: {
					display: true,
					text: '値１（黒）と値２（灰白）の比率',
					position: 'top',
					fontSize: 12,
					fontColor: '#000000'
				},
				scales: {
					xAxes: [{
						stacked: true,
						ticks: {
							beginAtZero: true,
							min: 0,
							max: 100
						}
					}],
					yAxes: [{
						stacked: true
					}]
				},
				legend: {
					position: 'bottom'
				}
			}
		});
	}());	//グラフ描画ここまで

	var RltAreaObj = document.getElementById("RltArea");
	RltAreaObj.focus();
	RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
	RltAreaObj.scrollTop = 0;
}
function sum() {
	var i = 1;
	var iCount = 1;
	var jCount = 2;
	var elmCount = iCount * jCount;

	var wSum = 0;

	for (i = 1; i < elmCount + 1; i++) {
		if (isNaN(parseInt(document.getElementById("cell_" + i).value)) === false) {
			wSum += parseInt(document.getElementById("cell_" + i).value);
		}
	}
	document.getElementById("cell_sum").value = wSum;
}
function saveData_1x2() {
	var i, j;

	var DD1 = parseInt(document.getElementById("cell_1").value);
	var DD2 = parseInt(document.getElementById("cell_2").value);

	var Stream = DD1 + "\t" + DD2 + "\n";
	var fineName = "1x2_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function simulation_1x2(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var result = "rnd1:2*50";
	var N = "";
	if (key_shift) {
		N = prompt("Nを入力してください");
		if (N === null) {
			result = "rnd1:2*50";
		}
		if (N !== "") {
			if (isNaN(N)) {
				N = 50;
			}
			result = "rnd1:2*" + parseInt(N, 10);
		}
	} else {
		if (document.getElementById("cell_sum").value !== "") {
			result = "rnd1:2*" + document.getElementById("cell_sum").value;
		} else {
			result = "rnd1:2*50";
		}
	}

	document.getElementById("CandPArea").value = random_number_generation(result);

	conditionalBranch();
	copipe('CandPArea', 'text');
	inputTextArea(document.getElementById('CandPArea'), 0);
	// inputBtnTextClear(this);
	sum();

	mainCalc_1x2();
}
function outputR_1x2() { //通常のR出力
	var rcmArray = [];
	var spc = "          ";

	rcmArray.push("#  main\n");
	rcmArray.push("N= ds1+ds2\n");
	rcmArray.push("bo2= 1-bo1\n");
	rcmArray.push("\n");
	rcmArray.push("# 作図\n");
	rcmArray.push("dosu= c(ds1, ds2)   # 観測度数\n");
	rcmArray.push("bohi= c(bo1, bo2)   # 母比率\n");
	rcmArray.push("zhyo= matrix(c(bohi, dosu/N ), nc=2, by=1 )\n");
	rcmArray.push("rownames(zhyo)= c(\"母比率\", \"標本比率\")\n");
	rcmArray.push("maintitle=\"値１（黒）と値２（白）の比率\"\n");
	rcmArray.push("barplot(t(zhyo), hor=1, las=1, cex.ax=1.5, main=maintitle )\n");
	rcmArray.push("\n");
	rcmArray.push("# 作表\n");
	rcmArray.push("tx1= c()\n");
	rcmArray.push("tx1= matrix(round( c(dosu,dosu/N,bohi), 4), nr=3, by=1 )\n");
	rcmArray.push("rownames(tx1)= c(\"度　数\",\"標本比率 \",\"母比率\")\n");
	rcmArray.push("colnames(tx1)= c(\"値１\",\"      値２\" )\n");
	rcmArray.push("\n");
	rcmArray.push("# 効果量\n");
	rcmArray.push("ESg= ds1/N-bo1\n");
	rcmArray.push("kx1= chisq.test( dosu )\n");
	rcmArray.push("ESw= sqrt( kx1$stat/N )\n");
	rcmArray.push("\n");
	rcmArray.push("# 両側\n");
	rcmArray.push("kr1= c()\n");
	rcmArray.push("kr1= binom.test(dosu, conf=shinrai )\n");
	rcmArray.push("\n");
	rcmArray.push("crD1= qbinom(0.025, N, bo1 )\n");
	rcmArray.push("if( pbinom(crD1, N, bo1)>0.025 ) crD1=crD1-1\n");
	rcmArray.push("crD2= qbinom(0.975, N, bo1 )\n");
	rcmArray.push("if( pbinom(crD2, N, bo1)<0.975 ) crD2=crD2+1\n");
	rcmArray.push("crD2= crD2+1\n");
	rcmArray.push("beta= sum( dbinom((crD1+1):(crD2-1), N, bo1+ESg) )\n");
	rcmArray.push("powR= 1-beta\n");
	rcmArray.push("\n");
	rcmArray.push("tr1= c()\n");
	rcmArray.push("tr1= matrix(round(c(kr1$p.v,abs(ESg),ESw,powR),4), nr=1 )\n");
	rcmArray.push("rownames(tr1)=\"両側検定\"\n");
	rcmArray.push("colnames(tr1)= c(\"   ｐ値\",\"効果量ｇ\",\"効果量ｗ\",\" 検出力\")\n");
	rcmArray.push("\n");
	rcmArray.push("tr2= c()\n");
	rcmArray.push("tr2= matrix( c(kr1$conf[c(1,2)], \n");
	rcmArray.push("    binom.test(dosu, conf=0.90)$conf[c(1,2)],\n");
	rcmArray.push("    binom.test(dosu, conf=0.80)$conf[c(1,2)]), nr=3, by=1 )\n");
	rcmArray.push("rownames(tr2)= paste( c(95,90,80),\"\", sep=\"％信頼区間\" )\n");
	rcmArray.push("colnames(tr2)= c(\" 下限値\", \" 上限値\")\n");
	rcmArray.push("\n");
	rcmArray.push("# パワー\n");
	rcmArray.push("NN= c(NA,NA)\n");
	rcmArray.push("if( powR<0.80 )\n");
	rcmArray.push("{\n");
	rcmArray.push(" for( i in N:10000 )\n");
	rcmArray.push(" {\n");
	rcmArray.push("  crD1= qbinom(0.025, i, bo1 )\n");
	rcmArray.push("  if( pbinom(crD1,i,bo1)>0.025 ) crD1=crD1-1\n");
	rcmArray.push("  crD2= qbinom(0.975, i, bo1 )\n");
	rcmArray.push("  if( pbinom(crD2,i,bo1)<0.975 ) crD2=crD2+1\n");
	rcmArray.push("  crD2= crD2+1\n");
	rcmArray.push("  beta= sum( dbinom((crD1+1):(crD2-1),i,bo1+ESg) )\n");
	rcmArray.push("  if( beta<0.20 ){ NN=c(i,1-beta,NN); break }\n");
	rcmArray.push(" }\n");
	rcmArray.push("} else {\n");
	rcmArray.push(" for( i in N:0 )\n");
	rcmArray.push(" {\n");
	rcmArray.push("  crD1= qbinom(0.025, i, bo1 )\n");
	rcmArray.push("  if( pbinom(crD1,i,bo1)>0.025 ) crD1=crD1-1\n");
	rcmArray.push("  crD2= qbinom(0.975, i, bo1 )\n");
	rcmArray.push("  if( pbinom(crD2,i,bo1)<0.975 ) crD2=crD2+1\n");
	rcmArray.push("  crD2= crD2+1\n");
	rcmArray.push("  beta= sum( dbinom((crD1+1):(crD2-1),i,bo1+ESg) )\n");
	rcmArray.push("  if( beta>0.20 ) break\n");
	rcmArray.push("  NN= c(i,1-beta,NN )\n");
	rcmArray.push(" }\n");
	rcmArray.push("}\n");
	rcmArray.push("tr3= c()\n");
	rcmArray.push("tr3= matrix(round(c(abs(ESg),0.05,NN[2],NN[1],N),4), nr=1 )\n");
	rcmArray.push("rownames(tr3)=\"\"\n");
	rcmArray.push("colnames(tr3)= c(\"効果量ｇ\",\"   α\",\"  検出力\",\"次回のＮ\",\"今回のＮ\" )\n");
	rcmArray.push("\n");
	rcmArray.push("# 片側\n");
	rcmArray.push("if( ds1>ds2 ){ kim=\"g\"; st=N; ed=0; tmp=\"（D1>D2）\" }else{ kim=\"l\"; st=0; ed=N; tmp=\"（D1<D2）\" }\n");
	rcmArray.push("kx9= binom.test(dosu, al=kim, conf=shinrai )\n");
	rcmArray.push("\n");
	rcmArray.push("crDS=NA; alph=0\n");
	rcmArray.push("for( i in st:ed )\n");
	rcmArray.push("{\n");
	rcmArray.push(" alph= alph+dbinom(i,N,bo1)\n");
	rcmArray.push(" if( alph>=0.05 ) break\n");
	rcmArray.push(" crDS= c(i, crDS)\n");
	rcmArray.push("}\n");
	rcmArray.push("crDS= crDS[1]\n");
	rcmArray.push("powK= sum(dbinom(st:crDS,N,p=bo1+ESg) )\n");
	rcmArray.push("\n");
	rcmArray.push("tK1= c()\n");
	rcmArray.push("tK1= matrix( round( c(\n");
	rcmArray.push("     kx9$p.v, abs(ESg), ESw, powK), 4), nr=1 )\n");
	rcmArray.push("rownames(tK1)= paste(\"片側検定\",tmp, sep=\"\" )\n");
	rcmArray.push("colnames(tK1)= c(\"ｐ値\",\"効果量ｇ\",\"効果量ｗ\",\" 検出力\")\n");
	rcmArray.push("\n");
	rcmArray.push("tK2= c()\n");
	rcmArray.push("tK2= matrix(kx9$conf[c(1,2)], nr=1 )\n");
	rcmArray.push("rownames(tK2)= paste(shinrai*100,\"％信頼区間\", sep=\"\" )\n");
	rcmArray.push("colnames(tK2)= c(\" 下限値\", \" 上限値\")\n");
	rcmArray.push("\n");
	rcmArray.push("\n");
	rcmArray.push("# ■結果の書き方\n");
	rcmArray.push("PV= function(x) floor(x*1000)/1000\n");
	rcmArray.push("txt= c()\n");
	rcmArray.push("txt=\"　Table(tx1)は各値の度数集計表である。\\n　Table(tx1)において正確二項検定を行った結果，\"\n");
	rcmArray.push("if( abs(ESg)==0.50 ) fuki=paste(\" (p=\",PV(pch),\", w=\",ESw,\", 両側検定)。\", sep=\"\" ) else\n");
	rcmArray.push("pch= tr1[1]\n");
	rcmArray.push("ESw= round(tr1[3], 3)\n");
	rcmArray.push("kens= round(tr1[4], 3)\n");
	rcmArray.push("\n");
	rcmArray.push("fuki= paste(\" (p=\",PV(pch),\", w=\",ESw,\", 1-β=\",kens,\", 両側検定)。\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("goku=\"い傾向があった\"\n");
	rcmArray.push("if( pch<0.10 )\n");
	rcmArray.push("{\n");
	rcmArray.push(" if( ds1>ds2 ) tmp=\"多\" else tmp=\"少な\"\n");
	rcmArray.push(" if( pch<0.05 ) goku=\"かった\"\n");
	rcmArray.push(" txt= paste(txt, \"値１の度数が値２の度数よりも有意に\",tmp,goku,fuki, sep=\"\" )\n");
	rcmArray.push("} else {\n");
	rcmArray.push(" txt= paste(txt, \"値１と値２の度数の差は有意ではなかった\",fuki, sep=\"\" )\n");
	rcmArray.push("}\n");
	rcmArray.push("\n");
	rcmArray.push("if( ESw>=0.49 ) tmp=\"大きい\" else\n");
	rcmArray.push("if( ESw>=0.29 ) tmp=\"中程度以上\" else\n");
	rcmArray.push("if( ESw>=0.26 ) tmp=\"ほぼ中程度\" else tmp=\"小さい\"\n");
	rcmArray.push("txt= paste(txt, \"効果量wは便宜的基準 (Cohen, 1992) によると\",tmp,\"と判断される。\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("goku=\"\"\n");
	rcmArray.push("if( pch<0.10 & abs(ESg)<0.50 )\n");
	rcmArray.push("{\n");
	rcmArray.push(" fuki=\"検出力（1-β）は\"\n");
	rcmArray.push(" if( kens<0.70 ){ goku=\"ただし\"; tmp=\"不十分であり，信頼性が低い\" } else\n");
	rcmArray.push(" if( kens<0.76 ) tmp=\"やや低いが0.70以上あり不十分ではない\" else\n");
	rcmArray.push(" if( kens<0.80 ) tmp=\"ほぼ十分といえる\" else tmp=\"十分である\"\n");
	rcmArray.push(" txt= paste(txt, goku,fuki,tmp,\"。\", sep=\"\" )\n");
	rcmArray.push("}\n");
	rcmArray.push("txt= paste(txt,\"\\n\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("if( shinrai==0.95 ){ gyo=1; if(pch>0.05 & pch<0.10) shinrai=0.90 }\n");
	rcmArray.push("if( shinrai==0.90 )  gyo=2\n");
	rcmArray.push("if( shinrai==0.80 )  gyo=3\n");
	rcmArray.push("ci1= round(tr2[gyo,1], 3)\n");
	rcmArray.push("ci2= round(tr2[gyo,2], 3)\n");
	rcmArray.push("goku=\"。\"\n");
	rcmArray.push("if( pch>0.10 ) goku=\"。\\n\"\n");
	rcmArray.push("txt= paste(txt, \"　F分布を用いた値１の比率の\",shinrai*100,\"％信頼区間は\",ci1,\" - \",ci2,\"と推定された\",goku, sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("if( ESg>0 ) { mds=\"下\"; c.i=ci1 } else { mds=\"上\"; c.i=ci2 }\n");
	rcmArray.push("tmp=\"\"\n");
	rcmArray.push("if( pch<0.10)\n");
	rcmArray.push("{\n");
	rcmArray.push(" diff= abs( c.i-bo1 )\n");
	rcmArray.push(" dosa= N*diff*2\n");
	rcmArray.push(" goku=\"推測される。\"\n");
	rcmArray.push(" if( dosa>=1 ) dosa=trunc(dosa) else { dosa=\"1\"; goku=\"はいえない。\" }\n");
	rcmArray.push(" txt= paste(txt, \"信頼区間の\",mds,\"限\",round(c.i,3),\"は母比率\",bo1,\"と\",round(diff,3),\"の比率差を示し，今回のN=\",N,\"のとき信頼水準\",shinrai*100,\"％で最少差が現実に度数\",dosa,\"以上の差を生じると\",goku, sep=\"\" )\n");
	rcmArray.push("} # if(pch)\n");
	rcmArray.push("txt= paste(txt, \"\\n\\n［引用文献］\\n\",\n");
	rcmArray.push("\"Cohen, J. (1992). A power primer. Psychological Bulletin, 112, 155-159.\\n\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("options(digits=4)\n");
	rcmArray.push("options(scipen=5)\n");
	rcmArray.push("##############################\n");
	rcmArray.push("#\n");
	rcmArray.push("#   １×２表：母比率同等\n");
	rcmArray.push("#   正確二項検定  片側検定\n");
	rcmArray.push("#\n");
	rcmArray.push("##############################\n");
	rcmArray.push("tx1 # 度数集計表\n");
	rcmArray.push("\n");
	rcmArray.push("tK1 # 正確二項検定\n");
	rcmArray.push("\n");
	rcmArray.push("tK2 # 値１の比率の区間推定（Ｆ分布による）\n");
	rcmArray.push("\n");
	rcmArray.push("##############################\n");
	rcmArray.push("#\n");
	rcmArray.push("#   １×２表：母比率同等\n");
	rcmArray.push("#   正確二項検定  両側検定\n");
	rcmArray.push("#\n");
	rcmArray.push("##############################\n");
	rcmArray.push("tx1 # 度数集計表\n");
	rcmArray.push("\n");
	rcmArray.push("tr1 # 正確二項検定\n");
	rcmArray.push("# 効果量ｗの評価：大=0.50, 中=0.30, 小=0.10\n");
	rcmArray.push("# 度数=0があるとき検出力(1-β)は計算不能\n");
	rcmArray.push("\n");
	rcmArray.push("tr2 # 値１の比率の区間推定（Ｆ分布による）\n");
	rcmArray.push("# 検定結果が有意傾向のとき信頼水準=0.90に設定\n");
	rcmArray.push("\n");
	rcmArray.push("tr3 # パワーアナリシス（追試用Ｎの計算）\n");
	rcmArray.push("# NAの表示は計算中断（次回 N>10000必要）\n");
	rcmArray.push("\n");
	rcmArray.push("cat(txt) # 結果の書き方\n");
	rcmArray.push("\n");
	rcmArray.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
	rcmArray.push("# write(txt, file.choose(), ap=T) # 結果のファイル保存\n");
	rcmArray.push("\n");
	rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

	document.getElementById("RcmArea").value = document.getElementById("RcmArea").value + rcmArray.join("");
	rcmArray = null;
}
function outputR_Bayes_1x2() { //ベイズ統計のR出力
	var rcmArray = [];
	var spc = "          ";

	rcmArray.push("  rscale=1/2       # medium:尺度設定\n");
	rcmArray.push("# rscale=sqrt(2)/2 # wide √2/2=0.707\n");
	rcmArray.push("# rscale=1         # ultrawide\n");
	rcmArray.push("\n");
	rcmArray.push("BFkj= 3 # BFの評価基準\n");
	rcmArray.push("\n");
	rcmArray.push("# 作図\n");
	rcmArray.push("library( BayesFactor )\n");
	rcmArray.push("N= ds1+ds2\n");
	rcmArray.push("zhyo= matrix(c(bo1,1-bo1, ds1/N,ds2/N), nc=2,by=1 )\n");
	rcmArray.push("rownames(zhyo)= c(\"母比率\", \"標本比率\")\n");
	rcmArray.push("maintitle=\"値１（黒）と値２（白）の比率\"\n");
	rcmArray.push("barplot(t(zhyo), hor=1, las=1, cex.ax=1.5, main=maintitle )\n");
	rcmArray.push("\n");
	rcmArray.push("# 作表\n");
	rcmArray.push("tx1= c()\n");
	rcmArray.push("tx1= matrix( round( c(\n");
	rcmArray.push("  ds1,ds2,ds1/N,ds2/N,bo1,1-bo1), 4), nr=3,by=1 )\n");
	rcmArray.push("rownames(tx1)= c(\"度　数\",\"標本比率 \",\"母比率\")\n");
	rcmArray.push("colnames(tx1)= c(\"値１\",\"      値２\" )\n");
	rcmArray.push("maru=3; if( bo1<0.05 | bo1>0.95 ) maru=4 # 丸め\n");
	rcmArray.push("\n");
	rcmArray.push("# BF\n");
	rcmArray.push("opt= c(1/2, sqrt(2)/2, 1)\n");
	rcmArray.push("Bxt=c(); bfs=c(); err=c()\n");
	rcmArray.push("for( i in 1:3 )\n");
	rcmArray.push("{\n");
	rcmArray.push(" kx= proportionBF(ds1,ds1+ds2,p=bo1, rscale=opt[i] )\n");
	rcmArray.push(" bfs= c(bfs, as.vector(kx) )\n");
	rcmArray.push(" err= c(err, as.numeric(extractBF(kx)[2]*100) )\n");
	rcmArray.push("}\n");
	rcmArray.push("Bxt= matrix(c(round(bfs,3),round(1/bfs,3),round(err,2)), nc=3,by=1 )\n");
	rcmArray.push("rownames(Bxt)= c(\"H1：P1≠P2\",\"H0：P1＝P2\",\" error(%)\")\n");
	rcmArray.push("colnames(Bxt)= c(\" BF_0.5\",\"BF_0.707\",\"  BF_1\" )\n");
	rcmArray.push("\n");
	rcmArray.push("Bxt2=c()\n");
	rcmArray.push("kx= proportionBF(ds1,ds1+ds2,p=bo1, rscale=rscale )\n");
	rcmArray.push("pos= summary(posterior(kx, iter=1e+4) )\n");
	rcmArray.push("Bxt2= matrix(round(c(pos$stat[2,1:2], pos$quant[2,c(3,1,5)]), maru), nr=1 )\n");
	rcmArray.push("rownames(Bxt2)=\"P1\"\n");
	rcmArray.push("colnames(Bxt2)= c(\" Mean\",\"SD\",\"Median\",\"CI:2.5%\",\"- 97.5%\")\n");
	rcmArray.push("\n");
	rcmArray.push("bfG=c()\n");
	rcmArray.push("ky= proportionBF(ds1,ds1+ds2,p=bo1,rscale=rscale, nullInterval=c(bo1, 1) )\n");
	rcmArray.push("bfG= matrix(c(round(as.vector(ky),3), round(as.numeric(extractBF(ky)[,2]*100),2)), nc=2 )\n");
	rcmArray.push("rownames(bfG)= c(\"H1:P1＞P2\",\"H1:P1＜P2\")\n");
	rcmArray.push("colnames(bfG)= c(\"     BF\",\"err%\")\n");
	rcmArray.push("\n");
	rcmArray.push("posG= c()\n");
	rcmArray.push("for( i in 1:2 )\n");
	rcmArray.push("{\n");
	rcmArray.push(" pos1= summary(posterior(ky[i],iter=1e+4) )\n");
	rcmArray.push(" posG= c(posG, pos1$stat[2,1:2],pos1$quant[2,c(3,1,5)] )\n");
	rcmArray.push("}\n");
	rcmArray.push("posG= matrix(round(posG,maru), nr=2,by=1 )\n");
	rcmArray.push("rownames(posG)= c(\"P1\",\"P2\")\n");
	rcmArray.push("colnames(posG)= colnames(Bxt2 )\n");
	rcmArray.push("\n");
	rcmArray.push("# 真値の範囲\n");
	rcmArray.push("tsBF= function(bf)\n");
	rcmArray.push("{\n");
	rcmArray.push("TXT= c()\n");
	rcmArray.push("if( bf>150) TXT=\"非常に有力\" else\n");
	rcmArray.push("if( bf> 20) TXT=\"有力\"       else\n");
	rcmArray.push("if( bf>=BFkj) TXT=\"有効\"\n");
	rcmArray.push("TXT\n");
	rcmArray.push("}\n");
	rcmArray.push("trP1= function( p1 ) # 範囲検定\n");
	rcmArray.push("{\n");
	rcmArray.push(" if( p1==0.5 ){ if( Bxt2[1,1]>bo1 ) p1=0.501 else p1=0.499 }\n");
	rcmArray.push(" if( p1>bo1 ){ int1=c(p1,  1); int0=c(bo1, p1) } else\n");
	rcmArray.push("             { int1=c( 0, p1); int0=c(p1, bo1) }\n");
	rcmArray.push(" h1= proportionBF(ds1,N,p=bo1,rscale=rscale, nullInterval=int1 )\n");
	rcmArray.push(" h0= proportionBF(ds1,N,p=bo1,rscale=rscale, nullInterval=int0 )\n");
	rcmArray.push(" h1[1]/h0[1]\n");
	rcmArray.push("} # func/trP1\n");
	rcmArray.push("\n");
	rcmArray.push("ES.P1= function( 境界=0.60 ) # オプション用\n");
	rcmArray.push("{\n");
	rcmArray.push(" bfs= trP1(境界)\n");
	rcmArray.push(" gok1=paste(\"P1＞\",境界,sep=\"\"); gok2=paste(bo1,\"＜P1≦\",境界,sep=\"\")\n");
	rcmArray.push(" if( Bxt2[1,1]<bo1 )\n");
	rcmArray.push("{\n");
	rcmArray.push(" gok1=paste(\"P1＜\",境界, sep=\"\")\n");
	rcmArray.push(" gok2=paste(境界,\"≦P1＜\",bo1, sep=\"\")\n");
	rcmArray.push("}\n");
	rcmArray.push(" bf= round(as.vector(bfs), 3 )\n");
	rcmArray.push(" if( bf>=BFkj ) tmp=\"であった\" else tmp=\"有効水準に達しなかった\"\n");
	rcmArray.push(" cat( paste(\n");
	rcmArray.push(" \"H1：\",gok1,\" (BF=\",bf,\", error=\",round(attributes(bfs)$bayesFactor[1,2]*100, 2),\"%)\\n\",\n");
	rcmArray.push(" \"H0：\",gok2,\" (BF=\",round(1/bf,3),\")\\n-----\\n\",\n");
	rcmArray.push(" \"観測値1の比率 (P1) の範囲についてベイズファクタによる検定を行った結果，「\",gok1,\n");
	rcmArray.push(" \"」と仮定したときの「\",gok2,\"」に対比したBF値は\",tsBF(bf),tmp,\" (BF=\",bf,\", error=\",\n");
	rcmArray.push(" round(attributes(bfs)$bayesFactor[1,2]*100, 2),\"%)。\\n\\n\",\n");
	rcmArray.push(" sep=\"\")  )\n");
	rcmArray.push("} # func/ES.P1\n");
	rcmArray.push("\n");
	rcmArray.push("\n");
	rcmArray.push("# ■結果の書き方\n");
	rcmArray.push("options(digits=4)\n");
	rcmArray.push("options(scipen=5)\n");
	rcmArray.push("rscale= round(rscale, 3)\n");
	rcmArray.push("H=matrix(\"\"); rownames(H)=\"\"\n");
	rcmArray.push("colnames(H)= paste(\"※事前分布：Logistic(rscale=\",rscale,\")\", sep=\"\" ) \n");
	rcmArray.push("\n");
	rcmArray.push("makeTXT= function( Tab, Tab2, alt )\n");
	rcmArray.push("{\n");
	rcmArray.push("x= Tab[1, 1]\n");
	rcmArray.push("fuki= paste(\" (BF=\",x,\", error=\",Tab[1, 2],\"%）。\", sep=\"\" )\n");
	rcmArray.push("if( x>=BFkj ) goku=\"であった\" else goku=\"有効水準に達しなかった\"\n");
	rcmArray.push("TXT= paste(\"　Table(tx1)は各値の度数集計表である。\\n　ベイズファクタ分析（有効水準=\",BFkj,\", \",alt,\"側仮説）を行った結果，BF値は\",tsBF(x),goku,fuki, sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("if( x>=BFkj )\n");
	rcmArray.push("{\n");
	rcmArray.push(" if( tx1[2,1]>bo1 ) tmp=\"大きい\" else tmp=\"小さい\"\n");
	rcmArray.push(" TXT= paste(TXT, \"したがって観測値1の比率は観測値2の比率よりも実質的に\",tmp,\"ことが示された。\", sep=\"\" )\n");
	rcmArray.push("}\n");
	rcmArray.push("TXT= paste(TXT, \"事後分布における観測値1の比率のメディアンは\",Tab2[1,3],\"であり, その95％確信区間は\",Tab2[1,4],\" - \",Tab2[1,5],\"と推定された。\\n\", sep=\"\" )\n");
	rcmArray.push("if( (1/x)>=BFkj ) TXT= paste(TXT, \"　逆に，対立仮説に比して帰無仮説が\",tsBF(1/x),\"であり (BF=\",round(1/x,3),\")，観測値1の比率は観測値2の比率と実質的な差はないことが見いだされた。\\n\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("TXT= paste(TXT, \"\\n　以上のBF値の計算にはＲパッケージBayesFactor (Morey & Rouder, 2021) を使用し，事前分布（logistic分布）の尺度設定をrscale=\",rscale,\"としたほかは各種設定はデフォルトに従った。MCMC法による推定回数は1万回とした。\\n\", sep=\"\" )\n");
	rcmArray.push("TXT\n");
	rcmArray.push("} # func/makeTXT\n");
	rcmArray.push("\n");
	rcmArray.push("txt=c(); Txt=c()\n");
	rcmArray.push("alt=\"両\" # \"≠\"\n");
	rcmArray.push("rets=2; if( rscale==0.5 ) rets=1 else if( rscale==1 ) rets=3\n");
	rcmArray.push("Tab= matrix(Bxt[c(1,3),rets], nr=1 )\n");
	rcmArray.push("txt= makeTXT(Tab, Bxt2, alt)\n");
	rcmArray.push("\n");
	rcmArray.push("alt=\"片\" # alt=\"＞\"; alt=\"＜\"\n");
	rcmArray.push("gyo=1\n");
	rcmArray.push("if( bfG[1,1]<bfG[2,1] ) gyo=2\n");
	rcmArray.push("Tab =matrix(bfG[gyo,], nr=1 )\n");
	rcmArray.push("Tab2=matrix(posG[gyo,],nr=1 )\n");
	rcmArray.push("Txt= makeTXT(Tab, Tab2, alt )\n");
	rcmArray.push("\n");
	rcmArray.push("\n");
	rcmArray.push("################################\n");
	rcmArray.push("#  ■ベイズファクタ分析\n");
	rcmArray.push("#  　１×２表：片側検定\n");
	rcmArray.push("#\n");
	rcmArray.push("#  帰無仮説(H0)：P1＝P2\n");
	rcmArray.push("#  対立仮説(H1)：P1＞P2, P1＜P2\n");
	rcmArray.push("H###############################\n");
	rcmArray.push("tx1 # 度数集計表\n");
	rcmArray.push("\n");
	rcmArray.push("bfG # ベイズファクタ分析_片側仮説\n");
	rcmArray.push("# BF値の便宜的評価:有効>3, 有力>20\n");
	rcmArray.push("\n");
	rcmArray.push("posG # P1,P2の95％確信区間\n");
	rcmArray.push("\n");
	rcmArray.push("cat(Txt) # 結果の書き方(片側仮説)\n");
	rcmArray.push("\n");
	rcmArray.push("\n");
	rcmArray.push("############################\n");
	rcmArray.push("#  ■ベイズファクタ分析\n");
	rcmArray.push("#  　１×２表：両側検定\n");
	rcmArray.push("#\n");
	rcmArray.push("#  　帰無仮説(H0)：P1＝P2\n");
	rcmArray.push("#  　対立仮説(H1)：P1≠P2\n");
	rcmArray.push("H###########################\n");
	rcmArray.push("tx1 # 度数集計表\n");
	rcmArray.push("\n");
	rcmArray.push("Bxt # ベイズファクタ分析_両側仮説\n");
	rcmArray.push("# BF値の便宜的評価：有効>3, 有力>20\n");
	rcmArray.push("\n");
	rcmArray.push("Bxt2 # P1の事後推定：95％確信区間\n");
	rcmArray.push("\n");
	rcmArray.push("cat(txt) # 結果の書き方(両側仮説)\n");
	rcmArray.push("\n");
	rcmArray.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
	rcmArray.push("# ES.P1( 境界=0.60 ) # 観測値1の比率(P1)の範囲検定\n");
	rcmArray.push("# write(Txt, file.choose(), ap=T) # 結果のファイル保存（片側）\n");
	rcmArray.push("# write(txt, file.choose(), ap=T) # 結果のファイル保存（両側）\n");
	rcmArray.push("\n");
	rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

	document.getElementById("RcmArea").value = document.getElementById("RcmArea").value + rcmArray.join("");
	rcmArray = null;
}