/**
 * 多変量解析
 * 信頼性係数αの計算
 *
 *
 *
 */
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();

    changeReverseSetting();

    // デフォルトのタブを選択
    ChangeTab(1, 5);
};
function mainCalc_cronbach() {
    var i = 0;
    var j = 0;
    var k = 0;
    var ik = 0;

    var NN = 0;
    var KK = 0;

    var DData = dataremake5("DataArea");
    var dd = [];
    dd = DData.split(" ");

    var strArray = [];
    var bar = "---------------------------------------------------------------\n";

    NN = countRowCol("DataArea")[0]; // 行数を取得
    KK = countRowCol("DataArea")[1]; // 列数を取得

    if (KK == -1) { //列数エラー -1
        alert("データが行列形式ではありません");
    } else if (NN != 0) { //行数が 0 でない場合
        var xx = new Array(NN);
        for (i = 0; i < NN; i++) {
            xx[i] = new Array(KK);
        }

        var ddCount = 0;
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                xx[i][j] = parseFloat(dd[ddCount]);
                ddCount++;
            }
        }

        //逆転項目処理
        var wMin = parseInt(document.getElementById("x_min").value, 10);
        var wMax = parseInt(document.getElementById("x_max").value, 10);
        var reverseItem = [];
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                reverseItem[j] = "　";
                if (document.getElementById("x" + (j + 1)).checked) {
                    xx[i][j] = (wMax + wMin) - xx[i][j];
                    reverseItem[j] = "逆";
                }
            }
        }

        var N = []; //各項目の回答数
        var M = []; //平均
        var V = []; //分散
        var VS = []; //不偏分散
        var SD = []; //標準偏差
        var Vsum = 0; //各項目の分散の合計
        var skewness = []; //歪度
        var kurtosis = []; //尖度

        var S = 0;
        var SS = 0;
        var SSS = 0;
        var SSSS = 0;
        for (j = 0; j < KK; j++) {
            //各項目の平均
            S = 0;
            for (i = 0; i < NN; i++) {
                if (!isNaN(xx[i][j])) {
                    S = S + xx[i][j];
                }
            }
            M[j] = S / NN;

            //各項目の分散
            //各項目の標準偏差
            SS = 0;
            for (i = 0; i < NN; i++) {
                if (!isNaN(xx[i][j])) {
                    SS = SS + Math.pow(M[j] - xx[i][j], 2);
                }
            }
            V[j] = SS / NN;
            VS[j] = SS / (NN - 1);
            SD[j] = Math.sqrt(V[j]);
            // SD[j] = Math.sqrt(VS[j]);
            if (document.getElementById("item" + (j + 1)).checked) {
                Vsum = Vsum + V[j];
            }

            //歪度
            SSS = 0;
            for (i = 0; i < NN; i++) {
                if (!isNaN(xx[i][j])) {
                    SSS = SSS + Math.pow((xx[i][j] - M[j]) / SD[j], 3);
                }
            }
            // skewness[j] = N[j] / (N[j] - 1) / (N[j] - 2) * SSS;
            skewness[j] = NN / (NN - 1) / (NN - 2) * SSS;

            //尖度
            SSSS = 0;
            for (i = 0; i < NN; i++) {
                if (!isNaN(xx[i][j])) {
                    SSSS = SSSS + Math.pow((xx[i][j] - M[j]), 4) / Math.pow(SD[j], 4);
                }
            }
            // kurtosis[j] = N[j] * (N[j] + 1) / ((N[j] - 1) * (N[j] - 2) * (N[j] - 3)) * SSSS - 3 * Math.pow(N[j] - 1, 2) / ((N[j] - 2) * (N[j] - 3));
            kurtosis[j] = NN * (NN + 1) / ((NN - 1) * (NN - 2) * (NN - 3)) * SSSS - 3 * Math.pow(NN - 1, 2) / ((NN - 2) * (NN - 3));

        }

        // 項目全体相関（ITC）
        var AllSum = []; //各参加者別の全項目の合計
        for (i = 0; i < NN; i++) {
            S = 0;
            for (j = 0; j < KK; j++) {
                if (document.getElementById("item" + (j + 1)).checked) {
                    S = S + xx[i][j];
                }
            }
            AllSum[i] = S;
        }

        var AllMean = 0; //全項目合計値の平均
        S = 0;
        for (i = 0; i < NN; i++) {
            S = S + AllSum[i];
        }
        AllMean = S / NN;

        var AllV = 0; //全項目合計値の分散
        var AllVS = 0; //全項目合計値の不偏分散
        var AllSD = 0; //全項目合計値の標準偏差
        SS = 0;
        for (i = 0; i < NN; i++) {
            SS = SS + Math.pow(AllMean - AllSum[i], 2);
        }
        AllV = SS / NN;
        AllVS = SS / (NN - 1);
        AllSD = Math.sqrt(AllV);

        //合計得点と各項目の相関を求める
        var tmpSum = new Array(NN);
        for (i = 0; i < NN; i++) {
            tmpSum[i] = new Array(KK);
        }
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                tmpSum[i][j] = AllSum[i];
            }
        }

        var tmpM = [];
        for (j = 0; j < KK; j++) {
            S = 0;
            for (i = 0; i < NN; i++) {
                S = S + tmpSum[i][j];
            }
            tmpM[j] = S / NN;
        }
        var tmpV = [];
        var tmpVS = [];
        var tmpSD = [];
        for (j = 0; j < KK; j++) {
            SS = 0;
            for (i = 0; i < NN; i++) {
                SS = SS + Math.pow(tmpM[j] - tmpSum[i][j], 2);
            }
            tmpV[j] = SS / NN;
            // tmpVS[j] = SS / (NN - 1);
            tmpSD[j] = Math.sqrt(tmpV[j]);
        }

        var tmpR = [];
        S = 0;
        for (j = 0; j < KK; j++) {
            S = 0;
            for (i = 0; i < NN; i++) {
                S += (xx[i][j] - M[j]) * (tmpSum[i][j] - tmpM[j]);
            }
            tmpR[j] = S / NN / SD[j] / tmpSD[j];
        }

        // 合計得点と各項目の相関が負だったら，項目値を逆転する
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                // reverseItem[j] = "　";
                if (tmpR[j] < 0) {
                    xx[i][j] = (wMax + wMin) - xx[i][j];
                    reverseItem[j] = "逆";
                }
            }
        }

        //再計算
        Vsum = 0; //各項目の分散の合計
        S = 0;
        SS = 0;
        SSS = 0;
        SSSS = 0;
        for (j = 0; j < KK; j++) {
            //各項目の平均
            S = 0;
            for (i = 0; i < NN; i++) {
                if (!isNaN(xx[i][j])) {
                    S = S + xx[i][j];
                }
            }
            M[j] = S / NN;

            //各項目の分散
            //各項目の標準偏差
            SS = 0;
            for (i = 0; i < NN; i++) {
                if (!isNaN(xx[i][j])) {
                    SS = SS + Math.pow(M[j] - xx[i][j], 2);
                }
            }
            V[j] = SS / NN;
            VS[j] = SS / (NN - 1);
            SD[j] = Math.sqrt(V[j]);
            // SD[j] = Math.sqrt(VS[j]);
            if (document.getElementById("item" + (j + 1)).checked) {
                Vsum = Vsum + V[j];
            }
        }

        AllSum = []; //各参加者別の全項目の合計
        for (i = 0; i < NN; i++) {
            S = 0;
            for (j = 0; j < KK; j++) {
                if (document.getElementById("item" + (j + 1)).checked) {
                    S = S + xx[i][j];
                }
            }
            AllSum[i] = S;
        }

        AllMean = 0; //全項目合計値の平均
        S = 0;
        for (i = 0; i < NN; i++) {
            S = S + AllSum[i];
        }
        AllMean = S / NN;

        AllV = 0; //全項目合計値の分散
        AllVS = 0; //全項目合計値の不偏分散
        AllSD = 0; //全項目合計値の標準偏差
        SS = 0;
        for (i = 0; i < NN; i++) {
            SS = SS + Math.pow(AllMean - AllSum[i], 2);
        }
        AllV = SS / NN;
        AllVS = SS / (NN - 1);
        AllSD = Math.sqrt(AllV);
        // AllSD = Math.sqrt(AllVS);

        var delSum = new Array(NN); //各参加者別の１項目を削除した項目の合計
        for (i = 0; i < NN; i++) {
            delSum[i] = new Array(KK);
        }
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                delSum[i][j] = AllSum[i] - xx[i][j];
            }
        }

        var delM = [];
        for (j = 0; j < KK; j++) {
            S = 0;
            for (i = 0; i < NN; i++) {
                S = S + delSum[i][j];
            }
            delM[j] = S / NN;
        }
        var delV = [];
        // var delVS = [];
        var delSD = [];
        for (j = 0; j < KK; j++) {
            SS = 0;
            for (i = 0; i < NN; i++) {
                SS = SS + Math.pow(delM[j] - delSum[i][j], 2);
            }
            delV[j] = SS / NN;
            // delVS[j] = SS / (NN - 1);
            delSD[j] = Math.sqrt(delV[j]);
            // delSD[j] = Math.sqrt(delVS[j]);
        }

        var R = [];
        S = 0;
        for (j = 0; j < KK; j++) {
            S = 0;
            for (i = 0; i < NN; i++) {
                S += (xx[i][j] - M[j]) * (delSum[i][j] - delM[j]);
            }
            R[j] = S / NN / SD[j] / delSD[j];
        }

        var checkNum = 0;
        for (j = 0; j < KK; j++) {
            if (document.getElementById("item" + (j + 1)).checked) {
                checkNum++;
            }
        }

        var Kcount = checkNum;
        var alpha = Kcount / (Kcount - 1) * (1 - Vsum / AllVS);

        //項目削除後のα係数の計算
        var tmpData = ""; //逆転処理後のデータを作成
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                tmpData += xx[i][j] + " ";
            }
            tmpData += "\n";
        }
        var delAlpha = [];
        delAlpha = alphaCalc(tmpData);

        // 結果の出力
        strArray.push("[信頼性係数]\n");
        strArray.push("\n");
        strArray.push("Cronbach's α = " + alpha.toFixed(3) + "\n\n");
        strArray.push(bar);
        // strArray.push("\tN\t平均\t分散\tI-T相関\t削除時α\n");
        strArray.push("\tN\tMean\tS.D\t歪度\t尖度\tI-T相関\t削除時α\n");
        strArray.push(bar);
        for (j = 0; j < KK; j++) {
            if (document.getElementById("item" + (j + 1)).checked) {
                strArray.push("x" + (j + 1) + "：\t");
                strArray.push(NN + "\t" + M[j].toFixed(2) + "\t" + SD[j].toFixed(2) + "\t" + skewness[j].toFixed(2) + "\t" + kurtosis[j].toFixed(2) + "\t" + R[j].toFixed(3) + "\t" + delAlpha[j].toFixed(3) + "\t" + reverseItem[j]);
                strArray.push("\n");
            }
        }
        strArray.push(bar);
        // strArray.push("合計値\t" + AllMean.toFixed(2) + "\t" + AllVS.toFixed(2) + "\n");
        strArray.push("合計値\t\t" + AllMean.toFixed(2) + "\t" + AllSD.toFixed(2) + "\n");

        strArray.push("\n\n＜削除した項目＞\n");
        if (Kcount === KK) {
            strArray.push("なし\n");
        } else {
            strArray.push("\t平均\t分散\n");
            strArray.push(bar);
            for (j = 0; j < KK; j++) {
                if (document.getElementById("item" + (j + 1)).checked === false) {
                    strArray.push("x" + (j + 1) + "：\t");
                    strArray.push(M[j].toFixed(2) + "\t" + VS[j].toFixed(2));
                    strArray.push("\n");
                }
            }
        }
        strArray.push("\n※SDは標本標準偏差。\n");
        strArray.push("\n");
        // strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

        document.getElementById("RltArea").value = strArray.join("");
    }
}
function changeItemTable() {
    var i, j, k;
    var htmArray = [];
    var Str = document.getElementById("DataArea").value;
    var wStr = "";

    wStr = Str.replace(/,/g, " ");
    wStr = wStr.replace(/\t/g, " ");
    wStr = wStr.replace(/\r\n/g, "\n");
    wStr = wStr + "\n";

    var count = 0;
    for (i = 0; i < wStr.length; i++) {
        if (wStr.charAt(i) == "\n") break;
        if (wStr.charAt(i) == " ") {
            count++;
        }
        if (wStr.charAt(i) == " " && wStr.charAt(i + 1) == "\n") {
            count = count - 1;
        }
    }

    if (Str != "") {
        LA = count + 1;
    } else {
        LA = 0;
    }

    var trCount = parseInt(LA / 10) + 1;
    if (LA % 10 == 0) trCount = trCount - 1;
    if (trCount == 0) trCount = 1;

    var LACount = 0;
    htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
    for (j = 0; j < trCount; j++) {
        htmArray.push("<tr>");
        for (i = 0; i < 10; i++) {
            htmArray.push("<td class=\"hyou_midashi_NF_title\">");
            if (LACount < LA) {
                htmArray.push("<input type=\"checkbox\" id=\"item" + (LACount + 1) + "\" name=\"item" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\" onclick=\"rv_keyClick(" + 1 + ",event," + (LACount + 1) + ");\"><label for=\"item" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
            } else {
                htmArray.push("　");
            }
            htmArray.push("</td>");
            LACount++;
        }
        htmArray.push("</tr>");
    }
    htmArray.push("</table>");

    document.getElementById("Item_table").innerHTML = htmArray.join("");
    htmArray = null;
}
function changeReverseTable() {
    var i, j, k;
    var htmArray = [];
    var Str = document.getElementById("DataArea").value;
    var wStr = "";

    wStr = Str.replace(/,/g, " ");
    wStr = wStr.replace(/\t/g, " ");
    wStr = wStr.replace(/\r\n/g, "\n");
    wStr = wStr + "\n";

    var count = 0;
    for (i = 0; i < wStr.length; i++) {
        if (wStr.charAt(i) == "\n") break;
        if (wStr.charAt(i) == " ") {
            count++;
        }
        if (wStr.charAt(i) == " " && wStr.charAt(i + 1) == "\n") {
            count = count - 1;
        }
    }

    if (Str != "") {
        LA = count + 1;
    } else {
        LA = 0;
    }

    var trCount = parseInt(LA / 10) + 1;
    if (LA % 10 == 0) trCount = trCount - 1;
    if (trCount == 0) trCount = 1;

    var LACount = 0;
    htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
    for (j = 0; j < trCount; j++) {
        htmArray.push("<tr>");
        for (i = 0; i < 10; i++) {
            htmArray.push("<td class=\"hyou_midashi_NF_title\">");
            if (LACount < LA) {
                htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" onclick=\"rv_keyClick(" + 2 + ",event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
            } else {
                htmArray.push("　");
            }
            htmArray.push("</td>");
            LACount++;
        }
        htmArray.push("</tr>");
    }
    htmArray.push("</table>");

    document.getElementById("Reverse_table").innerHTML = htmArray.join("");
    htmArray = null;
}
function changeReverseSetting() {
    var htmArray = [];

    htmArray.push("<div class=\"tateyoko\">");

    var thisBrowser = getBrowser();
    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("尺度の下限値：<input type=\"number\" class=\"text9\" id=\"x_min\" size=\"10\" maxlength=\"10\" min=\"0\"  max=\"100\" value=\"1\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\">");
        htmArray.push("　尺度の上限値：<input type=\"number\" class=\"text9\" id=\"x_max\" size=\"10\" maxlength=\"10\" min=\"1\"  max=\"100\" value=\"5\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\">");
    } else {
        htmArray.push("最小値：<select name=\"tate\" id=\"x_min\" class=\"tySelect\" size=\"1\" onchange=\"checkMinMaxValue();\">");
        htmArray.push("<option value=\"0\">1</option>");
        htmArray.push("<option value=\"1\" selected>1</option>");
        htmArray.push("<option value=\"2\">2</option>");
        htmArray.push("<option value=\"3\">3</option>");
        htmArray.push("<option value=\"4\">4</option>");
        htmArray.push("<option value=\"5\">5</option>");
        htmArray.push("<option value=\"6\">6</option>");
        htmArray.push("<option value=\"7\">7</option>");
        htmArray.push("<option value=\"8\">8</option>");
        htmArray.push("<option value=\"9\">9</option>");
        htmArray.push("<option value=\"10\">10</option>");
        htmArray.push("<option value=\"11\">11</option>");
        htmArray.push("<option value=\"12\">12</option>");
        htmArray.push("<option value=\"13\">13</option>");
        htmArray.push("<option value=\"14\">14</option>");
        htmArray.push("<option value=\"15\">15</option>");
        htmArray.push("<option value=\"16\">16</option>");
        htmArray.push("<option value=\"17\">17</option>");
        htmArray.push("<option value=\"18\">18</option>");
        htmArray.push("<option value=\"19\">19</option>");
        htmArray.push("</select>");
        htmArray.push("　最大値：<select name=\"yoko\" id=\"x_max\" class=\"tySelect\" size=\"1\" onchange=\"checkMinMaxValue();\">");
        htmArray.push("<option value=\"1\">1</option>");
        htmArray.push("<option value=\"2\">2</option>");
        htmArray.push("<option value=\"3\">3</option>");
        htmArray.push("<option value=\"4\">4</option>");
        htmArray.push("<option value=\"5\" selected>5</option>");
        htmArray.push("<option value=\"6\">6</option>");
        htmArray.push("<option value=\"7\">7</option>");
        htmArray.push("<option value=\"8\">8</option>");
        htmArray.push("<option value=\"9\">9</option>");
        htmArray.push("<option value=\"10\">10</option>");
        htmArray.push("<option value=\"11\">11</option>");
        htmArray.push("<option value=\"12\">12</option>");
        htmArray.push("<option value=\"13\">13</option>");
        htmArray.push("<option value=\"14\">14</option>");
        htmArray.push("<option value=\"15\">15</option>");
        htmArray.push("<option value=\"16\">16</option>");
        htmArray.push("<option value=\"17\">17</option>");
        htmArray.push("<option value=\"18\">18</option>");
        htmArray.push("<option value=\"19\">19</option>");
        htmArray.push("<option value=\"20\">20</option>");
        htmArray.push("</select>");
    }

    htmArray.push("</div>");

    document.getElementById("reverse_setting").innerHTML = htmArray.join("");
    htmArray = null;

}
function subCalc_reverse() {
    var i = 0;
    var result = "";

    var wMin = parseInt(document.getElementById("x_min").value, 10);
    var wMax = parseInt(document.getElementById("x_max").value, 10);

    var NN = countRowCol("DataArea")[0]; // 行数を取得
    var KK = countRowCol("DataArea")[1]; // 列数を取得

    var xx = new Array(NN);
    for (i = 0; i < NN; i++) {
        xx[i] = new Array(KK);
    }

    var DData = dataremake5("DataArea");
    DData = crDel(DData);
    var dd = [];
    dd = DData.split(" ");

    var ddCount = 0;
    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            xx[i][j] = parseFloat(dd[ddCount]);
            ddCount++;
        }
    }

    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            if (document.getElementById("x" + (j + 1)).checked) {
                xx[i][j] = (wMax + wMin) - xx[i][j];
            }
        }
    }

    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            result += xx[i][j] + " ";
        }
        result += "\n";
    }

    document.getElementById("DataArea").value = result;
}
function clearNumberconvTable() {
    document.getElementById("Numberconv_table").innerHTML = "";
}
/**
 * [rv_keyClick shiftキーを押しながらチェックボックスをクリックすると全てのチェックを反転する]
 * @param  {event} event [Firefox IE用]
 * @param  {int} num   [クリックしたチェックボックスidの番号]
 */
function rv_keyClick(id, event, num) {
    //イベント処理
    var key_event = event || window.event; //Firefox IE用
    // var key_ctrl = (key_event.ctrlKey);
    var key_shift = (key_event.shiftKey);

    var _id = id;
    //キーに対応した処理
    if (key_shift) {
        var KK = countRowCol("DataArea")[1]; // 列数を取得

        for (var k = 0; k < KK; k++) {
            if (_id == 1) {
                document.getElementById("item" + (k + 1)).checked = !document.getElementById("item" + (k + 1)).checked;
            } else {
                document.getElementById("x" + (k + 1)).checked = !document.getElementById("x" + (k + 1)).checked;
            }
        }
        if (_id == 1) {
            document.getElementById("item" + num).checked = !document.getElementById("item" + num).checked;
        } else {
            document.getElementById("x" + num).checked = !document.getElementById("x" + num).checked;
        }
    }
}
function LoadResult() {
    var DData = document.getElementById("RltArea1").value;
    var rltData = [];
    rltData = DData.split("\n");

    var str = "";

    for (var i = 0; i < rltData.length; i++) {
        crDel(rltData[i]);
        if (rltData[i].substr(0, 1) !== "#") {
            if (rltData[i] !== "") {
                str += rltData[i] + "\n";
            }
        }
    }
    document.getElementById("DataArea").value = str;
}
function alphaCalc(data) {
    var i = 0;
    var j = 0;
    var k = 0;

    var NN = 0;
    var KK = 0;

    var DData = data;
    var dd = [];
    dd = DData.split(" ");

    NN = countRowCol("DataArea")[0]; // 行数を取得
    KK = countRowCol("DataArea")[1]; // 列数を取得

    var xx = new Array(NN);
    for (i = 0; i < NN; i++) {
        xx[i] = new Array(KK);
    }

    var ddCount = 0;
    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            xx[i][j] = parseFloat(dd[ddCount]);
            ddCount++;
        }
    }

    var checkNum = 0;
    for (j = 0; j < KK; j++) {
        if (document.getElementById("item" + (j + 1)).checked) {
            checkNum++;
        }
    }
    var Kcount = checkNum - 1;

    var N = []; //各項目の回答数
    var M = []; //平均
    var V = []; //分散
    var VS = []; //不偏分散
    var SD = []; //標準偏差
    var Vsum = 0; //各項目の分散の合計
    var AllSum = []; //各参加者別の全項目の合計
    var AllMean = 0; //全項目合計値の平均
    var AllV = 0; //全項目合計値の分散
    var AllVS = 0; //全項目合計値の不偏分散
    var AllSD = 0; //全項目合計値の標準偏差
    var alpha = [];

    var S = 0;
    var SS = 0;

    for (j = 0; j < KK; j++) {
        //各項目の平均
        S = 0;
        for (i = 0; i < NN; i++) {
            if (!isNaN(xx[i][j])) {
                S = S + xx[i][j];
            }
        }
        M[j] = S / NN;

        //各項目の分散
        //各項目の標準偏差
        SS = 0;
        for (i = 0; i < NN; i++) {
            if (!isNaN(xx[i][j])) {
                SS = SS + Math.pow(M[j] - xx[i][j], 2);
            }
        }
        V[j] = SS / NN;
        VS[j] = SS / (NN - 1);
        SD[j] = Math.sqrt(V[j]);
        // if (document.getElementById("x" + (j + 1)).checked) {
        //     Vsum = Vsum + VS[j];
        // }
    }

    // 項目を１つずつ削除するループ
    for (k = 0; k < KK; k++) {
        Vsum = 0;
        for (j = 0; j < KK; j++) {
            if (document.getElementById("item" + (j + 1)).checked) {
                if (j !== k) {
                    Vsum = Vsum + V[j];
                }
            }
        }
        // console.log(Vsum);

        for (i = 0; i < NN; i++) {
            S = 0;
            for (j = 0; j < KK; j++) {
                if (document.getElementById("item" + (j + 1)).checked) {
                    if (j !== k) {
                        S = S + xx[i][j];
                    }
                }
            }
            AllSum[i] = S;
        }
        // console.log(AllSum);

        S = 0;
        for (i = 0; i < NN; i++) {
            S = S + AllSum[i];
        }
        AllMean = S / NN;

        SS = 0;
        for (i = 0; i < NN; i++) {
            SS = SS + Math.pow(AllMean - AllSum[i], 2);
        }
        AllV = SS / NN;
        AllVS = SS / (NN - 1);
        AllSD = Math.sqrt(AllV);

        alpha[k] = Kcount / (Kcount - 1) * (1 - Vsum / AllVS);

    } // 項目を１つずつ削除するループ

    return alpha;
}

function alphaCalc0() {
    var i = 0;
    var j = 0;
    var k = 0;

    var NN = 0;
    var KK = 0;

    var DData = dataremake5("DataArea");
    var dd = [];
    dd = DData.split(" ");

    NN = countRowCol("DataArea")[0]; // 行数を取得
    KK = countRowCol("DataArea")[1]; // 列数を取得

    var xx = new Array(NN);
    for (i = 0; i < NN; i++) {
        xx[i] = new Array(KK);
    }

    var ddCount = 0;
    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            xx[i][j] = parseFloat(dd[ddCount]);
            ddCount++;
        }
    }

    var checkNum = 0;
    for (j = 0; j < KK; j++) {
        if (document.getElementById("item" + (j + 1)).checked) {
            checkNum++;
        }
    }
    var Kcount = checkNum - 1;

    var N = []; //各項目の回答数
    var M = []; //平均
    var V = []; //分散
    var VS = []; //不偏分散
    var SD = []; //標準偏差
    var Vsum = 0; //各項目の分散の合計
    var AllSum = []; //各参加者別の全項目の合計
    var AllMean = 0; //全項目合計値の平均
    var AllV = 0; //全項目合計値の分散
    var AllVS = 0; //全項目合計値の不偏分散
    var AllSD = 0; //全項目合計値の標準偏差
    var alpha = [];

    var S = 0;
    var SS = 0;

    for (j = 0; j < KK; j++) {
        //各項目の平均
        S = 0;
        for (i = 0; i < NN; i++) {
            if (!isNaN(xx[i][j])) {
                S = S + xx[i][j];
            }
        }
        M[j] = S / NN;

        //各項目の分散
        //各項目の標準偏差
        SS = 0;
        for (i = 0; i < NN; i++) {
            if (!isNaN(xx[i][j])) {
                SS = SS + Math.pow(M[j] - xx[i][j], 2);
            }
        }
        V[j] = SS / NN;
        VS[j] = SS / (NN - 1);
        SD[j] = Math.sqrt(V[j]);
        // if (document.getElementById("x" + (j + 1)).checked) {
        //     Vsum = Vsum + VS[j];
        // }
    }

    // 項目を１つずつ削除するループ
    for (k = 0; k < KK; k++) {
        Vsum = 0;
        for (j = 0; j < KK; j++) {
            if (document.getElementById("item" + (j + 1)).checked) {
                if (j !== k) {
                    Vsum = Vsum + VS[j];
                }
            }
        }
        // console.log(Vsum);

        for (i = 0; i < NN; i++) {
            S = 0;
            for (j = 0; j < KK; j++) {
                if (document.getElementById("item" + (j + 1)).checked) {
                    if (j !== k) {
                        S = S + xx[i][j];
                    }
                }
            }
            AllSum[i] = S;
        }
        // console.log(AllSum);

        S = 0;
        for (i = 0; i < NN; i++) {
            S = S + AllSum[i];
        }
        AllMean = S / NN;

        SS = 0;
        for (i = 0; i < NN; i++) {
            SS = SS + Math.pow(AllMean - AllSum[i], 2);
        }
        AllV = SS / NN;
        AllVS = SS / (NN - 1);
        AllSD = Math.sqrt(AllV);

        alpha[k] = Kcount / (Kcount - 1) * (1 - Vsum / AllVS);

    } // 項目を１つずつ削除するループ

    return alpha;
}
function subCalc_corr() {
    var i = 0;
    var j = 0;
    var k = 0;

    var NN = countRowCol("DataArea")[0]; // 行数を取得
    var KK = countRowCol("DataArea")[1]; // 列数を取得

    var strArray = [];
    bar = "--------------------------------------\n";
    var diaArray = [];
    var rcmArray = [];
    var rcmArray1 = [];
    var rcmArray2 = [];

    var DData = dataremake5("DataArea");
    DData = crDel(DData);
    var dd = [];
    dd = DData.split(" ");

    var xx = new Array(NN);
    for (i = 0; i < NN; i++) {
        xx[i] = new Array(KK);
    }

    var ddCount = 0;
    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            xx[i][j] = parseFloat(dd[ddCount]);
            ddCount++;
        }
    }

    var M = [];
    var SD = [];
    var MA = [];
    var MI = [];

    //基本統計量
    strArray.push("[相関係数の計算と検定]\n\n");
    strArray.push(" == Means & SDs(SDは標本標準偏差) ==\n\n");
    strArray.push("  N= " + NN + "\n");
    strArray.push(bar);
    strArray.push("Var.\t\tMean\t\tS.D.\t\tMin.\t\tMax.\n");
    strArray.push(bar);

    var S = 0;
    var SS = 0;
    for (j = 0; j < KK; j++) {
        S = 0;
        SS = 0;
        MA[j] = xx[0][j];
        MI[j] = xx[0][j];

        for (i = 0; i < NN; i++) {
            S += xx[i][j];
            SS += Math.pow(xx[i][j], 2);

            if (MA[j] < xx[i][j]) MA[j] = xx[i][j];
            if (MI[j] > xx[i][j]) MI[j] = xx[i][j];
        }

        M[j] = S / NN;
        SD[j] = Math.sqrt(SS / NN - Math.pow(M[j], 2));

        strArray.push((j + 1) + "\t" + using(M[j], 4, 3) + "\t" + using(SD[j], 4, 3) + "\t" + using(MI[j], 4, 3) + "\t" + using(MA[j], 4, 3) + "\n");
    }
    strArray.push(bar);

    strArray.push("\n - Item Selection -\n");
    strArray.push(bar);
    strArray.push("Var.\tMean+SD\t\tMean-SD\n");
    strArray.push(bar);
    for (j = 0; j < KK; j++) {
        strArray.push((j + 1) + "\t" + using(M[j] + SD[j], 4, 3) + "\t" + using(M[j] - SD[j], 4, 3) + "\n");
    }
    strArray.push(bar);

    var R = new Array(KK);
    for (j = 0; j < KK; j++) {
        R[j] = new Array(KK);
    }

    var FF = new Array(KK);
    for (j = 0; j < KK; j++) {
        FF[j] = new Array(KK);
    }

    var F$ = new Array(KK);
    for (j = 0; j < KK; j++) {
        F$[j] = new Array(KK);
    }

    var lineWidth = new Array(KK);
    for (j = 0; j < KK; j++) {
        lineWidth[j] = new Array(KK);
    }

    var corrStr = new Array(KK);
    for (j = 0; j < KK; j++) {
        corrStr[j] = new Array(KK);
    }

    var FF1, FF2, FF3;

    S = 0;
    for (j = 0; j < KK - 1; j++) {
        for (jj = j + 1; jj < KK; jj++) {
            S = 0;
            for (i = 0; i < NN; i++) {
                S += (xx[i][j] - M[j]) * (xx[i][jj] - M[jj]);
            }
            R[j][jj] = S / NN / SD[j] / SD[jj];
            if (R[j][jj] > 0.9999) {
                FF[j][jj] = 999.99;
            } else {
                if (Math.pow(R[j][jj], 2) == 1) {
                    FF[j][jj] = 0;
                } else {
                    FF[j][jj] = Math.pow(R[j][jj], 2) / (1 - Math.pow(R[j][jj], 2)) * (NN - 2);
                }
            }

            FF3 = f_tables(2, NN); //１％水準
            FF2 = f_tables(1, NN); //５％水準
            FF1 = f_tables(0, NN); //１０％水準

            if (NN > 2) {
                if (FF[j][jj] > FF3) { //１％水準
                    F$[j][jj] = "**";
                    if (Math.abs(R[j][jj]) >= 0.9) {
                        lineWidth[j][jj] = 8;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には非常強い関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.7) {
                        lineWidth[j][jj] = 6;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には強い関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.4) {
                        lineWidth[j][jj] = 4;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には中程度の関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.3) {
                        lineWidth[j][jj] = 2;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には弱い関連があります。\n";
                    } else {
                        lineWidth[j][jj] = 1;
                        corrStr[j][jj] = "";
                    }
                } else if (FF[j][jj] > FF2) { //５％水準
                    F$[j][jj] = " *";
                    if (Math.abs(R[j][jj]) >= 0.9) {
                        lineWidth[j][jj] = 8;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には非常強い関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.7) {
                        lineWidth[j][jj] = 6;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には強い関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.4) {
                        lineWidth[j][jj] = 4;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には中程度の関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.3) {
                        lineWidth[j][jj] = 2;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には弱い関連があります。\n";
                    } else {
                        lineWidth[j][jj] = 1;
                        corrStr[j][jj] = "";
                    }
                } else if (FF[j][jj] > FF1) { //１０％水準
                    F$[j][jj] = " +";
                    lineWidth[j][jj] = 1;
                    corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "は弱く関連する可能性があります。\n";
                } else {
                    F$[j][jj] = "ns";
                    lineWidth[j][jj] = 0;
                    corrStr[j][jj] = "";
                }
            } else {
                F$[j][jj] = "ns";
                lineWidth[j][jj] = 0;
                corrStr[j][jj] = "";
            }
        }
    }
    strArray.push("\n");
    strArray.push("\n Correlation Matrix\n");
    strArray.push("  df= 1 & " + (NN - 2) + "\n");

    var diagramData = KK + "\n";
    var wStr = "";

    strArray.push(bar);
    for (j = 0; j < KK; j++) {
        strArray.push("\tVar" + (j + 1));
    }
    strArray.push("\n");
    strArray.push(bar);

    for (j = 0; j < KK; j++) {
        strArray.push("Var" + (j + 1));
        for (jj = 0; jj < j + 1; jj++) {
            strArray.push("\t");
        }
        strArray.push("-");
        for (jj = j + 1; jj < KK; jj++) {
            strArray.push("\t" + using(R[j][jj], 2, 3) + " " + F$[j][jj]);
        }
        strArray.push("\n");
    }

    strArray.push("\nTest of Correlation\n");
    for (j = 0; j < KK - 1; j++) {
        strArray.push(bar);
        strArray.push("  Var.       r       F   Test\n");
        strArray.push(bar);
        for (jj = j + 1; jj < KK; jj++) {
            strArray.push(" Var" + (j + 1) + "xVar" + (jj + 1) + "\t");
            strArray.push(using(R[j][jj], 2, 3) + "\t" + using(FF[j][jj], 3, 2) + "\t" + F$[j][jj] + "\n");
            if (lineWidth[j][jj] != 0) {
                diagramData += (j + 1) + "," + (jj + 1) + "," + using(R[j][jj], 2, 3) + "," + lineWidth[j][jj] + "\n";
            }
            if (corrStr[j][jj] != "") {
                wStr += corrStr[j][jj];
            }
        }
    }

    strArray.push("\n" + bar + "\n" + wStr);

    strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

    // ダイアグラム出力
    document.getElementById("corrDiaArea").value = diagramData;
    corrDiaDraw();

    //グラフの設定
    var gCheck = document.getElementById("RltArea").value;
    gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

    document.getElementById("RltArea").value += strArray.join("");
    strArray = null;
    // var RltAreaObj = document.getElementById("RltArea2");
    // RltAreaObj.focus();
    // RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
    // RltAreaObj.scrollTop = 0;

    //グラフ描画
    (function () {
        chartClear();

        var i, j, jj;

        //軸の最大値と最小値の設定
        var max = xx[0][0];
        var min = xx[0][0];
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                if (max < xx[i][j]) max = xx[i][j];
                if (min > xx[i][j]) min = xx[i][j];
            }
        }

        var _myMax = gCheck.match(/max:\d+/);
        if (_myMax !== null) {
            var myMax = _myMax[0].match(/\d+/);
            max = parseFloat(myMax, 10);
        }
        var _myMin = gCheck.match(/min:\d+/);
        if (_myMin !== null) {
            var myMin = _myMin[0].match(/\d+/);
            min = parseFloat(myMin, 10);
        }

        //カラーユニバーサルデザイン推奨配色セット制作委員会
        //https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
        // var chartClrAry = ["#ff4b00", "#fff100", "#03af7a", "#005aff", "#4dc4ff", "#ff8082", "#f6aa00", "#990099", "#804000"];
        var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

        var titleText;

        var chartNum = 0;
        for (j = 0; j < KK - 1; j++) {
            for (jj = j + 1; jj < KK; jj++) {

                var chartImg = document.createElement('canvas');
                chartImg.id = "ChartImg" + chartNum;
                var ctx = document.getElementById("chart").appendChild(chartImg);

                var data = [];
                for (i = 0; i < NN; i++) {
                    addData = { x: xx[i][j], y: xx[i][jj] };
                    data.push(addData);
                }

                titleText = 'A' + (j + 1) + ':A' + (jj + 1);

                var datasetData = [{
                    backgroundColor: chartClrAry[chartNum % chartClrAry.length],
                    borderColor: chartClrAry[chartNum % chartClrAry.length],
                    pointBorderWidth: 3,
                    borderWidth: 1,
                    lineTension: 0,
                    data: data
                }];
                chartNum++;

                var myChart = new Chart(ctx, {
                    type: 'scatter',
                    data: {
                        datasets: datasetData
                    },
                    options: {
                        title: {
                            display: true,
                            text: titleText,
                            position: 'top',
                            fontSize: 12,
                            fontColor: '#000000'
                        },
                        scales: {
                            xAxes: [{
                                ticks: {
                                    suggestedMin: min,
                                    suggestedMax: max
                                }
                            }],
                            yAxes: [{
                                ticks: {
                                    suggestedMin: min,
                                    suggestedMax: max
                                }
                            }]
                        },
                        legend: {
                            display: false
                        },
                        tooltips: {
                            mode: 'label'
                        },
                    }
                });
            }
        }
    }());	//グラフ描画ここまで

}
function corrDiaDraw() {
    var i = 0;
    var j = 0;
    var jj = 0;

    var canvas = document.getElementById("DiaCanvas");
    // var canvas = document.getElementById("corrDiaCanvas");
    if (!canvas || !canvas.getContext) {
        return false;
    }

    if (document.getElementById("corrDiaArea").value != "") {
        var diaData = document.getElementById("corrDiaArea").value;
        var rowStr = diaData.split("\n");

        //項目数
        var KK = parseInt(rowStr[0], 10);

        var columStr = [];
        var k1 = [];
        var k2 = [];
        var r = [];
        var lineWidth = [];

        for (i = 1; i < rowStr.length - 1; i++) {
            columStr = rowStr[i].split(",");
            k1[i] = parseInt(columStr[0], 10);        //項目１
            k2[i] = parseInt(columStr[1], 10);        //項目２
            r[i] = parseFloat(columStr[2]);          //相関係数
            lineWidth[i] = parseInt(columStr[3], 10); //線幅
        }

        var ctx = canvas.getContext('2d');

        //canvasを白で塗りつぶし
        ctx.beginPath();
        ctx.fillStyle = 'rgb(255,255,255)';
        ctx.fillRect(0, 0, 550, 450);

        // ダイアグラムの中心の座標
        var x1 = 275;
        var y1 = 200;

        // 項目番号0の座標
        var x2 = 275;
        var y2 = 30;

        // 項目番号の座標
        // var tx = 0;
        // var ty = 0;
        var tx = [];
        var ty = [];

        ctx.lineWidth = 1;

        var xx = [];
        var yy = [];

        var t = 0; //角度
        for (j = 0; j < KK; j++) {
            t = Math.PI / 180 * j * (360 / KK);
            xx[j] = Math.ceil((x2 - x1) * Math.cos(t) - (y2 - y1) * Math.sin(t)) + x1;
            yy[j] = Math.ceil((x2 - x1) * Math.sin(t) + (y2 - y1) * Math.cos(t)) + y1;
        }

        for (j = 0; j < KK; j++) {
            t = Math.PI / 180 * j * (360 / KK);
            tx[j] = Math.ceil((x2 - x1) * Math.cos(t) - (y2 - y1) * Math.sin(t)) + x1 - 4;
            ty[j] = Math.ceil((x2 - x1) * Math.sin(t) + (y2 - y1) * Math.cos(t)) + y1 + 4;
        }

        var diaPointNum = parseInt(document.getElementById("diaPointNum").value, 10);
        if (diaPointNum == 0) {
            for (i = 1; i < rowStr.length - 1; i++) {
                // 線種 線幅=1 ならば 破線
                if (lineWidth[i] == 1) {
                    ctx.setLineDash([3, 3]); //破線
                } else {
                    ctx.setLineDash([]); //実線
                }

                if (r[i] > 0) {
                    // 相関係数>0 ならば 赤
                    ctx.strokeStyle = 'rgb(255,0,0)';
                } else {
                    // 相関係数<=0 ならば 青
                    ctx.strokeStyle = 'rgb(0,0,255)';
                }
                ctx.lineWidth = lineWidth[i];
                ctx.beginPath();
                ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
                ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
                ctx.stroke();
            }
        } else {
            // グレーで描画
            for (i = 1; i < rowStr.length - 1; i++) {
                // 線種 線幅=1 ならば 破線
                if (lineWidth[i] == 1) {
                    ctx.setLineDash([3, 3]); //破線
                } else {
                    ctx.setLineDash([]); //実線
                }
                ctx.strokeStyle = 'rgb(169,169,169)';
                ctx.lineWidth = lineWidth[i];
                ctx.beginPath();
                ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
                ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
                ctx.stroke();
            }

            for (i = 1; i < rowStr.length - 1; i++) {
                // 線種 線幅=1 ならば 破線
                if (lineWidth[i] == 1) {
                    ctx.setLineDash([3, 3]); //破線
                } else {
                    ctx.setLineDash([]); //実線
                }

                if (r[i] > 0) {
                    // 相関係数>0 ならば 赤
                    if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
                        ctx.strokeStyle = 'rgb(255,0,0)';
                    }
                } else {
                    // 相関係数<=0 ならば 青
                    if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
                        ctx.strokeStyle = 'rgb(0,0,255)';
                    }
                }

                if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
                    ctx.lineWidth = lineWidth[i];
                    ctx.beginPath();
                    ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
                    ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
                    ctx.stroke();
                }
            }
        }

        var wr = 10;
        //項目を示す○を描く（白で塗りつぶし）
        ctx.lineWidth = 1;
        ctx.setLineDash([]); //実線
        ctx.fillStyle = 'rgb(255,255,255)';
        for (j = 0; j < KK; j++) {
            ctx.beginPath();
            ctx.arc(xx[j], yy[j], wr, 0, Math.PI * 2, false);
            ctx.fill();
        }
        //項目を示す○を描く（線を黒く）
        ctx.lineWidth = 1;
        ctx.setLineDash([]); //実線
        ctx.strokeStyle = 'rgb(0,0,0)';
        for (j = 0; j < KK; j++) {
            ctx.beginPath();
            ctx.arc(xx[j], yy[j], wr, 0, Math.PI * 2, false);
            ctx.stroke();
        }

        ctx.lineWidth = 1;
        ctx.setLineDash([]); //実線
        ctx.font = "14px 'Times New Roman'";
        ctx.strokeStyle = 'rgb(0,0,0)';
        ctx.fillStyle = "rgb(0,0,0)";
        for (j = 0; j < KK; j++) {
            ctx.strokeText(j + 1, tx[j], ty[j]);
        }


        if (diaPointNum != 0) {
            //項目を示す○を描く（白で塗りつぶし）
            ctx.lineWidth = 1;
            ctx.setLineDash([]); //実線
            ctx.fillStyle = 'rgb(0,0,0)';
            ctx.beginPath();
            ctx.arc(xx[diaPointNum - 1], yy[diaPointNum - 1], wr, 0, Math.PI * 2, false);
            ctx.fill();
            //項目を示す○を描く（線を黒く）
            ctx.lineWidth = 1;
            ctx.setLineDash([]); //実線
            ctx.strokeStyle = 'rgb(0,0,0)';
            ctx.beginPath();
            ctx.arc(xx[diaPointNum - 1], yy[diaPointNum - 1], wr, 0, Math.PI * 2, false);
            ctx.stroke();

            ctx.lineWidth = 1;
            ctx.setLineDash([]); //実線
            ctx.font = "14px 'Times New Roman'";
            ctx.strokeStyle = 'rgb(255,255,255)';
            ctx.fillStyle = "rgb(255,255,255)";
            ctx.strokeText(diaPointNum, tx[diaPointNum - 1], ty[diaPointNum - 1]);
        }
    }

}
