/**
 * 多変量解析
 * 信頼性係数αの計算
 *
 *
 *
 */
var chartNum = 0; //グラフ番号
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();

    changeReverseSetting();

    // デフォルトのタブを選択
    ChangeTab(1, 5);
};
function mainCalc_scaleDev() {
    var i = 0;
    var j = 0;
    var k = 0;
    var ik = 0;

    var NN = 0;
    var KK = 0;

    var DData = dataremake5("DataArea");
    var dd = [];
    dd = DData.split(" ");

    var strArray = [];
    var bar = "--------------------------------------\n";

    NN = countRowCol("DataArea")[0]; // 行数を取得
    KK = countRowCol("DataArea")[1]; // 列数を取得

    if (KK == -1) { //列数エラー -1
        alert("データが行列形式ではありません");
    } else if (NN != 0) { //行数が 0 でない場合
        var xx = new Array(NN);
        for (i = 0; i < NN; i++) {
            xx[i] = new Array(KK);
        }

        var ddCount = 0;
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                xx[i][j] = parseFloat(dd[ddCount]);
                ddCount++;
            }
        }

        //逆転項目処理
        var wMin = parseInt(document.getElementById("x_min").value, 10);
        var wMax = parseInt(document.getElementById("x_max").value, 10);
        var reverseItem = [];
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                reverseItem[j] = "正";
                if (document.getElementById("x" + (j + 1)).checked) {
                    xx[i][j] = (wMax + wMin) - xx[i][j];
                    reverseItem[j] = "逆";
                }
            }
        }

        var N = []; //各項目の回答数
        var M = []; //平均
        var V = []; //分散
        var SD = []; //標準偏差
        var VS = []; //不偏分散
        var SDS = []; //不偏分散の標準偏差
        var Vsum = 0; //各項目の分散の合計
        var VSsum = 0; //各項目の分散の合計
        var skewness = []; //歪度
        var kurtosis = []; //尖度

        var S = 0;
        var SS = 0;
        var SSS = 0;
        var SSSS = 0;
        for (j = 0; j < KK; j++) {
            //各項目の平均
            S = 0;
            for (i = 0; i < NN; i++) {
                if (!isNaN(xx[i][j])) {
                    S = S + xx[i][j];
                }
            }
            M[j] = S / NN;

            //各項目の分散
            //各項目の標準偏差
            SS = 0;
            for (i = 0; i < NN; i++) {
                if (!isNaN(xx[i][j])) {
                    SS = SS + Math.pow(M[j] - xx[i][j], 2);
                }
            }
            V[j] = SS / NN;
            SD[j] = Math.sqrt(V[j]);
            VS[j] = SS / (NN - 1);
            SDS[j] = Math.sqrt(VS[j]);
            if (document.getElementById("item" + (j + 1)).checked) {
                VSsum = VSsum + VS[j];
                // Vsum = Vsum + VS[j];
            }

            //歪度
            SSS = 0;
            for (i = 0; i < NN; i++) {
                if (!isNaN(xx[i][j])) {
                    SSS = SSS + Math.pow((xx[i][j] - M[j]) / SDS[j], 3);
                }
            }
            skewness[j] = NN / (NN - 1) / (NN - 2) * SSS;

            //尖度
            SSSS = 0;
            for (i = 0; i < NN; i++) {
                if (!isNaN(xx[i][j])) {
                    SSSS = SSSS + Math.pow((xx[i][j] - M[j]), 4) / Math.pow(SDS[j], 4);
                }
            }
            kurtosis[j] = NN * (NN + 1) / ((NN - 1) * (NN - 2) * (NN - 3)) * SSSS - 3 * Math.pow(NN - 1, 2) / ((NN - 2) * (NN - 3));
        }

        var AllSum = []; //各参加者別の全項目の合計
        for (i = 0; i < NN; i++) {
            S = 0;
            for (j = 0; j < KK; j++) {
                if (document.getElementById("item" + (j + 1)).checked) {
                    S = S + xx[i][j];
                }
            }
            AllSum[i] = S;
        }

        var AllMean = 0; //全項目合計値の平均
        S = 0;
        for (i = 0; i < NN; i++) {
            S = S + AllSum[i];
        }
        AllMean = S / NN;

        var AllV = 0; //全項目合計値の分散
        var AllSD = 0; //全項目合計値の標準偏差
        var AllVS = 0; //全項目合計値の不偏分散
        var AllSDS = 0; //全項目合計値の不偏分散の標準偏差
        var Allskewness = 0;
        var Allkurtosis = 0;

        SS = 0;
        for (i = 0; i < NN; i++) {
            SS = SS + Math.pow(AllMean - AllSum[i], 2);
        }
        AllV = SS / NN;
        AllSD = Math.sqrt(AllV);
        AllVS = SS / (NN - 1);
        AllSDS = Math.sqrt(AllVS);

        //歪度
        SSS = 0;
        for (i = 0; i < NN; i++) {
            SSS = SSS + Math.pow((AllSum[i] - AllMean) / AllSDS, 3);
        }
        Allskewness = NN / (NN - 1) / (NN - 2) * SSS;

        //尖度
        SSSS = 0;
        for (i = 0; i < NN; i++) {
            SSSS = SSSS + Math.pow((AllSum[i] - AllMean), 4) / Math.pow(AllSDS, 4);
        }
        Allkurtosis = NN * (NN + 1) / ((NN - 1) * (NN - 2) * (NN - 3)) * SSSS - 3 * Math.pow(NN - 1, 2) / ((NN - 2) * (NN - 3));

        //合計得点と各項目の相関を求める
        var tmpSum = new Array(NN);
        for (i = 0; i < NN; i++) {
            tmpSum[i] = new Array(KK);
        }
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                tmpSum[i][j] = AllSum[i];
            }
        }

        var tmpM = [];
        for (j = 0; j < KK; j++) {
            S = 0;
            for (i = 0; i < NN; i++) {
                S = S + tmpSum[i][j];
            }
            tmpM[j] = S / NN;
        }
        var tmpV = [];
        var tmpVS = [];
        var tmpSD = [];
        for (j = 0; j < KK; j++) {
            SS = 0;
            for (i = 0; i < NN; i++) {
                SS = SS + Math.pow(tmpM[j] - tmpSum[i][j], 2);
            }
            tmpV[j] = SS / NN;
            // tmpVS[j] = SS / (NN - 1);
            tmpSD[j] = Math.sqrt(tmpV[j]);
        }

        var tmpR = [];
        S = 0;
        for (j = 0; j < KK; j++) {
            S = 0;
            for (i = 0; i < NN; i++) {
                S += (xx[i][j] - M[j]) * (tmpSum[i][j] - tmpM[j]);
            }
            tmpR[j] = S / NN / SD[j] / tmpSD[j];
        }

        // 項目全体相関（ITC）
        var delSum = new Array(NN); //各参加者別の１項目を削除した項目の合計
        for (i = 0; i < NN; i++) {
            delSum[i] = new Array(KK);
        }
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                delSum[i][j] = AllSum[i] - xx[i][j];
            }
        }

        var delM = [];
        for (j = 0; j < KK; j++) {
            S = 0;
            for (i = 0; i < NN; i++) {
                S = S + delSum[i][j];
            }
            delM[j] = S / NN;
        }
        var delV = [];
        var delSD = [];
        var delVS = [];
        var delSDS = [];
        for (j = 0; j < KK; j++) {
            SS = 0;
            for (i = 0; i < NN; i++) {
                SS = SS + Math.pow(delM[j] - delSum[i][j], 2);
            }
            delV[j] = SS / NN;
            // delVS[j] = SS / (NN - 1);
            delSD[j] = Math.sqrt(delV[j]);
            // delSDS[j] = Math.sqrt(delVS[j]);
        }

        var it_R = [];
        S = 0;
        for (j = 0; j < KK; j++) {
            S = 0;
            for (i = 0; i < NN; i++) {
                S += (xx[i][j] - M[j]) * (delSum[i][j] - delM[j]);
            }
            // it_R[j] = S / NN / SDS[j] / delSDS[j];
            it_R[j] = S / NN / SD[j] / delSD[j];
        }

        var checkNum = 0;
        for (j = 0; j < KK; j++) {
            if (document.getElementById("item" + (j + 1)).checked) {
                checkNum++;
            }
        }

        var Kcount = checkNum;
        var alpha = Kcount / (Kcount - 1) * (1 - VSsum / AllVS);

        //項目削除後のα係数の計算
        var tmpData = ""; //逆転処理後のデータを作成
        for (i = 0; i < NN; i++) {
            for (j = 0; j < KK; j++) {
                tmpData += xx[i][j] + " ";
            }
            tmpData += "\n";
        }
        var delAlpha = [];
        delAlpha = alphaCalc(tmpData);

        strArray.push("[[ 尺度開発／項目分析 ]]\n");
        strArray.push("N=" + NN + "\n");
        strArray.push("Item数=" + KK + "\n\n");

        strArray.push("［信頼性係数／内部一貫性の検討］\n");
        strArray.push("\n");
        strArray.push("Cronbach's α = " + alpha.toFixed(3));
        strArray.push("\n\n");

        strArray.push(bar);
        strArray.push("\t正逆\tI-T相関\t削除時α\n");
        strArray.push(bar);
        for (j = 0; j < KK; j++) {
            strArray.push("Item" + String(j + 1).padStart(2, '0') + "\t");
            if (document.getElementById("item" + (j + 1)).checked) {
                strArray.push(reverseItem[j] + "\t" + it_R[j].toFixed(3) + "\t" + delAlpha[j].toFixed(3) + "\n");
            } else {
                strArray.push("--\t-----\t-----\n");
            }
        }
        strArray.push(bar);
        strArray.push("※I-T相関の当該ItemはTotalに含まれない（I-R相関）\n");

        document.getElementById("RltArea1").value = strArray.join("");
        strArray = null;

        //G-P分析
        subCalc_gp(tmpData);
        chartNum = 0; //グラフ番号を初期化

        // 基本統計量の出力
        strArray = [];
        strArray.push("\n［基本統計量］\n");
        strArray.push("N=" + NN + "\n");
        strArray.push(bar);
        strArray.push("\t正逆\tMean\tSD\tM+SD\tM-SD\t歪度\t尖度\n");
        strArray.push(bar);
        strArray.push("Total\t");
        strArray.push("--\t" + AllMean.toFixed(2) + "\t" + AllSDS.toFixed(2) + "\t" + (AllMean + AllSDS).toFixed(2) + "\t" + (AllMean - AllSDS).toFixed(2) + "\t" + Allskewness.toFixed(3) + "\t" + Allkurtosis.toFixed(3));
        strArray.push("\n");

        for (j = 0; j < KK; j++) {
            strArray.push("Item" + String(j + 1).padStart(2, '0') + "\t");
            if (document.getElementById("item" + (j + 1)).checked) {
                strArray.push(reverseItem[j] + "\t" + M[j].toFixed(2) + "\t" + SDS[j].toFixed(2) + "\t" + (M[j] + SD[j]).toFixed(2) + "\t" + (M[j] - SDS[j]).toFixed(2) + "\t" + skewness[j].toFixed(3) + "\t" + kurtosis[j].toFixed(3));
                strArray.push("\n");
            } else {
                strArray.push("\t--\t----\t----\t----\t----\t----\n");
            }
        }
        strArray.push(bar);
        document.getElementById("RltArea1").value += strArray.join("");
        strArray = null;

        //相関係数
        subCalc_corr(tmpData, tmpR);

        //Ｒプログラム出力
        (function () {
            var rcmArray = [];
            var spc = "          ";

            rcmArray.push("##### 尺度開発／項目分析（ベイズファクタ使用）\n");
            rcmArray.push("\n");
            rcmArray.push("# パッケージ psych が必要\n");
            rcmArray.push("# パッケージ BayesFactor が必要\n");

            rcmArray.push("\n");
            rcmArray.push("## js-STARの入力\n");
            rcmArray.push("N= " + NN + "\n");
            rcmArray.push("komok= " + KK + "  # 項目数\n");
            // rcmArray.push("saiyo= c( 1, 2, 3, 4, 5, 6 ) # 採用する項目の指定\n");


            rcmArray.push("saiyo= c(");
            var strTmp = "";
            for (j = 0; j < KK; j++) {
                if (document.getElementById("item" + (j + 1)).checked) {
                    strTmp += (j + 1) + ",";
                }
            }
            strTmp = strTmp.substr(0, strTmp.length - 1);
            rcmArray.push(strTmp);
            rcmArray.push(")\n");
            rcmArray.push("\n");


            var cutpointValue = 100 / parseFloat(document.getElementById("cutpoint").value);

            console.log(100 / 3.3333333333333);

            rcmArray.push("Gsize= " + cutpointValue.toFixed(2) + "  # G-P群のサイズ\n");
            rcmArray.push("\n");

            rcmArray.push("data = c(\n");
            for (i = 0; i < NN; i++) {
                for (j = 0; j < KK; j++) {
                    rcmArray.push(" " + xx[i][j]);
                    if ((i != NN - 1) || (j != KK - 1)) rcmArray.push(",");
                }
                rcmArray.push("\n");
            }
            rcmArray.push(" )\n");
            rcmArray.push("\n");

            rcmArray.push("## js-STARの入力おわり\n");
            rcmArray.push("\n");

            rcmArray.push("BFkj= 3 # BFの評価基準\n");
            rcmArray.push("\n");
            rcmArray.push("library( psych )\n");
            rcmArray.push("library( BayesFactor )\n");
            rcmArray.push("\n");
            rcmArray.push("if( Gsize>1 ) Gsize=Gsize/100\n");
            rcmArray.push("dtab= matrix(data, ncol=komok, by=1 )\n");
            rcmArray.push("saisu= length(saiyo )\n");
            rcmArray.push("colnames(dtab)= paste(\"項目\", 1:komok, sep=\"\" )\n");
            rcmArray.push("dx= dtab[ ,saiyo]\n");
            rcmArray.push("\n");
            rcmArray.push("Gyak= rep(\" 正 \", saisu )\n");
            rcmArray.push("kx= alpha(dx, check.keys=T )\n");
            rcmArray.push("nams= rownames(kx$alpha )\n");
            rcmArray.push("itca= round(kx$item.stats[ ,5], 3 )\n");
            rcmArray.push("joga= round(kx$alpha.drop[ ,1], 3 )\n");
            rcmArray.push("fuka= fa(dx, nf=1, fm=\"pa\", ro=\"none\")$load[1:saisu, ]\n");
            rcmArray.push("fuka= round(fuka, 3 )\n");
            rcmArray.push("for( i in 1:saisu ) # 逆転\n");
            rcmArray.push("{\n");
            rcmArray.push(" if( regexpr(\"-\", nams[i])>0 )\n");
            rcmArray.push(" {\n");
            rcmArray.push("  Gyak[i]=\"逆転\"\n");
            rcmArray.push("  dt= dx[ ,i]\n");
            rcmArray.push("  dx[ ,i]= min(dt)+max(dt)-dt\n");
            rcmArray.push(" }\n");
            rcmArray.push("}\n");
            rcmArray.push("\n");
            rcmArray.push("tx1= matrix(round(kx$total[1:3], 3), nc=3 )\n");
            rcmArray.push("rownames(tx1)=\"尺度合計\"\n");
            rcmArray.push("colnames(tx1)=c(\"素点α\",\"標準化α\",\"G6(smc)\" )\n");
            rcmArray.push("\n");
            rcmArray.push("tx2= c()\n");
            rcmArray.push("tx2= data.frame(fuka, Gyak, itca, joga)\n");
            rcmArray.push("rownames(tx2)= colnames(dx )\n");
            rcmArray.push("colnames(tx2)= c(\"主因子解\",\"正逆\",\"I-T相関\",\"削除時α\" )\n");
            rcmArray.push("\n");
            rcmArray.push("# G-P／尺度合計\n");
            rcmArray.push("dy= cbind(dx, matrix(apply(dx[ ,1:saisu], 1, sum), nc=1) )\n");
            rcmArray.push("colnames(dy)[saisu+1]=\"全体\"\n");
            rcmArray.push("juni= rank(dy[ ,saisu+1] )\n");
            rcmArray.push("Good= dy[(juni>=(N-N*Gsize)) ,saisu+1]\n");
            rcmArray.push("Poor= dy[ juni<=(  N*Gsize ) ,saisu+1]\n");
            rcmArray.push("ky= ttestBF(Good, Poor )\n");
            rcmArray.push("bf= as.vector(ky )\n");
            rcmArray.push("Er= extractBF(ky)[1,2]*100\n");
            rcmArray.push("tx3= c()\n");
            rcmArray.push("tx3= matrix(c(length(Good), round(length(Good)/N*100, 2),\n");
            rcmArray.push("     round(c(mean(Good), sd(Good), bf), 3),\n");
            rcmArray.push("     length(Poor), round(length(Poor)/N*100, 2),\n");
            rcmArray.push("     round(c(mean(Poor), sd(Poor), 1/bf), 3)\n");
            rcmArray.push("     ), nc=5, by=1 )\n");
            rcmArray.push("rownames(tx3)=c(\"Total_上位群\",\"Total_下位群\")\n");
            rcmArray.push("colnames(tx3)=c(\"ｎ\",\"n/N(%)\",\"    平均\",\"SD\",\"     BF\")\n");
            rcmArray.push("\n");
            rcmArray.push("tx4= c()\n");
            rcmArray.push("miBf=999; mxBf=0; Er1=0; Er0=0\n");
            rcmArray.push("for( i in 1:saisu )\n");
            rcmArray.push("{\n");
            rcmArray.push(" Good= dy[(juni>=(N-N*Gsize)) ,i]\n");
            rcmArray.push(" Poor= dy[ juni<=(  N*Gsize ) ,i]\n");
            rcmArray.push(" kz= ttestBF(Good, Poor)\n");
            rcmArray.push(" Bf= as.vector(kz )\n");
            rcmArray.push(" hyo= matrix(round(c(\n");
            rcmArray.push("      mean(Good),sd(Good),mean(Poor),sd(Poor),Bf\n");
            rcmArray.push("      ), 3), nc=5 )\n");
            rcmArray.push(" tx4= rbind(tx4, hyo )\n");
            rcmArray.push(" err= extractBF(kz)[1,2]*100\n");
            rcmArray.push(" if( Bf< BFkj ){ if( Bf>mxBf ) mxBf=Bf; if( err>Er0 ) Er0=err }\n");
            rcmArray.push(" if( Bf>=BFkj ){ if( Bf<miBf ) miBf=Bf; if( err>Er1 ) Er1=err } \n");
            rcmArray.push("}\n");
            rcmArray.push("rownames(tx4)= paste(\"項目\",saiyo, sep=\"\" )\n");
            rcmArray.push("colnames(tx4)= c(\"上位群Mean\",\"SD\",\"下位群Mean\",\"SD\",\"BF\")\n");
            rcmArray.push("\n");
            rcmArray.push("tx5= round(cor(dy), 3 )\n");
            rcmArray.push("tx6= c()\n");
            rcmArray.push("for( i in 1:(saisu+1) ){\n");
            rcmArray.push("for( j in 1:(saisu+1) ){\n");
            rcmArray.push(" if( i==j ) tx6=c(tx6, NA ) else\n");
            rcmArray.push(" {\n");
            rcmArray.push("  corbf= as.vector(correlationBF(dy[,i], dy[,j]) )\n");
            rcmArray.push("  if( i<j ) tx6=c(tx6, round(corbf, 3) )\n");
            rcmArray.push("  if( i>j ) tx6=c(tx6, round(1/corbf, 3) )\n");
            rcmArray.push(" }\n");
            rcmArray.push("}  }\n");
            rcmArray.push("tx6= matrix(tx6, nc=saisu+1, by=1 )\n");
            rcmArray.push("dimnames(tx6)= dimnames(tx5)\n");
            rcmArray.push("\n");
            rcmArray.push("tx9= describe(dy)[,c(3:5,8,9,11:13)]\n");
            rcmArray.push("colnames(tx9)= c(\"平均\",\"SD\",\"Med.\",\"Min\",\"Max\",\"歪度\",\"尖度\",\"SE\")\n");
            rcmArray.push("\n");
            rcmArray.push("# 結果の書き方\n");
            rcmArray.push("txt=\"　\"; kmk=\"\"\n");
            rcmArray.push("for( i in 1:saisu )\n");
            rcmArray.push("{\n");
            rcmArray.push(" kmk= paste(kmk,\"項目\",saiyo[i], sep=\"\" )\n");
            rcmArray.push(" if( i<saisu ) kmk=paste(kmk,\"，\", sep=\"\" )\n");
            rcmArray.push("}\n");
            rcmArray.push("txt= paste(txt,kmk,\"を用いて尺度の構成を行った。\", sep=\"\" )\n");
            rcmArray.push("txt= paste(txt,\"各項目の基本統計量をTable(tx9)に示す。\", sep=\"\" )\n");
            rcmArray.push("kaz= sum( tx2[ ,1]<0 )\n");
            rcmArray.push("if( kaz>0 ) # 逆転あり\n");
            rcmArray.push("{\n");
            rcmArray.push(" txt= paste(txt,\"なお以下の分析では，\", sep=\"\" )\n");
            rcmArray.push(" for( i in 1:saisu )\n");
            rcmArray.push(" {\n");
            rcmArray.push("  if( tx2[i, 1]<0 ) txt=paste(txt,\"項目\",saiyo[i], sep=\"\" )\n");
            rcmArray.push("  if( i<kaz ) txt=paste(txt,\"，\", sep=\"\" )\n");
            rcmArray.push(" }\n");
            rcmArray.push(" txt= paste(txt,\"の得点を逆転した。\", sep=\"\" )\n");
            rcmArray.push("}\n");
            rcmArray.push("\n");
            rcmArray.push("alp1= tx1[1,1]\n");
            rcmArray.push("goku=\"不十分であった。\"; daga=\"続けて、\"\n");
            rcmArray.push("if( alp1>=0.8 ) goku=\"十分であった。\" else\n");
            rcmArray.push("if( alp1>=0.7 ) goku=\"十分とはいえないが、0.70以上あり一応許容される。\" else\n");
            rcmArray.push("daga=\"参考までに、\"\n");
            rcmArray.push("txt= paste(txt,\"\n　Cronbachの信頼性係数α（素点計算値）を用いて内部一貫性の検討を行った結果（Table(tx1)参照）、全項目の尺度合計についてα=\",alp1,\"であり、内部一貫性は\",goku, sep=\"\" )\n");
            rcmArray.push("\n");
            rcmArray.push("alp2= max(tx2[ ,4] )\n");
            rcmArray.push("kban= order(tx2[ ,4], decreasing=1)[1]\n");
            rcmArray.push("if( alp1<alp2 & alp2>=0.7 ) txt=paste(txt,\"\n※項目\",kban,\"を除外した尺度合計はα=\",alp2,\"と増加するので項目\",kban,\"を除外し再分析することも一案。\", sep=\"\" )\n");
            rcmArray.push("\n");
            rcmArray.push("# G-P\n");
            rcmArray.push("tsBF= function(bf)\n");
            rcmArray.push("{\n");
            rcmArray.push(" TXT= c()\n");
            rcmArray.push(" if( bf>150) TXT=\"非常に有力\" else\n");
            rcmArray.push(" if( bf> 20) TXT=\"有力\"       else\n");
            rcmArray.push(" if( bf>=BFkj) TXT=\"有効\"\n");
            rcmArray.push(" TXT\n");
            rcmArray.push("}\n");
            rcmArray.push("fuki= paste(\"（BF=\",round(bf, 3),\", error=\",round(Er, 3),\"%）、\", sep=\"\" )\n");
            rcmArray.push("txt= paste(txt,\"\n\n　\",daga,\"当該尺度の弁別力を検討するためG-P分析を実施した。尺度合計の上位群・下位群のサンプルサイズを各\",Gsize*100,\"％と設定し、各群の合計得点の平均差についてベイズファクタによる検定（有効水準=\",BFkj,\"，両側仮説，以下同様）を行った。その結果（Table(tx3)参照）、BF値は\", sep=\"\" )\n");
            rcmArray.push("\n");
            rcmArray.push("if( bf<BFkj | mean(Good)<mean(Poor) ) txt=paste(txt,\"有効以上ではなく\",fuki,\"尺度合計が上位群・下位群の弁別力を示すとはいえなかった。\", sep=\"\" ) else\n");
            rcmArray.push("{\n");
            rcmArray.push(" txt= paste(txt,tsBF(bf),\"であり\",fuki,\"尺度合計の上位群の平均が下位群の平均よりも実質的に大きいことが見いだされた。\n　そこで、この上位群・下位群のサンプルを固定し個々の項目において両群の平均得点の差を検定した結果（Table(tx4)参照）、\", sep=\"\" )\n");
            rcmArray.push("\n");
            rcmArray.push(" ban=c(); ban0=c(); daga=\"\"\n");
            rcmArray.push(" for( i in 1:saisu ) if( tx4[i, 5]>=BFkj ) ban=c(ban, saiyo[i]) else ban0=c(ban0, saiyo[i])\n");
            rcmArray.push("\n");
            rcmArray.push(" if( length(ban)>0 ) # BF>3あり\n");
            rcmArray.push(" {\n");
            rcmArray.push("  if( length(ban)==1 ) goku=\"\" else goku=\"s\"\n");
            rcmArray.push("  if( length(ban0)==0 ) tmp=\"全項目\" else\n");
            rcmArray.push("  {\n");
            rcmArray.push("   tmp=\"\"; daga=\"しかし\"\n");
            rcmArray.push("   for( i in 1:length(ban) ) \n");
            rcmArray.push("   {\n");
            rcmArray.push("    tmp= paste(tmp,\"項目\",ban[i], sep=\"\" )\n");
            rcmArray.push("    if( i<length(ban) ) tmp=paste(tmp,\"，\", sep=\"\" )\n");
            rcmArray.push("   }\n");
            rcmArray.push("  }\n");
            rcmArray.push("  txt= paste(txt,tmp,\"において上位群・下位群の２平均間に有効以上の実質的な差が見いだされた（BF\",goku,\">\",round(miBf, 3),\", error\",goku,\"<\",round(Er1, 2),\"%）。\", sep=\"\" )\n");
            rcmArray.push(" }\n");
            rcmArray.push("\n");
            rcmArray.push(" if( length(ban0)>0 ) # BF<3あり\n");
            rcmArray.push(" {\n");
            rcmArray.push("  if( length(ban0)==1 ) goku=\"\" else goku=\"s\"\n");
            rcmArray.push("  if( length(ban)==0 ) tmp=\"全項目\" else\n");
            rcmArray.push("  {\n");
            rcmArray.push("   tmp=\"\"\n");
            rcmArray.push("   for( i in 1:length(ban0) )\n");
            rcmArray.push("   {\n");
            rcmArray.push("    tmp= paste(tmp,\"項目\",ban0[i], sep=\"\" )\n");
            rcmArray.push("    if( i<length(ban0) ) tmp=paste(tmp,\"，\", sep=\"\" )\n");
            rcmArray.push("   }\n");
            rcmArray.push("  txt= paste(txt,daga,tmp,\"において上位群・下位群の２平均に実質的な差があるとはいえなかった（BF\",goku,\"<\",round(mxBf, 3),\", error\",goku,\"<\",round(Er0, 2),\"%）。\", sep=\"\" )\n");
            rcmArray.push("  }\n");
            rcmArray.push(" }\n");
            rcmArray.push("}  # if(bf<BFkj)\n");
            rcmArray.push("\n");
            rcmArray.push("yosh1=\"\"; yosh2=\"\"\n");
            rcmArray.push("if( alp1>=0.8 ) yosh1=\"十分な\" else if( alp1>=0.7 ) yosh1=\"許容される\"\n");
            rcmArray.push("if( bf>=BFkj ) if( length(ban0)==0 ) yosh2=\"実質的な\" else\n");
            rcmArray.push("if( length(ban)>0 ) yosh2=\"部分的な\"\n");
            rcmArray.push("tmp=\"\n\n　以上より，\"\n");
            rcmArray.push("if( alp1>=0.7 ) txt=paste(txt,tmp,kmk,\"から構成される尺度が\",yosh1,\"内部一貫性と\",yosh2,\"弁別力をもつ尺度であることが示唆された。\n\", sep=\"\" ) else\n");
            rcmArray.push("txt=paste(txt,tmp,\"現有の項目からは十分な信頼性をもつ尺度が構成されないことが示唆される。\n\", sep=\"\" )\n");
            rcmArray.push("\n");
            rcmArray.push("options(digits=5)\n");
            rcmArray.push("options(scipen=5)\n");
            rcmArray.push("#######################\n");
            rcmArray.push("#\n");
            rcmArray.push("#  尺度開発／項目分析\n");
            rcmArray.push("# (ベイズファクタ使用)\n");
            rcmArray.push("#\n");
            rcmArray.push("#######################\n");
            rcmArray.push("\n");
            rcmArray.push("tx1 # 信頼性係数／内部一貫性\n");
            rcmArray.push("\n");
            rcmArray.push("tx2 # 信頼性の検討\n");
            rcmArray.push("# 主因子解は反復主因子法による因子負荷量\n");
            rcmArray.push("# 逆転は事前設定によらず自動的に逆転される\n");
            rcmArray.push("# I-T相関のItemはTotalに含まれない（I-R相関）\n");
            rcmArray.push("\n");
            rcmArray.push("tx3 # 尺度合計のG-P分析（ベイズファクタ使用）\n");
            rcmArray.push("# BFの事前分布はCauchy分布(rscale=0.707)\n");
            rcmArray.push("# BF上段は「上位群Mean≠下位群Mean」の対比\n");
            rcmArray.push("# BF下段は「上位群Mean＝下位群Mean」の対比\n");
            rcmArray.push("\n");
            rcmArray.push("tx4 # 各項目のG-P分析（ベイズファクタ使用）\n");
            rcmArray.push("\n");
            rcmArray.push("tx5 # 相関行列\n");
            rcmArray.push("\n");
            rcmArray.push("tx6 # BFによる無相関検定\n");
            rcmArray.push("# 対角線の右上は「ρ≠0」の対比(BF10)\n");
            rcmArray.push("# 対角線の左下は「ρ＝0」の対比(BF01)\n");
            rcmArray.push("\n");
            rcmArray.push("tx9 # 基本統計量\n");
            rcmArray.push("# 基本統計量は素点計算値（逆転前の値）\n");
            rcmArray.push("\n");
            rcmArray.push("cat(txt) # 結果の書き方\n");
            rcmArray.push("\n");
            rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

            document.getElementById("RcmArea").value = rcmArray.join("");
        }());	//Ｒプログラムここまで

        document.getElementById("RltArea").focus();
    }
}
function changeItemTable() {
    var i, j, k;
    var htmArray = [];
    var Str = document.getElementById("DataArea").value;
    var wStr = "";

    wStr = Str.replace(/,/g, " ");
    wStr = wStr.replace(/\t/g, " ");
    wStr = wStr.replace(/\r\n/g, "\n");
    wStr = wStr + "\n";

    var count = 0;
    for (i = 0; i < wStr.length; i++) {
        if (wStr.charAt(i) == "\n") break;
        if (wStr.charAt(i) == " ") {
            count++;
        }
        if (wStr.charAt(i) == " " && wStr.charAt(i + 1) == "\n") {
            count = count - 1;
        }
    }

    if (Str != "") {
        LA = count + 1;
    } else {
        LA = 0;
    }

    var trCount = parseInt(LA / 10) + 1;
    if (LA % 10 == 0) trCount = trCount - 1;
    if (trCount == 0) trCount = 1;

    var LACount = 0;
    htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
    for (j = 0; j < trCount; j++) {
        htmArray.push("<tr>");
        for (i = 0; i < 10; i++) {
            htmArray.push("<td class=\"hyou_midashi_NF_title\">");
            if (LACount < LA) {
                htmArray.push("<input type=\"checkbox\" id=\"item" + (LACount + 1) + "\" name=\"item" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\" onclick=\"rv_keyClick(" + 1 + ",event," + (LACount + 1) + ");\"><label for=\"item" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
            } else {
                htmArray.push("　");
            }
            htmArray.push("</td>");
            LACount++;
        }
        htmArray.push("</tr>");
    }
    htmArray.push("</table>");

    document.getElementById("Item_table").innerHTML = htmArray.join("");
    htmArray = null;
}
function changeReverseTable() {
    var i, j, k;
    var htmArray = [];
    var Str = document.getElementById("DataArea").value;
    var wStr = "";

    wStr = Str.replace(/,/g, " ");
    wStr = wStr.replace(/\t/g, " ");
    wStr = wStr.replace(/\r\n/g, "\n");
    wStr = wStr + "\n";

    var count = 0;
    for (i = 0; i < wStr.length; i++) {
        if (wStr.charAt(i) == "\n") break;
        if (wStr.charAt(i) == " ") {
            count++;
        }
        if (wStr.charAt(i) == " " && wStr.charAt(i + 1) == "\n") {
            count = count - 1;
        }
    }

    if (Str != "") {
        LA = count + 1;
    } else {
        LA = 0;
    }

    var trCount = parseInt(LA / 10) + 1;
    if (LA % 10 == 0) trCount = trCount - 1;
    if (trCount == 0) trCount = 1;

    var LACount = 0;
    htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
    for (j = 0; j < trCount; j++) {
        htmArray.push("<tr>");
        for (i = 0; i < 10; i++) {
            htmArray.push("<td class=\"hyou_midashi_NF_title\">");
            if (LACount < LA) {
                htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" onclick=\"rv_keyClick(" + 2 + ",event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
            } else {
                htmArray.push("　");
            }
            htmArray.push("</td>");
            LACount++;
        }
        htmArray.push("</tr>");
    }
    htmArray.push("</table>");

    document.getElementById("Reverse_table").innerHTML = htmArray.join("");
    htmArray = null;
}
function changeReverseSetting() {
    var htmArray = [];

    htmArray.push("<div class=\"tateyoko\">");

    var thisBrowser = getBrowser();
    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("尺度の下限値：<input type=\"number\" class=\"text9\" id=\"x_min\" size=\"10\" maxlength=\"10\" min=\"0\"  max=\"100\" value=\"1\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\">");
        htmArray.push("　尺度の上限値：<input type=\"number\" class=\"text9\" id=\"x_max\" size=\"10\" maxlength=\"10\" min=\"1\"  max=\"100\" value=\"5\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\">");
    } else {
        htmArray.push("最小値：<select name=\"tate\" id=\"x_min\" class=\"tySelect\" size=\"1\" onchange=\"checkMinMaxValue();\">");
        htmArray.push("<option value=\"0\">1</option>");
        htmArray.push("<option value=\"1\" selected>1</option>");
        htmArray.push("<option value=\"2\">2</option>");
        htmArray.push("<option value=\"3\">3</option>");
        htmArray.push("<option value=\"4\">4</option>");
        htmArray.push("<option value=\"5\">5</option>");
        htmArray.push("<option value=\"6\">6</option>");
        htmArray.push("<option value=\"7\">7</option>");
        htmArray.push("<option value=\"8\">8</option>");
        htmArray.push("<option value=\"9\">9</option>");
        htmArray.push("<option value=\"10\">10</option>");
        htmArray.push("<option value=\"11\">11</option>");
        htmArray.push("<option value=\"12\">12</option>");
        htmArray.push("<option value=\"13\">13</option>");
        htmArray.push("<option value=\"14\">14</option>");
        htmArray.push("<option value=\"15\">15</option>");
        htmArray.push("<option value=\"16\">16</option>");
        htmArray.push("<option value=\"17\">17</option>");
        htmArray.push("<option value=\"18\">18</option>");
        htmArray.push("<option value=\"19\">19</option>");
        htmArray.push("</select>");
        htmArray.push("　最大値：<select name=\"yoko\" id=\"x_max\" class=\"tySelect\" size=\"1\" onchange=\"checkMinMaxValue();\">");
        htmArray.push("<option value=\"1\">1</option>");
        htmArray.push("<option value=\"2\">2</option>");
        htmArray.push("<option value=\"3\">3</option>");
        htmArray.push("<option value=\"4\">4</option>");
        htmArray.push("<option value=\"5\" selected>5</option>");
        htmArray.push("<option value=\"6\">6</option>");
        htmArray.push("<option value=\"7\">7</option>");
        htmArray.push("<option value=\"8\">8</option>");
        htmArray.push("<option value=\"9\">9</option>");
        htmArray.push("<option value=\"10\">10</option>");
        htmArray.push("<option value=\"11\">11</option>");
        htmArray.push("<option value=\"12\">12</option>");
        htmArray.push("<option value=\"13\">13</option>");
        htmArray.push("<option value=\"14\">14</option>");
        htmArray.push("<option value=\"15\">15</option>");
        htmArray.push("<option value=\"16\">16</option>");
        htmArray.push("<option value=\"17\">17</option>");
        htmArray.push("<option value=\"18\">18</option>");
        htmArray.push("<option value=\"19\">19</option>");
        htmArray.push("<option value=\"20\">20</option>");
        htmArray.push("</select>");
    }

    htmArray.push("</div>");

    document.getElementById("reverse_setting").innerHTML = htmArray.join("");
    htmArray = null;

}
function subCalc_reverse() {
    var i = 0;
    var result = "";

    var wMin = parseInt(document.getElementById("x_min").value, 10);
    var wMax = parseInt(document.getElementById("x_max").value, 10);

    var NN = countRowCol("DataArea")[0]; // 行数を取得
    var KK = countRowCol("DataArea")[1]; // 列数を取得

    var xx = new Array(NN);
    for (i = 0; i < NN; i++) {
        xx[i] = new Array(KK);
    }

    var DData = dataremake5("DataArea");
    DData = crDel(DData);
    var dd = [];
    dd = DData.split(" ");

    var ddCount = 0;
    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            xx[i][j] = parseFloat(dd[ddCount]);
            ddCount++;
        }
    }

    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            if (document.getElementById("x" + (j + 1)).checked) {
                xx[i][j] = (wMax + wMin) - xx[i][j];
            }
        }
    }

    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            result += xx[i][j] + " ";
        }
        result += "\n";
    }

    document.getElementById("DataArea").value = result;
}
function clearItemTable() {
    document.getElementById("Item_table").innerHTML = "";
}
function clearReverseTable() {
    document.getElementById("Reverse_table").innerHTML = "";
}
/**
 * [rv_keyClick shiftキーを押しながらチェックボックスをクリックすると全てのチェックを反転する]
 * @param  {event} event [Firefox IE用]
 * @param  {int} num   [クリックしたチェックボックスidの番号]
 */
function rv_keyClick(id, event, num) {
    //イベント処理
    var key_event = event || window.event; //Firefox IE用
    // var key_ctrl = (key_event.ctrlKey);
    var key_shift = (key_event.shiftKey);

    var _id = id;
    //キーに対応した処理
    if (key_shift) {
        var KK = countRowCol("DataArea")[1]; // 列数を取得

        for (var k = 0; k < KK; k++) {
            if (_id == 1) {
                document.getElementById("item" + (k + 1)).checked = !document.getElementById("item" + (k + 1)).checked;
            } else {
                document.getElementById("x" + (k + 1)).checked = !document.getElementById("x" + (k + 1)).checked;
            }
        }
        if (_id == 1) {
            document.getElementById("item" + num).checked = !document.getElementById("item" + num).checked;
        } else {
            document.getElementById("x" + num).checked = !document.getElementById("x" + num).checked;
        }
    }
}
function LoadResult() {
    var DData = document.getElementById("RltArea1").value;
    var rltData = [];
    rltData = DData.split("\n");

    var str = "";

    for (var i = 0; i < rltData.length; i++) {
        crDel(rltData[i]);
        if (rltData[i].substr(0, 1) !== "#") {
            if (rltData[i] !== "") {
                str += rltData[i] + "\n";
            }
        }
    }
    document.getElementById("DataArea").value = str;
}
function alphaCalc(data) {
    var i = 0;
    var j = 0;
    var k = 0;

    var NN = 0;
    var KK = 0;

    var DData = data;
    var dd = [];
    dd = DData.split(" ");

    NN = countRowCol("DataArea")[0]; // 行数を取得
    KK = countRowCol("DataArea")[1]; // 列数を取得

    var xx = new Array(NN);
    for (i = 0; i < NN; i++) {
        xx[i] = new Array(KK);
    }

    var ddCount = 0;
    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            xx[i][j] = parseFloat(dd[ddCount]);
            ddCount++;
        }
    }

    var checkNum = 0;
    for (j = 0; j < KK; j++) {
        if (document.getElementById("item" + (j + 1)).checked) {
            checkNum++;
        }
    }
    var Kcount = checkNum - 1;

    var N = []; //各項目の回答数
    var M = []; //平均
    var V = []; //分散
    var SD = []; //標準偏差
    var VS = []; //不偏分散
    var SDS = []; //不偏分散の標準偏差
    var Vsum = 0; //各項目の分散の合計
    var VSsum = 0; //各項目の分散の合計
    var AllSum = []; //各参加者別の全項目の合計
    var AllMean = 0; //全項目合計値の平均
    var AllV = 0; //全項目合計値の分散
    var AllVS = 0; //全項目合計値の不偏分散
    var AllSD = 0; //全項目合計値の標準偏差
    var AllSDS = 0; //全項目合計値の標準偏差
    var alpha = [];

    var S = 0;
    var SS = 0;

    for (j = 0; j < KK; j++) {
        //各項目の平均
        S = 0;
        for (i = 0; i < NN; i++) {
            if (!isNaN(xx[i][j])) {
                S = S + xx[i][j];
            }
        }
        M[j] = S / NN;

        //各項目の分散
        //各項目の標準偏差
        SS = 0;
        for (i = 0; i < NN; i++) {
            if (!isNaN(xx[i][j])) {
                SS = SS + Math.pow(M[j] - xx[i][j], 2);
            }
        }
        V[j] = SS / NN;
        VS[j] = SS / (NN - 1);
        SD[j] = Math.sqrt(V[j]);
        SDS[j] = Math.sqrt(VS[j]);
        // if (document.getElementById("x" + (j + 1)).checked) {
        //     Vsum = Vsum + VS[j];
        // }
    }

    // 項目を１つずつ削除するループ
    for (k = 0; k < KK; k++) {
        VSsum = 0;
        for (j = 0; j < KK; j++) {
            if (document.getElementById("item" + (j + 1)).checked) {
                if (j !== k) {
                    VSsum = VSsum + VS[j];
                }
            }
        }
        // console.log(Vsum);

        for (i = 0; i < NN; i++) {
            S = 0;
            for (j = 0; j < KK; j++) {
                if (document.getElementById("item" + (j + 1)).checked) {
                    if (j !== k) {
                        S = S + xx[i][j];
                    }
                }
            }
            AllSum[i] = S;
        }
        // console.log(AllSum);

        S = 0;
        for (i = 0; i < NN; i++) {
            S = S + AllSum[i];
        }
        AllMean = S / NN;

        SS = 0;
        for (i = 0; i < NN; i++) {
            SS = SS + Math.pow(AllMean - AllSum[i], 2);
        }
        AllV = SS / NN;
        AllVS = SS / (NN - 1);
        AllSDS = Math.sqrt(AllVS);

        alpha[k] = Kcount / (Kcount - 1) * (1 - VSsum / AllVS);

    } // 項目を１つずつ削除するループ

    return alpha;
}
function subCalc_gp(data) {
    var i = 0;
    var j = 0;
    var k = 0;

    var NN = countRowCol("DataArea")[0]; // 行数を取得
    var KK = countRowCol("DataArea")[1]; // 列数を取得

    var result = ""; //結果出力用
    var dataStr = ""; //加工後データ
    var t_test_result = "";
    var bar = "-----------------------------------------\n";
    var str = "";

    // var DData = dataremake5("DataArea");
    // DData = crDel(DData);
    var DData = data;
    var dd = [];
    dd = DData.split(" ");

    var xxx = new Array(NN);
    for (i = 0; i < NN; i++) {
        xxx[i] = new Array(KK);
    }

    var ddCount = 0;
    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            xxx[i][j] = parseFloat(dd[ddCount]);
            ddCount++;
        }
    }

    var total = [];
    for (i = 0; i < NN; i++) {
        total[i] = 0;
        for (j = 0; j < KK; j++) {
            if (document.getElementById("item" + (j + 1)).checked) {
                total[i] += xxx[i][j];
            }
        }
    }

    var totalNum = [];
    for (i = 0; i < NN; i++) {
        totalNum[i] = i;
    }

    var totalSort = total.concat();
    var tmp;
    for (var outer = 0; outer < totalSort.length - 1; outer++) {
        for (i = totalSort.length - 1; i > outer; i--) {
            if (totalSort[i] < totalSort[i - 1]) {
                tmp = totalSort[i];
                totalSort[i] = totalSort[i - 1];
                totalSort[i - 1] = tmp;

                tmp = totalNum[i];
                totalNum[i] = totalNum[i - 1];
                totalNum[i - 1] = tmp;
            }
        }
    }

    var cutValue = parseFloat(document.getElementById("cutpoint").value);
    var cutPoint = Math.floor(total.length / cutValue);
    var lowCutNum = cutPoint - 1;
    var highCutNum = NN - cutPoint;

    //中位群に同値があったら，上位群・下位群に含める
    var startTmp = lowCutNum;
    for (i = startTmp + 1; i < NN - 1; i++) {
        if (totalSort[lowCutNum] === totalSort[i]) {
            lowCutNum++;
        }
    }
    startTmp = highCutNum;
    for (i = startTmp - 1; i > -1; i--) {
        if (totalSort[highCutNum] === totalSort[i]) {
            highCutNum--;
        }
    }

    var lowArray = totalSort.slice(0, lowCutNum + 1);
    var highArray = totalSort.slice(-(NN - highCutNum));

    //上位群と下位群に同値があったら，各群から削除する
    var temp = highArray[0];
    if (lowArray[lowArray.length - 1] == highArray[0]) {
        lowArray = lowArray.filter(x => x !== temp);
        highArray = highArray.filter(x => x !== temp);
    }

    var lowNumArray = totalNum.slice(0, lowArray.length);
    var highNumArray = totalNum.slice(-highArray.length);

    //加工後データ
    var group = Array(NN).fill("・");
    for (i = 0; i < lowNumArray.length; i++) {
        group[lowNumArray[i]] = "▼";
    }
    for (i = 0; i < highNumArray.length; i++) {
        group[highNumArray[i]] = "△";
    }

    dataStr = " No.\t群";
    for (j = 0; j < KK; j++) {
        if (document.getElementById("item" + (j + 1)).checked) {
            dataStr += "\tItem" + (j + 1);
        }
    }
    dataStr += "\tTotal\n";
    dataStr += bar;

    //入力順にデータ出力
    // for (i = 0; i < NN; i++) {
    //     dataStr += (i + 1) + "\t" + group[i];
    //     for (j = 0; j < KK; j++) {
    //         if (document.getElementById("item" + (j + 1)).checked) {
    //             dataStr += "\t" + xxx[i][j];
    //         }
    //     }
    //     dataStr += "\t" + total[i] + "\n";
    // }

    //降順にデータ出力
    for (i = NN - 1; i > -1; i--) {
        dataStr += (totalNum[i] + 1) + "\t" + group[totalNum[i]];
        for (j = 0; j < KK; j++) {
            if (document.getElementById("item" + (j + 1)).checked) {
                dataStr += "\t" + xxx[totalNum[i]][j];
            }
        }
        dataStr += "\t" + total[totalNum[i]] + "\n";
    }
    dataStr += bar;
    dataStr += "△上位群，▼下位群，・中位群\n";

    document.getElementById("RltArea2").value = dataStr;

    //合計得点の検定
    result = "\n\n［Ｇ—Ｐ分析／弁別力の検討］\n\n";
    result += "群のサイズの初期設定 = " + (100 / cutValue).toFixed(0) + "%\n\n";
    var result2 = bar;
    result2 += "Total\t    n\t       Mean\tS.D.\n";
    result2 += bar;
    result2 += t_test(lowArray, highArray)[0];
    result2 += "\n";

    t_test_result = "Total" + "\t" + t_test(lowArray, highArray)[1];

    // gp_graph(lowArray, highArray);
    gp_graph(highArray, lowArray, "Total", 0);

    for (j = 0; j < KK; j++) {
        if (document.getElementById("item" + (j + 1)).checked) {
            for (i = 0; i < lowNumArray.length; i++) {
                lowArray[i] = xxx[lowNumArray[i]][j];
            }
            for (i = 0; i < highNumArray.length; i++) {
                highArray[i] = xxx[highNumArray[i]][j];
            }
            result2 += bar;
            result2 += "Item" + String(j + 1).padStart(2, '0') + "\t    n\t       Mean\tS.D.\n";
            result2 += bar;
            result2 += t_test(lowArray, highArray)[0];

            t_test_result += "Item" + String(j + 1).padStart(2, '0') + "\t" + t_test(lowArray, highArray)[1];
            result2 += "\n";

            gp_graph(highArray, lowArray, "Item" + String(j + 1).padStart(2, '0'), 1);

        } else {
            t_test_result += "Item" + String(j + 1).padStart(2, '0') + "\t----------------------------\n";
        }

    }
    result += "= 合計得点と各項目の検定結果(Welch's t-Test) = \n";
    result += bar;
    result += t_test_result;
    result += bar + "\n";
    result += result2;

    document.getElementById("RltArea1").value += result;
    strArray = null;

    // var RltAreaObj = document.getElementById("RltArea2");
    // RltAreaObj.focus();
    // RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
    // RltAreaObj.scrollTop = 0;
}
function t_test(ary1, ary2) {
    var array1 = ary1.concat();
    var array2 = ary2.concat();

    //データ全体の行数（全参加者数）
    var All_N = countRowCol("DataArea")[0];

    var AA = "A";
    var LA = 2;
    var NNN = [];

    NNN[0] = array1.length;
    NNN[1] = array2.length;
    var NX = Math.max(...NNN);

    var xx = [array1, array2];

    var M = new Array(NX); //平均
    var V = []; //分散
    var SD = []; //標準偏差
    var VS = []; //不偏分散
    var SDS = []; //不偏分散の平方根

    var D_M = 0; //水準１と水準２の差の平均
    var D_S2 = 0; //水準１と水準２の差の分散
    var D_SD = 0; //水準１と水準２の差の標準偏差

    //平均・標準偏差
    var strArray = [];
    var bar = "-----------------------------------------\n";

    var S = 0;
    var SS = 0;
    var group = ["下位群", "上位群"];
    var N_parcent = [];

    for (i = LA - 1; i > -1; i--) {
        S = 0;
        SS = 0;
        for (j = 0; j < NNN[i]; j++) {
            S += xx[i][j];
            SS += Math.pow(xx[i][j], 2);
        }
        M[i] = S / NNN[i];
        V[i] = SS / NNN[i] - Math.pow(M[i], 2);
        SD[i] = Math.sqrt(V[i]);

        //出力のSDを不偏分散の平方根に統一するための計算
        VS[i] = V[i] * NNN[i] / (NNN[i] - 1);
        SDS[i] = Math.sqrt(VS[i]);

        N_parcent[i] = (NNN[i] / All_N) * 100;

        strArray.push((group[i] + "\t" + NNN[i] + " (" + N_parcent[i].toFixed(2) + "%) " + "\t" + M[i].toFixed(2) + "\t" + SDS[i].toFixed(2) + '\n'));
    }
    strArray.push(bar);

    //T値
    //ｔ値を求めるのは分散を使う
    var T = Math.abs(M[0] - M[1]) / Math.sqrt(V[0] / (NNN[0] - 1) + V[1] / (NNN[1] - 1));
    T = Math.round(T * 10000) / 10000;

    //自由度
    var wC = (V[0] / (NNN[0] - 1)) / (V[0] / (NNN[0] - 1) + V[1] / (NNN[1] - 1));
    var DF = (NNN[0] - 1) * (NNN[1] - 1) / ((NNN[0] - 1) * Math.pow(1 - wC, 2) + (NNN[1] - 1) * Math.pow(wC, 2));
    DF = Math.floor(DF);

    var PP2 = t_table(DF, T);

    var ppStr = "";
    if (PP2 === 0.01) {
        ppStr = "   ** (p<.01)";
    }
    if (PP2 === 0.05) {
        ppStr = "   *  (p<.05)";
    }
    if (PP2 === 0.10) {
        ppStr = "   +  (.05<p<.10)";
    }
    if (PP2 === 1) {
        ppStr = "   ns (.10<p)";
    }

    //上位群と下位群の平均が逆転していた場合
    var reverseStr1 = "";
    var reverseStr2 = "";
    if (M[0] - M[1] > 0) {
        reverseStr1 = "　※上位・下位群が逆転しています。\n";
        reverseStr2 = "　※上位・下位群が逆転しています。";
    }

    strArray.push(" t(" + DF + ")= " + T + " , " + ppStr + "\n" + reverseStr1);

    var t_test_result = " t(" + DF + ")= " + T + " , " + ppStr + reverseStr2 + "\n";
    // strArray.push((t_test_result));

    var str = strArray.join("");
    strArray = null;



    return [str, t_test_result];

    // str += 'x' + (k + 1) + ' : t(' + DF + ')= ' + T + ' ,\t' + ppStr + '\n';

}
function gp_graph(ary1, ary2, title, color) {
    var array1 = ary1.concat();
    var array2 = ary2.concat();

    //データ全体の行数（全参加者数）
    var All_N = countRowCol("DataArea")[0];
    var KK = countRowCol("DataArea")[1]; // 列数を取得

    var AA = "A";
    var LA = 2;
    var NNN = [];

    NNN[0] = array1.length;
    NNN[1] = array2.length;
    var NX = Math.max(...NNN);

    var xx = [array1, array2];

    var M = new Array(NX); //平均
    var V = []; //分散
    var SD = []; //標準偏差
    var VS = []; //不偏分散
    var SDS = []; //不偏分散の平方根

    var D_M = 0; //水準１と水準２の差の平均
    var D_S2 = 0; //水準１と水準２の差の分散
    var D_SD = 0; //水準１と水準２の差の標準偏差

    //平均・標準偏差
    var S = 0;
    var SS = 0;
    var N_parcent = [];

    for (i = LA - 1; i > -1; i--) {
        S = 0;
        SS = 0;
        for (j = 0; j < NNN[i]; j++) {
            S += xx[i][j];
            SS += Math.pow(xx[i][j], 2);
        }
        M[i] = S / NNN[i];
        V[i] = SS / NNN[i] - Math.pow(M[i], 2);
        SD[i] = Math.sqrt(V[i]);

        //出力のSDを不偏分散の平方根に統一するための計算
        VS[i] = V[i] * NNN[i] / (NNN[i] - 1);
        SDS[i] = Math.sqrt(VS[i]);

        N_parcent[i] = (NNN[i] / All_N) * 100;
    }

    //グラフ描画
    var i;
    var chartImg = document.createElement('canvas');
    chartImg.id = "ChartImg" + chartNum;
    var ctx = document.getElementById("chart").appendChild(chartImg);

    var data = [];
    for (i = 0; i < LA; i++) {
        data[i] = parseFloat(M[i].toFixed(1), 10);
    }

    var max_y = 0;
    var min_y = 0;
    if (title == "Total") {
        max_y = parseInt(document.getElementById("x_max").value, 10) * KK;
    } else {
        max_y = parseInt(document.getElementById("x_max").value, 10);
    }

    //カラーユニバーサルデザイン推奨配色セット制作委員会
    //https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
    var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

    var datasetKey = [];
    for (i = 0; i < 1; i++) {
        datasetKey[i] = [];
    }
    for (i = 0; i < 1; i++) {
        datasetKey[i].label = '群';
        datasetKey[i].data = data;
        // datasetKey[i].backgroundColor = chartClrAry[i % chartClrAry.length];
        // datasetKey[i].borderColor = chartClrAry[i % chartClrAry.length];
        datasetKey[i].backgroundColor = chartClrAry[color];
        datasetKey[i].borderColor = chartClrAry[color];

        datasetKey[i].pointBorderWidth = 3;
        datasetKey[i].borderWidth = 1;
        datasetKey[i].lineTension = 0;
    }

    var labelData = [];
    labelData.push('上位群');
    labelData.push('下位群');

    var datasetData = [];
    for (i = 0; i < 1; i++) {
        datasetData[i] = datasetKey[i];
    }

    var myChart = new Chart(ctx, {
        type: 'bar',
        data: {
            labels: labelData,
            datasets: datasetData
        },
        options: {
            scales: {
                xAxes: [{
                    maxBarThickness: 30,
                    ticks: {
                    }
                }],
                yAxes: [{
                    ticks: {
                        suggestedMin: min_y,
                        suggestedMax: max_y
                    }
                }]
            },
            legend: {
                position: 'right'
            },
            title: {
                display: true,
                text: title + ' (Mean)'
            }
        }
    });

    //箱ひげ図
    var addData = [];
    var myData = [];
    var arrayCol = [];
    for (i = 0; i < LA; i++) {
        arrayCol = [];
        for (j = 0; j < NNN[i]; j++) {
            arrayCol.push(xx[i][j]);
        }
        myData.push(arrayCol);
    }

    chartNum++;

    chartImg = document.createElement('canvas');
    chartImg.id = "ChartImg" + chartNum;
    ctx = document.getElementById("chart").appendChild(chartImg);

    var boxplotData = {
        labels: labelData,
        datasets: [{
            label: '群',
            backgroundColor: chartClrAry[color] + '33',
            borderColor: chartClrAry[color],
            borderWidth: 1,
            padding: 10,
            outlierRadius: 3,
            itemRadius: 3,
            outlierColor: '#999999',
            data: myData
        }]
    };

    var myChart2 = new Chart(ctx, {
        type: 'boxplot',
        data: boxplotData,
        options: {
            responsive: true,
            scales: {
                yAxes: [{
                    ticks: {
                        suggestedMin: min_y,
                        suggestedMax: max_y
                    }
                }]
            },
            legend: {
                position: 'right',
            },
            title: {
                display: true,
                text: title + ' (Boxplot)'
            }
        }
    });

    chartNum++;
}
function subCalc_corr(data, tmpR) {
    var i = 0;
    var j = 0;
    var k = 0;

    var NN = countRowCol("DataArea")[0]; // 行数を取得
    var KK = countRowCol("DataArea")[1]; // 列数を取得

    var strArray = [];
    var bar = "--------------------------------------\n";
    var diaArray = [];
    var rcmArray = [];
    var rcmArray1 = [];
    var rcmArray2 = [];

    var DData = data;
    var dd = [];
    dd = DData.split(" ");

    var xx = new Array(NN);
    for (i = 0; i < NN; i++) {
        xx[i] = new Array(KK);
    }

    var ddCount = 0;
    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            xx[i][j] = parseFloat(dd[ddCount]);
            ddCount++;
        }
    }

    var M = [];
    var SD = [];
    var MA = [];
    var MI = [];

    //基本統計量
    strArray.push("\n［相関係数の計算と検定］\n");

    var S = 0;
    var SS = 0;
    for (j = 0; j < KK; j++) {
        S = 0;
        SS = 0;
        MA[j] = xx[0][j];
        MI[j] = xx[0][j];

        for (i = 0; i < NN; i++) {
            S += xx[i][j];
            SS += Math.pow(xx[i][j], 2);

            if (MA[j] < xx[i][j]) MA[j] = xx[i][j];
            if (MI[j] > xx[i][j]) MI[j] = xx[i][j];
        }

        M[j] = S / NN;
        SD[j] = Math.sqrt(SS / NN - Math.pow(M[j], 2));

    }

    var R = new Array(KK);
    for (j = 0; j < KK; j++) {
        R[j] = new Array(KK);
    }

    var FF = new Array(KK);
    for (j = 0; j < KK; j++) {
        FF[j] = new Array(KK);
    }

    var F$ = new Array(KK);
    for (j = 0; j < KK; j++) {
        F$[j] = new Array(KK);
    }

    var lineWidth = new Array(KK);
    for (j = 0; j < KK; j++) {
        lineWidth[j] = new Array(KK);
    }

    var corrStr = new Array(KK);
    for (j = 0; j < KK; j++) {
        corrStr[j] = new Array(KK);
    }

    var FF1, FF2, FF3;

    var tmpFF = [];
    var tmpF$ = [];
    for (j = 0; j < KK; j++) {
        if (tmpR[j] > 0.9999) {
            tmpFF[j] = 999.99;
        } else {
            if (Math.pow(tmpR[j], 2) == 1) {
                tmpFF[j] = 0;
            } else {
                tmpFF[j] = Math.pow(tmpR[j], 2) / (1 - Math.pow(tmpR[j], 2)) * (NN - 2);
            }
        }

        FF3 = f_tables(2, NN); //１％水準
        FF2 = f_tables(1, NN); //５％水準
        FF1 = f_tables(0, NN); //１０％水準

        if (NN > 2) {
            if (tmpFF[j] > FF3) { //１％水準
                tmpF$[j] = "**";
                // if (Math.abs(R[j][jj]) >= 0.9) {
                //     lineWidth[j][jj] = 8;
                //     corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には非常強い関連があります。\n";
                // } else if (Math.abs(R[j][jj]) >= 0.7) {
                //     lineWidth[j][jj] = 6;
                //     corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には強い関連があります。\n";
                // } else if (Math.abs(R[j][jj]) >= 0.4) {
                //     lineWidth[j][jj] = 4;
                //     corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には中程度の関連があります。\n";
                // } else if (Math.abs(R[j][jj]) >= 0.3) {
                //     lineWidth[j][jj] = 2;
                //     corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には弱い関連があります。\n";
                // } else {
                //     lineWidth[j][jj] = 1;
                //     corrStr[j][jj] = "";
                // }
            } else if (tmpFF[j] > FF2) { //５％水準
                tmpF$[j] = " *";
                // if (Math.abs(R[j][jj]) >= 0.9) {
                //     // lineWidth[j][jj] = 8;
                //     // corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には非常強い関連があります。\n";
                // } else if (Math.abs(R[j][jj]) >= 0.7) {
                //     // lineWidth[j][jj] = 6;
                //     // corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には強い関連があります。\n";
                // } else if (Math.abs(R[j][jj]) >= 0.4) {
                //     // lineWidth[j][jj] = 4;
                //     // corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には中程度の関連があります。\n";
                // } else if (Math.abs(R[j][jj]) >= 0.3) {
                //     // lineWidth[j][jj] = 2;
                //     // corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には弱い関連があります。\n";
                // } else {
                //     // lineWidth[j][jj] = 1;
                //     // corrStr[j][jj] = "";
                // }
            } else if (tmpFF[j] > FF1) { //１０％水準
                tmpF$[j] = " +";
                // lineWidth[j][jj] = 1;
                // corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "は弱く関連する可能性があります。\n";
            } else {
                tmpF$[j] = "ns";
                // lineWidth[j][jj] = 0;
                // corrStr[j][jj] = "";
            }
        } else {
            tmpF$[j] = "ns";
            // lineWidth[j][jj] = 0;
            // corrStr[j][jj] = "";
        }
    }


    S = 0;
    for (j = 0; j < KK - 1; j++) {
        for (jj = j + 1; jj < KK; jj++) {
            S = 0;
            for (i = 0; i < NN; i++) {
                S += (xx[i][j] - M[j]) * (xx[i][jj] - M[jj]);
            }
            R[j][jj] = S / NN / SD[j] / SD[jj];
            if (R[j][jj] > 0.9999) {
                FF[j][jj] = 999.99;
            } else {
                if (Math.pow(R[j][jj], 2) == 1) {
                    FF[j][jj] = 0;
                } else {
                    FF[j][jj] = Math.pow(R[j][jj], 2) / (1 - Math.pow(R[j][jj], 2)) * (NN - 2);
                }
            }

            FF3 = f_tables(2, NN); //１％水準
            FF2 = f_tables(1, NN); //５％水準
            FF1 = f_tables(0, NN); //１０％水準

            if (NN > 2) {
                if (FF[j][jj] > FF3) { //１％水準
                    F$[j][jj] = "**";
                    if (Math.abs(R[j][jj]) >= 0.9) {
                        lineWidth[j][jj] = 8;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には非常強い関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.7) {
                        lineWidth[j][jj] = 6;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には強い関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.4) {
                        lineWidth[j][jj] = 4;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には中程度の関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.3) {
                        lineWidth[j][jj] = 2;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には弱い関連があります。\n";
                    } else {
                        lineWidth[j][jj] = 1;
                        corrStr[j][jj] = "";
                    }
                } else if (FF[j][jj] > FF2) { //５％水準
                    F$[j][jj] = " *";
                    if (Math.abs(R[j][jj]) >= 0.9) {
                        lineWidth[j][jj] = 8;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には非常強い関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.7) {
                        lineWidth[j][jj] = 6;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には強い関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.4) {
                        lineWidth[j][jj] = 4;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には中程度の関連があります。\n";
                    } else if (Math.abs(R[j][jj]) >= 0.3) {
                        lineWidth[j][jj] = 2;
                        corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には弱い関連があります。\n";
                    } else {
                        lineWidth[j][jj] = 1;
                        corrStr[j][jj] = "";
                    }
                } else if (FF[j][jj] > FF1) { //１０％水準
                    F$[j][jj] = " +";
                    lineWidth[j][jj] = 1;
                    corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "は弱く関連する可能性があります。\n";
                } else {
                    F$[j][jj] = "ns";
                    lineWidth[j][jj] = 0;
                    corrStr[j][jj] = "";
                }
            } else {
                F$[j][jj] = "ns";
                lineWidth[j][jj] = 0;
                corrStr[j][jj] = "";
            }
        }
    }
    strArray.push("\n= Correlation Matrix =\n");
    strArray.push("  df= 1 & " + (NN - 2) + "\n");

    var diagramData = KK + "\n";
    var wStr = "";

    strArray.push(bar);
    strArray.push("\tTotal");
    for (j = 0; j < KK; j++) {
        strArray.push("\tItem" + String(j + 1).padStart(2, '0'));
    }
    strArray.push("\n");
    strArray.push(bar);

    strArray.push("Total\t-");
    for (j = 0; j < KK; j++) {
        if (document.getElementById("item" + (j + 1)).checked) {
            strArray.push("\t" + using(tmpR[j], 2, 3) + " " + tmpF$[j]);
        } else {
            strArray.push("\t-----");
        }
    }
    strArray.push("\n");

    for (j = 0; j < KK; j++) {
        strArray.push("Item" + String(j + 1).padStart(2, '0') + "\t");
        for (jj = 0; jj < j + 1; jj++) {
            strArray.push("\t");
        }
        strArray.push("-");
        for (jj = j + 1; jj < KK; jj++) {
            strArray.push("\t" + using(R[j][jj], 2, 3) + " " + F$[j][jj]);
        }
        strArray.push("\n");
    }

    strArray.push("\n= Test of Correlation =\n");
    strArray.push(bar);
    strArray.push("\t\tr\tF\tTest\n");
    strArray.push(bar);
    for (j = 0; j < KK; j++) {
        strArray.push("Total" + "x" + String(j + 1).padStart(2, '0') + "\t");
        strArray.push(using(tmpR[j], 2, 3) + "\t" + using(tmpFF[j], 3, 2) + "\t" + tmpF$[j] + "\n");
    }

    for (j = 0; j < KK - 1; j++) {
        strArray.push(bar);
        strArray.push("\t\tr\tF\tTest\n");
        strArray.push(bar);
        for (jj = j + 1; jj < KK; jj++) {
            strArray.push("Item" + String(j + 1).padStart(2, '0') + "x" + String(jj + 1).padStart(2, '0') + "\t");
            strArray.push(using(R[j][jj], 2, 3) + "\t" + using(FF[j][jj], 3, 2) + "\t" + F$[j][jj] + "\n");
            if (lineWidth[j][jj] != 0) {
                diagramData += (j + 1) + "," + (jj + 1) + "," + using(R[j][jj], 2, 3) + "," + lineWidth[j][jj] + "\n";
            }
            if (corrStr[j][jj] != "") {
                wStr += corrStr[j][jj];
            }
        }
    }

    strArray.push("\n" + bar + "\n" + wStr);

    strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

    // ダイアグラム出力
    document.getElementById("corrDiaArea").value = diagramData;
    corrDiaDraw();

    //グラフの設定
    // var gCheck = document.getElementById("RltArea").value;
    // gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

    document.getElementById("RltArea1").value += strArray.join("");
    strArray = null;

    // //グラフ描画
    // (function () {
    //     chartClear();

    //     var i, j, jj;

    //     //軸の最大値と最小値の設定
    //     var max = xx[0][0];
    //     var min = xx[0][0];
    //     for (i = 0; i < NN; i++) {
    //         for (j = 0; j < KK; j++) {
    //             if (max < xx[i][j]) max = xx[i][j];
    //             if (min > xx[i][j]) min = xx[i][j];
    //         }
    //     }

    //     var _myMax = gCheck.match(/max:\d+/);
    //     if (_myMax !== null) {
    //         var myMax = _myMax[0].match(/\d+/);
    //         max = parseFloat(myMax, 10);
    //     }
    //     var _myMin = gCheck.match(/min:\d+/);
    //     if (_myMin !== null) {
    //         var myMin = _myMin[0].match(/\d+/);
    //         min = parseFloat(myMin, 10);
    //     }

    //     //カラーユニバーサルデザイン推奨配色セット制作委員会
    //     //https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
    //     // var chartClrAry = ["#ff4b00", "#fff100", "#03af7a", "#005aff", "#4dc4ff", "#ff8082", "#f6aa00", "#990099", "#804000"];
    //     var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

    //     var titleText;

    //     var chartNum = 0;
    //     for (j = 0; j < KK - 1; j++) {
    //         for (jj = j + 1; jj < KK; jj++) {

    //             var chartImg = document.createElement('canvas');
    //             chartImg.id = "ChartImg" + chartNum;
    //             var ctx = document.getElementById("chart").appendChild(chartImg);

    //             var data = [];
    //             for (i = 0; i < NN; i++) {
    //                 addData = { x: xx[i][j], y: xx[i][jj] };
    //                 data.push(addData);
    //             }

    //             titleText = 'A' + (j + 1) + ':A' + (jj + 1);

    //             var datasetData = [{
    //                 backgroundColor: chartClrAry[chartNum % chartClrAry.length],
    //                 borderColor: chartClrAry[chartNum % chartClrAry.length],
    //                 pointBorderWidth: 3,
    //                 borderWidth: 1,
    //                 lineTension: 0,
    //                 data: data
    //             }];
    //             chartNum++;

    //             var myChart = new Chart(ctx, {
    //                 type: 'scatter',
    //                 data: {
    //                     datasets: datasetData
    //                 },
    //                 options: {
    //                     title: {
    //                         display: true,
    //                         text: titleText,
    //                         position: 'top',
    //                         fontSize: 12,
    //                         fontColor: '#000000'
    //                     },
    //                     scales: {
    //                         xAxes: [{
    //                             ticks: {
    //                                 suggestedMin: min,
    //                                 suggestedMax: max
    //                             }
    //                         }],
    //                         yAxes: [{
    //                             ticks: {
    //                                 suggestedMin: min,
    //                                 suggestedMax: max
    //                             }
    //                         }]
    //                     },
    //                     legend: {
    //                         display: false
    //                     },
    //                     tooltips: {
    //                         mode: 'label'
    //                     },
    //                 }
    //             });
    //         }
    //     }
    // }());	//グラフ描画ここまで

}
function corrDiaDraw() {
    var i = 0;
    var j = 0;
    var jj = 0;

    var canvas = document.getElementById("DiaCanvas");
    // var canvas = document.getElementById("corrDiaCanvas");
    if (!canvas || !canvas.getContext) {
        return false;
    }

    if (document.getElementById("corrDiaArea").value != "") {
        var diaData = document.getElementById("corrDiaArea").value;
        var rowStr = diaData.split("\n");

        //項目数
        var KK = parseInt(rowStr[0], 10);

        var columStr = [];
        var k1 = [];
        var k2 = [];
        var r = [];
        var lineWidth = [];

        for (i = 1; i < rowStr.length - 1; i++) {
            columStr = rowStr[i].split(",");
            k1[i] = parseInt(columStr[0], 10);        //項目１
            k2[i] = parseInt(columStr[1], 10);        //項目２
            r[i] = parseFloat(columStr[2]);          //相関係数
            lineWidth[i] = parseInt(columStr[3], 10); //線幅
        }

        var ctx = canvas.getContext('2d');

        //canvasを白で塗りつぶし
        ctx.beginPath();
        ctx.fillStyle = 'rgb(255,255,255)';
        ctx.fillRect(0, 0, 550, 450);

        // ダイアグラムの中心の座標
        var x1 = 275;
        var y1 = 200;

        // 項目番号0の座標
        var x2 = 275;
        var y2 = 30;

        // 項目番号の座標
        // var tx = 0;
        // var ty = 0;
        var tx = [];
        var ty = [];

        ctx.lineWidth = 1;

        var xx = [];
        var yy = [];

        var t = 0; //角度
        for (j = 0; j < KK; j++) {
            t = Math.PI / 180 * j * (360 / KK);
            xx[j] = Math.ceil((x2 - x1) * Math.cos(t) - (y2 - y1) * Math.sin(t)) + x1;
            yy[j] = Math.ceil((x2 - x1) * Math.sin(t) + (y2 - y1) * Math.cos(t)) + y1;
        }

        for (j = 0; j < KK; j++) {
            t = Math.PI / 180 * j * (360 / KK);
            tx[j] = Math.ceil((x2 - x1) * Math.cos(t) - (y2 - y1) * Math.sin(t)) + x1 - 4;
            ty[j] = Math.ceil((x2 - x1) * Math.sin(t) + (y2 - y1) * Math.cos(t)) + y1 + 4;
        }

        var diaPointNum = parseInt(document.getElementById("diaPointNum").value, 10);
        if (diaPointNum == 0) {
            for (i = 1; i < rowStr.length - 1; i++) {
                // 線種 線幅=1 ならば 破線
                if (lineWidth[i] == 1) {
                    ctx.setLineDash([3, 3]); //破線
                } else {
                    ctx.setLineDash([]); //実線
                }

                if (r[i] > 0) {
                    // 相関係数>0 ならば 赤
                    ctx.strokeStyle = 'rgb(255,0,0)';
                } else {
                    // 相関係数<=0 ならば 青
                    ctx.strokeStyle = 'rgb(0,0,255)';
                }
                ctx.lineWidth = lineWidth[i];
                ctx.beginPath();
                ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
                ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
                ctx.stroke();
            }
        } else {
            // グレーで描画
            for (i = 1; i < rowStr.length - 1; i++) {
                // 線種 線幅=1 ならば 破線
                if (lineWidth[i] == 1) {
                    ctx.setLineDash([3, 3]); //破線
                } else {
                    ctx.setLineDash([]); //実線
                }
                ctx.strokeStyle = 'rgb(169,169,169)';
                ctx.lineWidth = lineWidth[i];
                ctx.beginPath();
                ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
                ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
                ctx.stroke();
            }

            for (i = 1; i < rowStr.length - 1; i++) {
                // 線種 線幅=1 ならば 破線
                if (lineWidth[i] == 1) {
                    ctx.setLineDash([3, 3]); //破線
                } else {
                    ctx.setLineDash([]); //実線
                }

                if (r[i] > 0) {
                    // 相関係数>0 ならば 赤
                    if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
                        ctx.strokeStyle = 'rgb(255,0,0)';
                    }
                } else {
                    // 相関係数<=0 ならば 青
                    if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
                        ctx.strokeStyle = 'rgb(0,0,255)';
                    }
                }

                if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
                    ctx.lineWidth = lineWidth[i];
                    ctx.beginPath();
                    ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
                    ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
                    ctx.stroke();
                }
            }
        }

        var wr = 10;
        //項目を示す○を描く（白で塗りつぶし）
        ctx.lineWidth = 1;
        ctx.setLineDash([]); //実線
        ctx.fillStyle = 'rgb(255,255,255)';
        for (j = 0; j < KK; j++) {
            ctx.beginPath();
            ctx.arc(xx[j], yy[j], wr, 0, Math.PI * 2, false);
            ctx.fill();
        }
        //項目を示す○を描く（線を黒く）
        ctx.lineWidth = 1;
        ctx.setLineDash([]); //実線
        ctx.strokeStyle = 'rgb(0,0,0)';
        for (j = 0; j < KK; j++) {
            ctx.beginPath();
            ctx.arc(xx[j], yy[j], wr, 0, Math.PI * 2, false);
            ctx.stroke();
        }

        ctx.lineWidth = 1;
        ctx.setLineDash([]); //実線
        ctx.font = "14px 'Times New Roman'";
        ctx.strokeStyle = 'rgb(0,0,0)';
        ctx.fillStyle = "rgb(0,0,0)";
        for (j = 0; j < KK; j++) {
            ctx.strokeText(j + 1, tx[j], ty[j]);
        }


        if (diaPointNum != 0) {
            //項目を示す○を描く（白で塗りつぶし）
            ctx.lineWidth = 1;
            ctx.setLineDash([]); //実線
            ctx.fillStyle = 'rgb(0,0,0)';
            ctx.beginPath();
            ctx.arc(xx[diaPointNum - 1], yy[diaPointNum - 1], wr, 0, Math.PI * 2, false);
            ctx.fill();
            //項目を示す○を描く（線を黒く）
            ctx.lineWidth = 1;
            ctx.setLineDash([]); //実線
            ctx.strokeStyle = 'rgb(0,0,0)';
            ctx.beginPath();
            ctx.arc(xx[diaPointNum - 1], yy[diaPointNum - 1], wr, 0, Math.PI * 2, false);
            ctx.stroke();

            ctx.lineWidth = 1;
            ctx.setLineDash([]); //実線
            ctx.font = "14px 'Times New Roman'";
            ctx.strokeStyle = 'rgb(255,255,255)';
            ctx.fillStyle = "rgb(255,255,255)";
            ctx.strokeText(diaPointNum, tx[diaPointNum - 1], ty[diaPointNum - 1]);
        }
    }

}
function simulation_scale(event) {
    var key_event = event || window.event; //Firefox IE用
    var key_shift = (key_event.shiftKey);

    var NN = 50; // 行数
    var KK; // 列数

    var min = 2;
    var max = 8;
    KK = Math.floor(Math.random() * (max - min + 1) + min);

    var result = "rnd1:5*" + NN + "*" + KK;

    document.getElementById("DataArea").value = random_number_generation(result);
}
