/**
 * 分散分析
 * サイン検定（２水準の対応データ）
 *
 *
 *
 */
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();

    //フォームを作成
    changeSaSetting();
    // デフォルトのタブを選択
    ChangeTab(1, 4);

    //コピペエリアにドラッグ＆ドロップを設定
    setDragAndDrop();

    document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
    var i = 0;

    var NN = parseInt(document.getElementById("subjNum").value, 10);
    // var LA = parseInt(document.getElementById("factorA_number").value);
    var LA = 2;

    var elmCount = NN * LA;

    var result = confirm("データを消去します");
    if (result === true) {
        document.getElementById("factorA_name").value = "A";
        for (i = 0; i < elmCount; i++) {
            document.getElementById("cell_" + (i + 1)).value = "";
        }
        errorClearCell(elmCount, "");

        document.getElementById("CandPArea").value = "";
        inputTextArea(document.getElementById("CandPArea"), 0);
        inputBtnTextClear(document.getElementById("inputBtn1"));
    }
    document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
    var i = 0;
    var NN = parseInt(document.getElementById("subjNum").value, 10);
    var LA = 2;
    var elmCount = NN * LA;

    var errorCellNum = 0;

    if (document.getElementById("CandPArea").value === "") {
        errorClearCell(elmCount, "");
        errorCell(elmCount, "");

        for (i = 0; i < elmCount; i++) {
            if (document.getElementById("cell_" + (i + 1)).value === "") {
                errorCellNum = i + 1;
            }
        }
        if (errorCellNum === 0) {
            errorClearCell(elmCount, "");
            mainCalc_sign1x2();
        } else {
            alert("すべての数値が入力されていません (^_^)ゞ");
            document.getElementById("cell_" + errorCellNum).focus();
        }
    } else {
        var DData = dataremake5("CandPArea");
        DData = crDel(DData);
        var dd = [];
        dd = DData.split(" ");
        if (elmCount != dd.length) {
            alert("データを確認してください");
        } else {
            copipe("CandPArea", "text");
            inputTextArea(document.getElementById("CandPArea"), 0);
            inputBtnTextClear(document.getElementById("inputBtn1"));
            checkCellData();
        }
    }
}
// メイン計算
function mainCalc_sign1x2() {
    var i = 0;
    var j = 0;
    var k = 0;

    var NN = parseInt(document.getElementById("subjNum").value, 10);
    var AA = document.getElementById("factorA_name").value;
    var LA = 2;

    AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
    if (AA === '') AA = "A";

    var xx = new Array(LA);
    for (i = 0; i < LA; i++) {
        xx[i] = new Array(NN);
    }

    var cellId = 1;
    if (document.getElementById("CandPArea").value === "") {
        for (j = 0; j < NN; j++) {
            for (i = 0; i < LA; i++) {
                xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
                cellId++;
            }
        }
    } else {
        var DData = document.getElementById("CandPArea").value;
        var dd = [];
        dd = DData.split(" ");

        var ddCount = 0;
        for (j = 0; j < NN; j++) {
            for (i = 0; i < LA; i++) {
                xx[i][j] = parseFloat(dd[ddCount]);
                ddCount++;
            }
        }
    }

    var DD1 = 0;
    var DD2 = 0;
    var DD3 = 0;

    var strArray = [];
    var bar = "------------------------------------------------\n";

    for (j = 0; j < NN; j++) {
        if (xx[1][j] - xx[0][j] > 0) DD1++;
        if (xx[1][j] - xx[0][j] < 0) DD2++;
        if (xx[1][j] - xx[0][j] === 0) DD3++;
    }
    NN = DD1 + DD2;

    var DS1 = (DD1 / NN).toFixed(4); //グラフに渡す値
    var DS2 = (DD2 / NN).toFixed(4);

    var effectSizeG = Math.abs(0.5000 - DS1);

    var PP2 = 0;   //両側確率
    var PP = 0;    //片側確率

    // var minD = Math.min(DD1, DD2);

    // for (i = 0; i < minD + 1; i++) {
    //     PP = PP + Math.exp(LogCombination(NN, i) + NN * Math.log(0.5));
    // }

    // PP2 = PP * 2;
    // if (PP2 >= 1) {
    //     PP2 = 0.9999;
    // }

    // var ppStr = "";
    // if (PP2 < 0.01) {
    //     ppStr = "   ** (p<.01)";
    // } else if (PP2 < 0.05) {
    //     ppStr = "   *  (p<.05)";
    // } else if (PP2 < 0.10) {
    //     ppStr = "   +  (.05<p<.10)";
    // } else {
    //     ppStr = "   ns (.10<p)";
    // }

    var minD = Math.min(DD1, DD2);

    var P = [];
    for (var R = 0; R < NN + 1; R++) {
        P[R] = Math.exp(LogCombination(NN, R) + R * Math.log(0.5) + (NN - R) * Math.log(0.5));
        // P[R] = Math.exp(LogCombination(NN, R) + R * Math.log(母比率１) + (NN - R) * Math.log(母比率２));
    }

    //ベイズファクタの計算
    var ds = P[DD1]; //帰無仮説の事後の的中確率：観測値１の偶然確率
    var BF = 1 / (NN + 1) / ds;

    for (i = 0; i < minD + 1; i++) {
        // PP = PP + Math.exp(LogCombination(NN, i) + NN * Math.log(0.5));
        PP = PP + P[i];
    }

    PP2 = PP * 2;
    if (PP2 >= 1) {
        PP2 = 0.9999;
    }

    var ppRlt = [[], [], []];
    //両側検定
    if (PP < 0.005) {
        ppRlt[0][0] = "** (p<.005)";
    } else {
        ppRlt[0][0] = "ns (p<.005)";
    }
    if (PP < 0.025) {
        ppRlt[1][0] = "*  (p<.025)";
    } else {
        ppRlt[1][0] = "ns (p<.025)";
    }
    if (PP < 0.05) {
        ppRlt[2][0] = "+  (.025<p<.05)";
    } else {
        ppRlt[2][0] = "ns (.025<p<.05)";
    }

    //片側検定
    if (PP < 0.01) {
        ppRlt[0][1] = "** (p<.01)";
    } else {
        ppRlt[0][1] = "ns (p<.01)";
    }
    if (PP < 0.05) {
        ppRlt[1][1] = "*  (p<.05)";
    } else {
        ppRlt[1][1] = "ns (p<.05)";
    }
    if (PP < 0.10) {
        ppRlt[2][1] = "+  (.05<p<.10)";
    } else {
        ppRlt[2][1] = "ns (.05<p<.10)";
    }

    var ppStr = "";
    ppStr += "p=" + PP.toFixed(4) + "（片側確率）\n\n";

    ppStr += " \t両側検定\t片側検定\n";
    ppStr += "-----------------------------------------\n";
    ppStr += "α=.01\t" + ppRlt[0][0] + "\t" + ppRlt[0][1] + "\n";
    if (ppRlt[0][0].match(/ns/)) {
        ppStr += "α=.05\t" + ppRlt[1][0] + "\t" + ppRlt[1][1] + "\n";
    }
    if (ppRlt[1][0].match(/ns/)) {
        ppStr += "α=.10\t" + ppRlt[2][0] + "\t" + ppRlt[2][1] + "\n";
    }

    strArray.push("[サイン検定]\n\n");
    strArray.push("------------------------------------\n");
    strArray.push("\t-\t0\t+\n");
    strArray.push("------------------------------------\n");
    strArray.push("\t" + DD2 + "\t" + DD3 + "\t" + DD1 + "\n");
    strArray.push("------------------------------------\n\n");

    strArray.push("サイン「０」のセルを除いて,１×２で分析します\n\n");

    strArray.push("------------------------------------\n");
    strArray.push("\t-\t+\tN\n");
    strArray.push("------------------------------------\n");
    strArray.push("\t" + DD2 + "\t" + DD1 + "\t" + NN + "\n");
    strArray.push("  (" + DS2 + ")  (" + DS1 + ")" + "\n");
    strArray.push("------------------------------------\n\n");

    strArray.push(ppStr + "\n");

    strArray.push("効果量 : g=" + effectSizeG.toFixed(4) + "\n");
    strArray.push("ベイズファクタ : BF=" + BF.toFixed(3) + "　※事前分布はBeta(1, 1)を設定\n");
    // strArray.push("両側検定  :  p=" + using(PP2, 1, 4) + ppStr + "\n");

    // //PP2 = PP/2;

    // var pp2Str = "";
    // if (PP < 0.01) {
    //     pp2Str = "   ** (p<.01)";
    // } else if (PP < 0.05) {
    //     pp2Str = "   *  (p<.05)";
    // } else if (PP < 0.10) {
    //     pp2Str = "   +  (.05<p<.10)";
    // } else {
    //     pp2Str = "   ns (.10<p)";
    // }

    // strArray.push("片側検定  :  p=" + using(PP, 1, 4) + pp2Str + "\n");
    strArray.push("-----------------------------------------\n");

    strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

    document.getElementById("RltArea").value = strArray.join("");
    strArray = null;

    //グラフ描画
    (function () {
        chartClear();

        var parent = document.getElementById("chart");
        var childElementCount = parent.childElementCount;

        var i;
        var chartImg = document.createElement('canvas');
        // chartImg.id = "ChartImg" + childElementCount;
        chartImg.id = "ChartImg";
        var ctx = document.getElementById("chart").appendChild(chartImg);

        var data = [];
        for (i = 0; i < 2; i++) {
            data[i] = [];
        }
        data[0][0] = (DS2 * 100).toFixed(4);
        data[0][1] = 50;
        data[1][0] = (DS1 * 100).toFixed(4);
        data[1][1] = 50;

        var datasetKey = [];
        for (i = 0; i < 2; i++) {
            datasetKey[i] = [];
        }
        datasetKey[0].label = '－';
        datasetKey[1].label = '＋';
        for (i = 0; i < 2; i++) {
            // datasetKey[i].label = '値' + (i + 1);
            datasetKey[i].data = data[i];
            datasetKey[i].backgroundColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
            datasetKey[i].borderColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
            datasetKey[i].borderWidth = 1;
        }

        var datasetData = [];
        // var dataset = [datas[0], datas[1]];
        for (i = 0; i < 2; i++) {
            datasetData[i] = datasetKey[i];
        }
        var myChart = new Chart(ctx, {
            type: 'horizontalBar',
            data: {
                labels: ['標本比率', '母比率'],
                datasets: datasetData
            },
            options: {
                title: {
                    display: true,
                    text: ' －（黒）と ＋（灰白）の比率',
                    position: 'top',
                    fontSize: 12,
                    fontColor: '#000000'
                },
                scales: {
                    xAxes: [{
                        stacked: true,
                        ticks: {
                            beginAtZero: true,
                            min: 0,
                            max: 100
                        }
                    }],
                    yAxes: [{
                        stacked: true
                    }]
                },
                legend: {
                    position: 'bottom'
                }
            }
        });
    }());	//グラフ描画ここまで


    var RltAreaObj = document.getElementById("RltArea");
    RltAreaObj.focus();
    RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
    RltAreaObj.scrollTop = 0;
}
// 要因Aの水準数セレクトのid subjNum
// 要因Aの名前 1行テキストボックスのid factorA_name
// 要因Aの水準数1行テキストボックスのid factorA_number
function changeSaSetting() {
    var h = 3;
    var htmArray = [];
    var htmArray1 = [];

    // freqdata2を使うか要検討 todo
    // htmArray.push("<div class=\"freqdata2\">");
    htmArray.push("<div class=\"tateyoko\">");
    htmArray.push("<table border=\"0\" class=\"codetb\">");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">参加者数：</td>");
    htmArray.push("<td class=\"codetbR\">");

    var thisBrowser = getBrowser();
    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" maxlength=\"10\"  min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeSaTable();\">");
    } else {
        htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeSaTable();\">");
        htmArray.push("<option value=\"2\" selected>2</option>");
        for (h = 3; h < 31; h++) {
            htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
        }
        htmArray.push("<option value=\"-1\">他</option>");
        htmArray.push("</select>");
    }

    htmArray.push("</td>");
    htmArray.push("</tr>");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">要因名：</td>");
    htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorA_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"A\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorA_name','cellClrBtn1');\" >×</span></td>");
    htmArray.push("</tr>");

    //常に2水準の比較
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">水準数：</td>");
    htmArray.push("<td class=\"codetbR\">2</td>");
    htmArray.push("</tr>");

    htmArray.push("</table>");
    htmArray.push("</div>");

    document.getElementById("sa_setting").innerHTML = htmArray.join("");
    htmArray = null;
    changeSaTable();

}
function changeSaTable() {
    var i = 0;
    var j = 0;
    var NN = parseInt(document.getElementById("subjNum").value, 10);
    var LA = 2; //常に2水準の比較

    var cellId = 1;
    var cellCount = NN * LA;

    var htmArray = [];

    // freqdata3を使うか要検討 todo
    // htmArray.push("<div class=\"freqdata3\">");
    htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("参加者");
    htmArray.push("</td>");

    for (i = 0; i < LA; i++) {
        htmArray.push("<td class=\"hyou_midashi_3d_title\">");
        htmArray.push("水準" + (i + 1));
        htmArray.push("</td>");
    }
    htmArray.push("</tr>");

    for (j = 0; j < NN; j++) {
        htmArray.push("<tr>");
        if (j === 0) {
            htmArray.push("<td class=\"hyou_midashi_3d_top\">");
        } else {
            htmArray.push("<td class=\"hyou_midashi_3d\">");
        }
        htmArray.push(j + 1);
        htmArray.push("</td>");
        for (i = 0; i < LA; i++) {
            htmArray.push("<td class=\"hyou_nyuryoku\">");
            htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
            htmArray.push("</td>");
            cellId++;
        }
        htmArray.push("</tr>");
    }
    htmArray.push("</table>");
    // htmArray.push("</div>");

    // htmArray.push("<div class=\"btnlayout4\">");
    // htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
    // htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','text');inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
    // htmArray.push("</div>");

    document.getElementById("sa_table").innerHTML = htmArray.join("");
    htmArray = null;

    //ドラッグドロップエリアを書き換えているので再セットする
    // setDragAndDrop();
}
function saveData_sign1x2() {
    var i, j;

    var strArray = [];

    var NN = parseInt(document.getElementById("subjNum").value, 10);
    var LA = 2;

    var x;
    var cellId = 1;
    for (j = 0; j < NN; j++) {
        for (i = 0; i < LA; i++) {
            x = parseInt(document.getElementById("cell_" + cellId).value);
            if (i !== LA - 1) {
                strArray.push(x + "\t");
            } else {
                strArray.push(x);
            }
            cellId++;
        }
        if (j !== NN - 1) {
            strArray.push("\n");
        }
    }

    var Stream = strArray.join("");
    var fineName = "sing1x2_Data-" + getDate() + ".txt";

    SaveToFile(fineName, Stream);
}
function saveData_sign1x2() {
    var i, j;

    var strArray = [];

    var NN = parseInt(document.getElementById("subjNum").value, 10);
    var AA = document.getElementById("factorA_name").value;
    var LA = 2;

    //#0
    strArray.push("sign1x2" + "\n");
    //#1
    strArray.push("#" + "\n");
    strArray.push(NN + "\n");
    //#2
    strArray.push("#" + "\n");
    strArray.push(AA + "\n");
    //#3
    strArray.push("#" + "\n");
    strArray.push(LA + "\n");
    //#4
    strArray.push("#" + "\n");
    var x;
    var cellId = 1;
    for (j = 0; j < NN; j++) {
        for (i = 0; i < LA; i++) {
            x = document.getElementById("cell_" + cellId).value;
            if (i !== LA - 1) {
                strArray.push(x + "\t");
            } else {
                strArray.push(x);
            }
            cellId++;
        }
        if (j !== NN - 1) {
            strArray.push("\n");
        }
    }

    var Stream = strArray.join("");
    var fineName = "sign1x2_Data-" + getDate() + ".txt";

    SaveToFile(fineName, Stream);
}
function dataHeaderProcess_sign1x2() {
    var readText = document.getElementById("CandPArea").value;
    var dd = [];
    dd = readText.split("#");

    if (crDel(dd[0]) === "sign1x2") {
        var NN = crDel(dd[1]);
        var AA = crDel(dd[2]);
        var LA = crDel(dd[3]);

        document.getElementById("subjNum").value = parseInt(NN, 10);
        document.getElementById("factorA_name").value = AA;
        // document.getElementById("factorA_number").value = parseInt(LA, 10);
        changeSaTable();
        document.getElementById("CandPArea").value = delTopCR(dd[4]);
    }
}


