
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();
    setUp();
};
//canvasサイズ
var cw = 550; //幅
var ch = 320; //高さ

var a = 28; //座標の幅（キャンバスのドット数）
var distance = 10; //座標の間隔

// 原点の位置
var ox = (cw - a * 10) / 2;
var oy = a * 10 + (ch - a * 10) / 2;

var PN = 3; //群（点）の数

var images = []; //点の画像配列
images[0] = new Image();
images[0].src = '../image/point_puma_red.png';

images[1] = new Image();
images[1].src = '../image/point_puma_blue.png';

images[2] = new Image();
images[2].src = '../image/point_puma_green.png';

var w = 14; //点の幅
var h = 14; //点の高さ

//点の値
var x = [];
var y = [];

// var probabilityDensity = [
//     0.000, 0.000, 0.000, 0.000, 0.001, 0.001, 0.001, 0.002, 0.002,
//     0.003, 0.004, 0.006, 0.008, 0.010, 0.014, 0.018, 0.022, 0.028,
//     0.035, 0.044, 0.054, 0.066, 0.079, 0.094, 0.111, 0.130, 0.150,
//     0.171, 0.194, 0.218, 0.242, 0.266, 0.290, 0.312, 0.333, 0.352,
//     0.368, 0.381, 0.391, 0.397, 0.399, 0.397, 0.391, 0.381, 0.368,
//     0.352, 0.333, 0.312, 0.290, 0.266, 0.242, 0.218, 0.194, 0.171,
//     0.150, 0.130, 0.111, 0.094, 0.079, 0.066, 0.054, 0.044, 0.035,
//     0.028, 0.022, 0.018, 0.014, 0.010, 0.008, 0.006, 0.004, 0.003,
//     0.002, 0.002, 0.001, 0.001, 0.001, 0.000, 0.000, 0.000, 0.000
// ];

var probabilityDensityRed = [];   //A1の正規分布曲線
var probabilityDensityBlue = [];  //A2の正規分布曲線
var probabilityDensityGreen = []; //A3の正規分布曲線

function RedBellcurveCalc(mean, sd) {
    var Mean = mean;
    var Sd = sd;
    var x = -5;
    for (var i = 0; i < 101; i++) {
        probabilityDensityRed[i] = 1 / (Math.sqrt(2 * Math.PI) * Sd) * Math.exp(-Math.pow((x - Mean), 2) / (2 * Math.pow(Sd, 2)));
        probabilityDensityRed[i] = probabilityDensityRed[i].toFixed(3);
        x = x + 0.1;
    }
}
function BlueBellcurveCalc(mean, sd) {
    var Mean = mean;
    var Sd = sd;
    var x = -5;
    for (var i = 0; i < 101; i++) {
        probabilityDensityBlue[i] = 1 / (Math.sqrt(2 * Math.PI) * Sd) * Math.exp(-Math.pow((x - Mean), 2) / (2 * Math.pow(Sd, 2)));
        probabilityDensityBlue[i] = probabilityDensityBlue[i].toFixed(3);
        x = x + 0.1;
    }
}
function GreenBellcurveCalc(mean, sd) {
    var Mean = mean;
    var Sd = sd;
    var x = -5;
    for (var i = 0; i < 101; i++) {
        probabilityDensityGreen[i] = 1 / (Math.sqrt(2 * Math.PI) * Sd) * Math.exp(-Math.pow((x - Mean), 2) / (2 * Math.pow(Sd, 2)));
        probabilityDensityGreen[i] = probabilityDensityGreen[i].toFixed(3);
        x = x + 0.1;
    }
}

//分散分析のための設定
var AA = 'A';
var LA = 3;

var NN = new Array(LA);
var NA = new Array(LA);

var M = new Array(LA);

var SD = new Array(LA);

//前に選択されていた図を覚えておく
var saveFigure = 'barplot';

function setUp() {
    distance = document.getElementById('meanscale').value;
    document.getElementById('A1_N').value = 10;
    document.getElementById('A1_SD').value = 2 * distance + ".0";
    document.getElementById('A2_SD').value = 2 * distance + ".0";
    document.getElementById('A3_SD').value = 2 * distance + ".0";

    document.getElementById('A1_SD').max = 3 * distance;
    document.getElementById('A2_SD').max = 3 * distance;
    document.getElementById('A3_SD').max = 3 * distance;

    setData();
    DrawAxis();
    DrawLine();
    DrawPoint();
    printData();
    s_calc_main();

}
function setData() {
    var figure = document.getElementById("figure").value;

    if (figure === "barplot" || figure === "curve") {
        x = [ox + a * 4, ox + a * 5, ox + a * 6];
        y = [oy, oy, oy];
    }

    if (figure === "line") {
        x = [ox + a * 2, ox + a * 5, ox + a * 8];
        y = [oy - a * 4, oy - a * 5, oy - a * 6];
    }

    var wN = parseInt(document.getElementById('A1_N').value);
    NN[0] = wN;
    NN[1] = wN;
    NN[2] = wN;

    if (figure === "barplot" || figure === "curve") {
        M[0] = Math.round(((x[0] - ox) / a) * distance * 10) / 10;
        M[1] = Math.round(((x[1] - ox) / a) * distance * 10) / 10;
        M[2] = Math.round(((x[2] - ox) / a) * distance * 10) / 10;
    }

    if (figure === "line") {
        M[0] = Math.round(((oy - y[0]) / a) * distance * 10) / 10;
        M[1] = Math.round(((oy - y[1]) / a) * distance * 10) / 10;
        M[2] = Math.round(((oy - y[2]) / a) * distance * 10) / 10;
    }

    SD[0] = parseFloat(document.getElementById('A1_SD').value);
    SD[1] = parseFloat(document.getElementById('A2_SD').value);
    SD[2] = parseFloat(document.getElementById('A3_SD').value);

    RedBellcurveCalc(0, 2);
    BlueBellcurveCalc(0, 2);
    GreenBellcurveCalc(0, 2);
}
function Message() {
    var LA = parseInt(document.getElementById('hsd').value, 10);

    var msg2 = "<span class=\" point_red\">●</span><span class=\" point_blue\">●</span>を動かしてみましょう";
    var msg3 = "<span class=\" point_red\">●</span><span class=\" point_blue\">●</span><span class=\" point_green\">●</span>を動かしてみましょう";

    if (LA === 2) {
        document.getElementById("message").innerHTML = msg2;
    }
    if (LA === 3) {
        document.getElementById("message").innerHTML = msg3;
    }
}
function DrawAxis() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    ctx.clearRect(0, 0, canvas.width, canvas.height);

    ctx.lineWidth = 1;
    ctx.strokeStyle = 'rgb(128,128,128)';

    var figure = document.getElementById("figure").value;

    ctx.setLineDash([3, 3]);
    if (figure === 'barplot' || figure === 'curve') {
        for (i = 1; i < 11; i++) {
            ctx.beginPath();
            ctx.moveTo(ox + a * i, oy);
            ctx.lineTo(ox + a * i, oy - a * 10);
            ctx.stroke();
        }
    }
    if (figure === 'line') {
        ctx.beginPath();
        ctx.moveTo(ox + a * 2, oy);
        ctx.lineTo(ox + a * 2, oy - a * 10);
        ctx.stroke();
        ctx.beginPath();
        ctx.moveTo(ox + a * 5, oy);
        ctx.lineTo(ox + a * 5, oy - a * 10);
        ctx.stroke();
        ctx.beginPath();
        ctx.moveTo(ox + a * 8, oy);
        ctx.lineTo(ox + a * 8, oy - a * 10);
        ctx.stroke();
        ctx.beginPath();
        ctx.moveTo(ox + a * 10, oy);
        ctx.lineTo(ox + a * 10, oy - a * 10);
        ctx.stroke();
    }
    for (j = 1; j < 11; j++) {
        ctx.beginPath();
        ctx.moveTo(ox, oy - a * j);
        ctx.lineTo(ox + a * 10, oy - a * j);
        ctx.stroke();
    }

    ctx.strokeStyle = 'rgb(0,0,0)';
    ctx.fillStyle = 'rgb(0,0,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox + a * 10, oy);
    ctx.stroke();

    ctx.font = "16px Arial";
    ctx.textAlign = "right";
    //原点
    ctx.fillText(0, ox + a * 0 + 10 - 8, oy + 20);
    //横軸
    if (figure === 'barplot' || figure === 'curve') {
        for (i = 1; i < 11; i++) {
            ctx.fillText(i * distance, ox + a * i + 10 - 5, oy + 20);
        }
    }
    if (figure === 'line') {
        ctx.fillText("A1", ox + a * 2 + 10, oy + 20);
        ctx.fillText("A2", ox + a * 5 + 10, oy + 20);
        ctx.fillText("A3", ox + a * 8 + 10, oy + 20);
    }
    //縦軸
    if (figure === 'barplot' || figure === 'line') {
        for (j = 1; j < 11; j++) {
            // ctx.fillText(j, ox - 5, oy - a * j + 10);
            ctx.fillText(j * 5, ox - 5, oy - a * j + 10);
        }
    }
}
function DrawLine() {
    var i;
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    if (figure === 'barplot' || figure === 'curve') {
        M[0] = Math.round(((x[0] - ox) / a) * distance * 10) / 10;
        M[1] = Math.round(((x[1] - ox) / a) * distance * 10) / 10;
        M[2] = Math.round(((x[2] - ox) / a) * distance * 10) / 10;
    }
    if (figure === 'line') {
        M[0] = Math.round(((oy - y[0]) / a) * distance * 10) / 10;
        M[1] = Math.round(((oy - y[1]) / a) * distance * 10) / 10;
        M[2] = Math.round(((oy - y[2]) / a) * distance * 10) / 10;
    }

    SD[0] = parseFloat(document.getElementById('A1_SD').value);
    SD[1] = parseFloat(document.getElementById('A2_SD').value);
    SD[2] = parseFloat(document.getElementById('A3_SD').value);

    LA = parseInt(document.getElementById('hsd').value, 10);
    var figure = document.getElementById("figure").value;

    RedBellcurveCalc(0, SD[0] / distance);
    BlueBellcurveCalc(0, SD[1] / distance);
    GreenBellcurveCalc(0, SD[2] / distance);

    var gx = new Array(3);
    for (i = 0; i < 3; i++) {
        // gx[i] = new Array(81);
        gx[i] = new Array(101);
    }
    var gy = new Array(3);
    for (i = 0; i < 3; i++) {
        // gy[i] = new Array(81);
        gy[i] = new Array(101);
    }
    var scale = 0;
    var StartPoint = 0;
    var mmPoint = [0, 0, 0];
    var cutPoint1 = [0, 0, 0];
    var cutPoint2 = [0, 0, 0];

    // for (i = 0; i < 3; i++) {
    //     scale = Math.abs(M[i] - (M[i] - SD[i])) / 20;
    //     // StartPoint = M[i] - scale * 40;
    //     StartPoint = M[i] - scale * 50;
    //     // for (j = 0; j < 81; j++) {
    //     for (j = 0; j < 101; j++) {
    //         gx[i][j] = StartPoint + j * scale;
    //         gy[i][j] = probabilityDensity[j] * 10;
    //         if (gx[i][j] < M[i]) mmPoint[i] = j + 1;
    //         if (gx[i][j] < M[i] - SD[i]) cutPoint1[i] = j + 1;
    //         if (gx[i][j] < M[i] + SD[i]) cutPoint2[i] = j + 1;
    //     }
    // }

    //Red
    i = 0;
    scale = Math.abs(M[i] - (M[i] - SD[i])) / 20;
    StartPoint = M[i] - scale * 50;
    for (j = 0; j < 101; j++) {
        gx[i][j] = StartPoint + j * scale;
        gy[i][j] = probabilityDensityRed[j] * 10;
        if (gx[i][j] < M[i]) mmPoint[i] = j + 1;
        if (gx[i][j] < M[i] - SD[i]) cutPoint1[i] = j + 1;
        if (gx[i][j] < M[i] + SD[i]) cutPoint2[i] = j + 1;
    }
    //Blue
    i = 1;
    scale = Math.abs(M[i] - (M[i] - SD[i])) / 20;
    StartPoint = M[i] - scale * 50;
    for (j = 0; j < 101; j++) {
        gx[i][j] = StartPoint + j * scale;
        gy[i][j] = probabilityDensityBlue[j] * 10;
        if (gx[i][j] < M[i]) mmPoint[i] = j + 1;
        if (gx[i][j] < M[i] - SD[i]) cutPoint1[i] = j + 1;
        if (gx[i][j] < M[i] + SD[i]) cutPoint2[i] = j + 1;
    }
    //Green
    i = 2;
    scale = Math.abs(M[i] - (M[i] - SD[i])) / 20;
    StartPoint = M[i] - scale * 50;
    for (j = 0; j < 101; j++) {
        gx[i][j] = StartPoint + j * scale;
        gy[i][j] = probabilityDensityGreen[j] * 10;
        if (gx[i][j] < M[i]) mmPoint[i] = j + 1;
        if (gx[i][j] < M[i] - SD[i]) cutPoint1[i] = j + 1;
        if (gx[i][j] < M[i] + SD[i]) cutPoint2[i] = j + 1;
    }

    if (figure === 'barplot') {
        for (i = 0; i < LA; i++) {
            //平均を描画
            ctx.lineWidth = 3;
            if (i === 0) ctx.strokeStyle = 'rgb(255,0,0)';
            if (i === 1) ctx.strokeStyle = 'rgb(0,0,255)';
            if (i === 2) ctx.strokeStyle = 'rgb(0,175,45)';
            ctx.setLineDash([]);
            ctx.beginPath();
            ctx.moveTo(ox + a * (M[i] - SD[i]) / distance, oy);
            ctx.lineTo(ox + a * (M[i] - SD[i]) / distance, oy - a * M[i] / distance);
            ctx.moveTo(ox + a * (M[i] - SD[i]) / distance, oy - a * M[i] / distance);
            ctx.lineTo(ox + a * (M[i] + SD[i]) / distance, oy - a * M[i] / distance);
            ctx.moveTo(ox + a * (M[i] + SD[i]) / distance, oy - a * M[i] / distance);
            ctx.lineTo(ox + a * (M[i] + SD[i]) / distance, oy);
            ctx.stroke();

            ctx.lineWidth = 2;
            ctx.setLineDash([6, 2]);
            ctx.beginPath();
            ctx.moveTo(ox + a * M[i] / distance, oy - a * M[i] / distance);
            ctx.lineTo(ox + a * M[i] / distance, oy);
            ctx.stroke();

            //標準偏差を描画
            ctx.lineWidth = 2;
            if (i === 0) ctx.strokeStyle = 'rgb(255,0,0)';
            if (i === 1) ctx.strokeStyle = 'rgb(0,0,255)';
            if (i === 2) ctx.strokeStyle = 'rgb(0,175,45)';
            ctx.setLineDash([]);
            ctx.beginPath();
            ctx.moveTo(ox + a * (M[i] - 1 * distance) / distance, oy - a * (M[i] + SD[i]) / distance);
            ctx.lineTo(ox + a * (M[i] + 1 * distance) / distance, oy - a * (M[i] + SD[i]) / distance);
            ctx.moveTo(ox + a * M[i] / distance, oy - a * M[i] / distance);
            ctx.lineTo(ox + a * M[i] / distance, oy - a * (M[i] + SD[i]) / distance);
            ctx.stroke();
        }
    }

    if (figure === 'curve') {
        for (i = 0; i < LA; i++) {
            //正規分布を描画
            ////68％塗りつぶし
            if (i === 0) ctx.fillStyle = 'rgb(255,0,0,0.1)';
            if (i === 1) ctx.fillStyle = 'rgb(0,0,255,0.1)';
            if (i === 2) ctx.fillStyle = 'rgb(0,175,45,0.1)';
            ctx.beginPath();
            ctx.moveTo(ox + a * gx[i][cutPoint1[i]] / distance, oy);
            for (j = cutPoint1[i]; j < cutPoint2[i]; j++) {
                ctx.lineTo(ox + a * gx[i][j] / distance, oy - a * gy[i][j]);
            }
            ctx.lineTo(ox + a * gx[i][cutPoint2[i]] / distance, oy);
            ctx.closePath();
            ctx.fill();
            ////曲線
            ctx.lineWidth = 3;
            if (i === 0) ctx.strokeStyle = 'rgb(255,0,0)';
            if (i === 1) ctx.strokeStyle = 'rgb(0,0,255)';
            if (i === 2) ctx.strokeStyle = 'rgb(0,175,45)';
            ctx.setLineDash([]);
            ctx.beginPath();
            ctx.moveTo(ox + a * gx[i][0] / distance, oy - a * gy[i][0]);
            // for (j = 1; j < 81; j++) {
            for (j = 1; j < 101; j++) {
                ctx.lineTo(ox + a * gx[i][j] / distance, oy - a * gy[i][j]);
            }
            ctx.stroke();
            ////平均・標準偏差の線
            ctx.lineWidth = 2;
            if (i === 0) ctx.strokeStyle = 'rgb(255,0,0)';
            if (i === 1) ctx.strokeStyle = 'rgb(0,0,255)';
            if (i === 2) ctx.strokeStyle = 'rgb(0,175,45)';
            ctx.setLineDash([6, 2]);
            ctx.beginPath();
            ctx.moveTo(ox + a * gx[i][mmPoint[i]] / distance, oy);
            ctx.lineTo(ox + a * gx[i][mmPoint[i]] / distance, oy - a * gy[i][mmPoint[i]]);
            ctx.stroke();

            ctx.beginPath();
            ctx.moveTo(ox + a * gx[i][cutPoint1[i]] / distance, oy);
            ctx.lineTo(ox + a * gx[i][cutPoint1[i]] / distance, oy - a * gy[i][cutPoint1[i]]);
            ctx.stroke();

            ctx.beginPath();
            ctx.moveTo(ox + a * gx[i][cutPoint2[i]] / distance, oy);
            ctx.lineTo(ox + a * gx[i][cutPoint2[i]] / distance, oy - a * gy[i][cutPoint2[i]]);
            ctx.stroke();
        }
    }

    if (figure === 'line') {
        //線グラフを描画
        ctx.lineWidth = 3;
        ctx.strokeStyle = 'rgb(0,0,0)';
        ctx.setLineDash([]);
        ctx.beginPath();
        ctx.moveTo(x[0], y[0]);
        for (i = 1; i < LA; i++) {
            ctx.lineTo(x[i], y[i]);
        }
        ctx.stroke();

        //標準偏差を描画
        if (document.getElementById("bellcurveChecked").checked === false) {
            temp = 1; //アンテナの上下
            for (i = 0; i < LA; i++) {
                for (j = 0; j < 2; j++) {
                    ctx.lineWidth = 2;
                    if (i === 0) ctx.strokeStyle = 'rgb(255,0,0)';
                    if (i === 1) ctx.strokeStyle = 'rgb(0,0,255)';
                    if (i === 2) ctx.strokeStyle = 'rgb(0,175,45)';
                    temp = temp - j * 2; //1 or -1
                    ctx.beginPath();
                    ctx.moveTo(x[i], y[i]);
                    ctx.lineTo(x[i], y[i] + temp * SD[i] * a / distance);
                    ctx.stroke();
                    ctx.beginPath();
                    ctx.moveTo(x[i] - 10, y[i] + temp * SD[i] * a / distance);
                    ctx.lineTo(x[i] + 10, y[i] + temp * SD[i] * a / distance);
                    ctx.stroke();
                }
                temp = 1;
            }
        }

        ////曲線
        if (document.getElementById("bellcurveChecked").checked) {
            for (i = 0; i < LA; i++) {
                ctx.lineWidth = 1;
                if (i === 0) ctx.strokeStyle = 'rgb(255,0,0)';
                if (i === 1) ctx.strokeStyle = 'rgb(0,0,255)';
                if (i === 2) ctx.strokeStyle = 'rgb(0,175,45)';
                ctx.setLineDash([3, 2]);
                ctx.beginPath();
                ctx.moveTo(x[i] + a * gy[i][0] * 0.6, oy - a * gx[i][0] / distance);
                // for (j = 1; j < 81; j++) {
                for (j = 1; j < 101; j++) {
                    ctx.lineTo(x[i] + a * gy[i][j] * 0.6, oy - a * gx[i][j] / distance);
                }
                ctx.stroke();
            }
        }
    }
}
function ChangeFigure() {
    var figure = document.getElementById("figure").value;
    for (var i in images) {
        if (figure === 'barplot' || figure === 'curve') {
            if (saveFigure === 'line') {
                x[i] = (oy - y[i]) / a;
                x[i] = ox + a * x[i];
                images[i].drawOffsetX = x[i];
                y[i] = oy;
                images[i].drawOffsetY = oy;
            }
        }
        if (figure === 'line') {
            y[i] = (x[i] - ox) / a;
            y[i] = oy - a * y[i];
            images[i].drawOffsetY = y[i];
        }
    }
    if (figure === 'line') {
        x = [ox + a * 2, ox + a * 5, ox + a * 8];
        images[i].drawOffsetX = x[i];
    }
    saveFigure = figure; //今選択されている図を覚える

    if (figure === 'barplot' || figure === 'curve') {
        document.getElementById('bellcurve').style.visibility = 'hidden';
    }
    if (figure === 'line') {
        document.getElementById('bellcurve').style.visibility = 'visible';
    }
}
function DrawPoint() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    for (var i in images) {
        // 画像を描画した時の情報を記憶
        images[i].drawOffsetX = x[i];
        images[i].drawOffsetY = y[i];
        images[i].drawWidth = w;
        images[i].drawHeight = h;

        // 画像を描画
        if (i < 2) {
            ctx.drawImage(images[i], x[i] - w / 2, y[i] - h / 2, w, h);
        }

        if (document.getElementById('hsd').value == 3) {
            ctx.drawImage(images[2], x[2] - w / 2, y[2] - h / 2, w, h);
        }

    }
}
function printData() {
    var wN = parseInt(document.getElementById('A1_N').value);
    document.getElementById('A2_N').innerHTML = wN;

    document.getElementById('A1_mean').innerHTML = parseFloat(M[0]).toFixed(1);
    document.getElementById('A2_mean').innerHTML = parseFloat(M[1]).toFixed(1);

    var wSD = parseFloat(document.getElementById('A1_SD').value);

    if (document.getElementById('hsd').value == 3) {
        document.getElementById('A3_N').innerHTML = wN;
        document.getElementById('A3_mean').innerHTML = parseFloat(M[2]).toFixed(1);
        document.getElementById('A3_SD').style.visibility = 'visible';

    } else {
        document.getElementById('A3_N').innerHTML = '';
        document.getElementById('A3_mean').innerHTML = '';
        document.getElementById('A3_SD').style.visibility = 'hidden';
    }
}
function mainAs() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');
    var dragTarget = null;
    var isDragging = false;

    setData();
    DrawAxis();
    DrawLine();

    images[PN - 1].addEventListener('load', function () {
        DrawPoint();
    }, false);

    var figure = document.getElementById("figure").value;

    printData();
    // s_calc_as();
    // s_calc_ts();
    s_calc_main();

    // ドラッグ開始
    var mouseDown = function (e) {
        var event;
        if (e.type === "mousedown") {
            event = e;
        } else {
            event = e.changedTouches[0];
        }

        // ドラッグ開始位置
        var posX = parseInt(event.clientX - canvas.getBoundingClientRect().left);
        var posY = parseInt(event.clientY - canvas.getBoundingClientRect().top);

        for (var i = PN - 1; i >= 0; i--) {
            // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
            if (posX >= images[i].drawOffsetX - w / 2 &&
                posX <= (images[i].drawOffsetX + images[i].drawWidth + w / 2) &&
                posY >= images[i].drawOffsetY - h / 2 &&
                posY <= (images[i].drawOffsetY + images[i].drawHeight + h / 2)
            ) {
                dragTarget = i;
                isDragging = true;
                break;
            }
        }
    };

    // ドラッグ終了
    var mouseUp = function (e) {
        isDragging = false;
    };

    // canvasの枠から外れた
    var mouseOut = function (e) {
        // canvas外にマウスカーソルが移動した場合に，ドラッグ終了としたい場合はコメントインする
        // mouseUp(e);
    };

    // ドラッグ中
    var mouseMove = function (e) {
        var event;
        if (e.type === "mousemove") {
            event = e;
        } else {
            event = e.changedTouches[0];
        }

        // ドラッグ終了位置
        var posX = parseInt(event.clientX - canvas.getBoundingClientRect().left);
        var posY = parseInt(event.clientY - canvas.getBoundingClientRect().top);

        //フリックしたときに画面を動かさないようにデフォルト動作を抑制
        e.preventDefault();

        var figure = document.getElementById("figure").value;

        if (figure === 'barplot' || figure === 'curve') {
            if ((posX < ox + a / 4) || (posX > ox + a * 10 + a / 4)) {
                isDragging = false;
            }
        }

        if (figure === 'line') {
            if ((posX < ox) || (posX > ox + a * 10) || (posY < oy - a * 10 + h / 2) || (posY > oy + h / 2)) {
                isDragging = false;
            }
        }

        if (isDragging) {
            var mx = 0;
            var my = 0;
            for (var i in images) {
                if (i == dragTarget) {
                    if (figure === 'barplot' || figure === 'curve') {
                        mx = posX - images[i].drawWidth / 2;
                        // my = images[i].drawOffsetY;
                        my = oy;
                    }
                    if (figure === 'line') {
                        mx = images[i].drawOffsetX;
                        my = posY - images[i].drawHeight / 2;
                    }

                    // ドラッグが終了した時の情報を記憶
                    images[i].drawOffsetX = mx;
                    images[i].drawOffsetY = my;
                } else {
                    mx = images[i].drawOffsetX;
                    my = images[i].drawOffsetY;
                }
                w = images[i].drawWidth;
                h = images[i].drawHeight;

                x[i] = mx;
                y[i] = my;
            }
            if (figure === 'line') {
                M[0] = Math.round(((oy - y[0]) / a) * distance * 10) / 10;
                M[1] = Math.round(((oy - y[1]) / a) * distance * 10) / 10;
                M[2] = Math.round(((oy - y[2]) / a) * distance * 10) / 10;
            }

            if (figure === 'barplot' || figure === 'curve') {
                M[0] = Math.round(((x[0] - ox) / a) * distance * 10) / 10;
                M[1] = Math.round(((x[1] - ox) / a) * distance * 10) / 10;
                M[2] = Math.round(((x[2] - ox) / a) * distance * 10) / 10;
            }

            DrawAxis();
            DrawLine();
            DrawPoint();
            printData();

            // s_calc_as();
            // s_calc_ts();
            s_calc_main();
        }
    };

    // canvasにイベント登録
    canvas.addEventListener('mousedown', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('mousemove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('mouseup', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('mouseout', function (e) { mouseOut(e); }, false);

    canvas.addEventListener('touchstart', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('touchmove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('touchend', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('touchleave', function (e) { mouseOut(e); }, false);
}
function s_calc_main() {
    document.getElementById("asDataArea").value = "";
    if (document.getElementById("Tscheck").checked) {
        if (LA == 2) {
            s_calc_ts();
        }
        if (document.getElementById("Ascheck").checked) {
            s_calc_as();
        }
    } else {
        if (document.getElementById("Ascheck").checked) {
            document.getElementById("asDataArea").value = "";
            s_calc_as();
        }
    }
    // if (document.getElementById("Ascheck").checked) {
    //     s_calc_as();
    //     if (LA == 2) {
    //         if (document.getElementById("Tscheck").checked) {
    //             s_calc_ts();
    //         }
    //     }
    // } else {
    //     if (LA == 2) {
    //         if (document.getElementById("Tscheck").checked) {
    //             document.getElementById("asDataArea").value = "";
    //             s_calc_ts();
    //         }
    //     }
    // }
}
function s_calc_as() {
    var MC$;
    var EQ$;

    var strArray = [];
    var bar = "-----------------------------------------------------\n";

    var wN = parseInt(document.getElementById('A1_N').value);
    NN[0] = wN;
    NN[1] = wN;
    NN[2] = wN;

    NA[0] = NN[0];
    NA[1] = NN[1];
    NA[2] = NN[2];

    M[0] = parseFloat(M[0]);
    M[1] = parseFloat(M[1]);
    M[2] = parseFloat(M[2]);

    SD[0] = parseFloat(document.getElementById('A1_SD').value);
    SD[1] = parseFloat(document.getElementById('A2_SD').value);
    SD[2] = parseFloat(document.getElementById('A3_SD').value);

    for (i = 0; i < LA; i++) {
        NA[i] = NN[i];
    }

    // if(document.getElementById('hsd').checked){
    if (document.getElementById('hsd').value == 3) {
        LA = 3;
    } else {
        LA = 2;
    }
    //主効果検定
    strArray.push(" == Analysis of Variance ==\n\n");
    strArray.push(" S.V        SS        df        MS        F\n");

    var S = 0;
    var OB = 0;
    for (i = 0; i < LA; i++) {
        S = S + M[i] * NN[i];
        OB = OB + NN[i]; //度数の合計
    }
    var DH = S / OB; //大平均
    var A = 0;
    var E = 0;
    for (i = 0; i < LA; i++) {
        var MD = Math.pow(M[i] - DH, 2);
        A = A + MD * NN[i];
        E = E + Math.pow(SD[i], 2) * NN[i];
    }
    var T = A + E;
    var DA = LA - 1;
    var MA = A / DA;
    var DE = OB - LA;
    var ME = E / DE;
    var FA = MA / ME;
    var DAE = DA + DE;

    var D1 = DA;
    var D2 = DE;
    var Fdata = FA;
    var FA$ = pValue_Match_fRatio(D1, D2, Fdata);

    var a = using(A, 11, 4);
    var da = using(DA, 4, 0);
    var ma = using(MA, 8, 4);
    var fa = using(FA, 3, 2);
    var e = using(E, 9, 4);
    var de = using(DE, 4, 0);
    var me = using(ME, 8, 4);
    var t = using(T, 9, 4);
    var dae = using(DAE, 4, 0);

    strArray.push(bar);
    strArray.push("  A" + a + " " + da + " " + ma + " " + fa + " " + FA$ + "\n");
    strArray.push(" subj" + e + " " + de + " " + me + "\n");
    strArray.push(bar);
    strArray.push("Total" + t + " " + dae);
    strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

    // var effectSizeF = Math.sqrt(DA / DE * FA);
    // strArray.push("\n == EffectSize ==\n\n");
    // strArray.push("\teffectsize f\n");
    // strArray.push(bar);
    // strArray.push("  A\t" + effectSizeF.toFixed(4) + "\n");
    // strArray.push(bar);
    // strArray.push("\t\tLarge=0.4 , Medium=0.25 , Small=0.1\n");

    //多重比較 HSD(Tukey-kramer)
    // if(checkedHsd){
    if (FA$ != "ns") {
        if (LA > 2) {
            var Q2 = 0;
            Q2 = st_qValue(LA, DE);

            strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
            strArray.push(" (MSe=" + me + ", * p<.05)\n");
            strArray.push(bar);
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    var HSD = Q2 * Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii])) / Math.SQRT2;
                    var hsd = using(HSD, 8, 4);

                    if (Math.abs(M[i] - M[ii]) > HSD) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (M[i] > M[ii]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
                }
            }
            strArray.push(bar);
        }
    }
    // }
    // strArray.push("\n");

    // document.getElementById("asDataArea").value = strArray.join("");
    document.getElementById("asDataArea").value = document.getElementById("asDataArea").value + strArray.join("");
    strArray = null;
}
function saveData_s_as() {
    var i, j;

    var str = "分散分析As　シミュレーション\n\n";
    str += " == Mean & S.D. ==\n\n";

    for (i = 0; i < LA; i++) {
        str = str + "\t" + "A" + (i + 1);
    }
    str += "\n---------------------------------\n";
    str += "N" + "\t";
    for (i = 0; i < LA; i++) {
        str = str + NN[i] + "\t";
    }
    str += "\n";
    str += "mean" + "\t";
    for (i = 0; i < LA; i++) {
        str = str + M[i] + "\t";
    }
    str += "\n";
    str += "SD" + "\t";
    for (i = 0; i < LA; i++) {
        str = str + SD[i] + "\t";
    }
    str += "\n---------------------------------\n";

    var Stream = str + "\n" + document.getElementById("asDataArea").value;
    var fineName = "As_Data-" + getDate() + ".txt";

    SaveToFile(fineName, Stream);
}
function s_calc_ts() {
    var MC$;
    var EQ$;

    var strArray = [];
    var bar = "-----------------------------------------------------\n";

    var wN = parseInt(document.getElementById('A1_N').value);
    NN[0] = wN;
    NN[1] = wN;
    NN[2] = wN;

    NA[0] = NN[0];
    NA[1] = NN[1];
    NA[2] = NN[2];

    M[0] = parseFloat(M[0]);
    M[1] = parseFloat(M[1]);
    M[2] = parseFloat(M[2]);

    SD[0] = parseFloat(document.getElementById('A1_SD').value);
    SD[1] = parseFloat(document.getElementById('A2_SD').value);
    SD[2] = parseFloat(document.getElementById('A3_SD').value);

    var S2 = []; //分散

    S2[0] = Math.pow(SD[0], 2);
    S2[1] = Math.pow(SD[1], 2);
    S2[2] = Math.pow(SD[2], 2);

    //T値
    // var T = Math.abs(M[0] - M[1]) / Math.sqrt(S2[0] / (NN[0] - 1) + S2[1] / (NN[1] - 1));
    var T = Math.abs(M[0] - M[1]) / Math.sqrt(S2[0] / NN[0] + S2[1] / NN[1]);
    T = parseFloat(T.toFixed(4));

    //自由度
    var wC = (S2[0] / (NN[0] - 1)) / (S2[0] / (NN[0] - 1) + S2[1] / (NN[1] - 1));
    var DF = (NN[0] - 1) * (NN[1] - 1) / ((NN[0] - 1) * Math.pow(1 - wC, 2) + (NN[1] - 1) * Math.pow(wC, 2));
    DF = Math.floor(DF);

    var PP2 = t_table(DF, T);

    var ppStr = "";
    if (PP2 === 0.01) {
        ppStr = "   ** (p<.01 , 両側検定)";
    }
    if (PP2 === 0.05) {
        ppStr = "   *  (p<.05 , 両側検定)";
    }
    if (PP2 === 0.10) {
        ppStr = "   +  (.05<p<.10 , 両側検定)";
    }
    if (PP2 === 1) {
        ppStr = "   ns (.10<p , 両側検定)";
    }

    // var effectSizeD = T * Math.sqrt(1 / (NN[0] - 1) + 1 / (NN[1] - 1));
    var TT = (M[0] - M[1]) / Math.sqrt(S2[0] / NN[0] + S2[1] / NN[1]);
    var effectSizeD = TT * Math.sqrt(1 / NN[0] + 1 / NN[1]);

    strArray.push(" == Welch's t - test ==\n\n");
    strArray.push((' t(' + DF + ')= ' + T + ' , ' + ppStr + '\n'));
    strArray.push("\n");
    strArray.push(" -- EffectSize delta --\n\n");
    // strArray.push(bar);
    strArray.push(" δ= " + effectSizeD.toFixed(4) + "  ,  ");
    // strArray.push(bar);
    strArray.push("(Large=0.8 , Medium=0.5 , Small=0.2)\n");
    strArray.push("\n");

    // document.getElementById("asDataArea").value = document.getElementById("asDataArea").value + strArray.join("");
    document.getElementById("asDataArea").value = strArray.join("");
    strArray = null;
}
function checkBoxAbled() {
    if (LA == 2) {
        document.getElementById("Tscheck").disabled = true;
        document.getElementById("Ascheck").checked = true;
    }
    if (LA == 3) {
        document.getElementById("Tscheck").disabled = false;

    }
}