window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();
};

//canvasサイズ
var cw = 550; //幅
// var ch = 350; //高さ
var ch = 430; //高さ

var a = 28; //座標の幅
var distance = 1; //座標の間隔

// 原点の位置
var ox = (cw - a * 10) / 2;
var oy = a * 10 + (ch - a * 10) / 2 - 2;
// var oy = a * 10 + (ch - a * 10);

var PN = 10; //点の数
var PNmax = 100; //点の最大数
var NN = PN; //人数

var images = []; //点の画像配列
var _rnd = Math.floor(Math.random() * (10000));
for (i = 0; i < PNmax; i++) {
    images[i] = new Image();

    var str = '?var=' + _rnd;
    images[i].src = '../image/point_corr.png' + str;
}
var w = 14; //点の幅
var h = 14; //点の高さ

//点の値
var x = [];
var y = [];

var xx = new Array(NN);
for (i = 0; i < PNmax; i++) {
    xx[i] = new Array(NN);
}

var R = 0; //ピアソンの相関係数
var A = 1; //回帰直線の傾き
var B = 0; //回帰直線の切片

// var probabilityDensity = [
//     0.000, 0.000, 0.000, 0.000, 0.001, 0.001, 0.001, 0.002, 0.002,
//     0.003, 0.004, 0.006, 0.008, 0.010, 0.014, 0.018, 0.022, 0.028,
//     0.035, 0.044, 0.054, 0.066, 0.079, 0.094, 0.111, 0.130, 0.150,
//     0.171, 0.194, 0.218, 0.242, 0.266, 0.290, 0.312, 0.333, 0.352,
//     0.368, 0.381, 0.391, 0.397, 0.399, 0.397, 0.391, 0.381, 0.368,
//     0.352, 0.333, 0.312, 0.290, 0.266, 0.242, 0.218, 0.194, 0.171,
//     0.150, 0.130, 0.111, 0.094, 0.079, 0.066, 0.054, 0.044, 0.035,
//     0.028, 0.022, 0.018, 0.014, 0.010, 0.008, 0.006, 0.004, 0.003,
//     0.002, 0.002, 0.001, 0.001, 0.001, 0.000, 0.000, 0.000, 0.000
// ];

var probabilityDensityRed = [];   //Yの正規分布曲線
var probabilityDensityBlue = [];  //Y予測値の正規分布曲線
var probabilityDensityPink = [];  //Xの正規分布曲線

function RedBellcurveCalc(mean, sd) {
    var Mean = mean;
    var Sd = sd;
    var x = -5;
    for (var i = 0; i < 101; i++) {
        probabilityDensityRed[i] = 1 / (Math.sqrt(2 * Math.PI) * Sd) * Math.exp(-Math.pow((x - Mean), 2) / (2 * Math.pow(Sd, 2)));
        probabilityDensityRed[i] = probabilityDensityRed[i].toFixed(3);
        x = x + 0.1;
    }
}
function BlueBellcurveCalc(mean, sd) {
    var Mean = mean;
    var Sd = sd;
    var x = -5;
    for (var i = 0; i < 101; i++) {
        probabilityDensityBlue[i] = 1 / (Math.sqrt(2 * Math.PI) * Sd) * Math.exp(-Math.pow((x - Mean), 2) / (2 * Math.pow(Sd, 2)));
        probabilityDensityBlue[i] = probabilityDensityBlue[i].toFixed(3);
        x = x + 0.1;
    }
}
function PinkBellcurveCalc(mean, sd) {
    var Mean = mean;
    var Sd = sd;
    var x = -5;
    for (var i = 0; i < 101; i++) {
        probabilityDensityPink[i] = 1 / (Math.sqrt(2 * Math.PI) * Sd) * Math.exp(-Math.pow((x - Mean), 2) / (2 * Math.pow(Sd, 2)));
        probabilityDensityPink[i] = probabilityDensityPink[i].toFixed(3);
        x = x + 0.1;
    }
}

function setUp() {
    document.getElementById('PN_number').value = 10;

    setData();
    DrawAxis();
    s_calc_corr();
    DrawPoint();

    DrawX();

    DrawY();
    DrawYY();
    DrawAxisNum();
    DrawLine();
    Message();
}
function setData() {
    var PN = document.getElementById('PN_number').value;
    for (var i = 0; i < PN; i++) {
        var tR = Math.round(Math.random() * (100 - 0) - 0);
        x[i] = parseFloat(ox + tR / 100 * (a * 10) - w / 2, 10);
        tR = Math.round(Math.random() * (100 - 0) - 0);
        y[i] = parseFloat(oy - tR / 100 * (a * 10) - h / 2, 10);
    }
}
function Message() {
    var msg1 = "<span class=\"point_green\">●</span>を動かしてみましょう";
    var msg2 = "<span class=\"point_green\">●</span>を追加しましょう";
    var msg3 = "<span class=\"point_green\">●</span>を削除しましょう";

    if (document.getElementById("move").checked) {
        document.getElementById("message").innerHTML = msg1;
    }
    if (document.getElementById("add").checked) {
        document.getElementById("message").innerHTML = msg2;
    }
    if (document.getElementById("del").checked) {
        document.getElementById("message").innerHTML = msg3;
    }
}
function DrawAxis() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    ctx.clearRect(0, 0, canvas.width, canvas.height);
    // ctx.fillStyle = 'rgb(200,200,200)';
    // ctx.fillRect(0, 0, canvas.width, canvas.height);

    ctx.lineWidth = 1;
    ctx.strokeStyle = 'rgb(128,128,128)';

    ctx.setLineDash([3, 3]);
    ctx.beginPath();
    ctx.moveTo(ox + a * 2, oy);
    ctx.lineTo(ox + a * 2, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 8, oy);
    ctx.lineTo(ox + a * 8, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 10, oy);
    ctx.lineTo(ox + a * 10, oy - a * 10);
    ctx.stroke();
    ctx.closePath(); //追加

    for (i = 1; i < 11; i++) {
        ctx.beginPath();
        ctx.moveTo(ox + a * i, oy);
        ctx.lineTo(ox + a * i, oy - a * 10);
        ctx.stroke();
        ctx.closePath(); //追加
    }

    for (j = 1; j < 11; j++) {
        ctx.beginPath();
        ctx.moveTo(ox, oy - a * j);
        ctx.lineTo(ox + a * 10, oy - a * j);
        ctx.stroke();
        ctx.closePath(); //追加
    }

    ctx.strokeStyle = 'rgb(0,0,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox + a * 10, oy);
    ctx.stroke();
    ctx.closePath(); //追加

}
function DrawAxisNum() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');
    ctx.font = "16px Arial";
    ctx.textAlign = "right";
    ctx.fillStyle = 'rgb(0,0,0)';
    ctx.fillText("0", ox - 5, oy + 20);
    ctx.fillText("100", ox + a * 10 + 10, oy + 20);
    ctx.fillText("100", ox - 5, oy - a * 10 + 10);
    // ctx.fillText("X", ox + a * 5, oy + 35);
    ctx.fillText("X", ox + a * 5, oy + 40);
    ctx.fillText("Y", ox - 30, oy - a * 5 - 15);
}
function DrawLine() {
    var i, j;
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    //ピアソンの相関係数を描画
    ctx.fillStyle = 'rgb(0,0,0)';
    ctx.font = "18px Arial";
    ctx.textAlign = "left";
    ctx.beginPath();
    // ctx.fillText("r=" + R.toFixed(3), ox + a * 4, oy - a * 10 - 10);
    ctx.fillText("r=" + R.toFixed(3), ox + a * 4, oy + 70);
    ctx.closePath();

    // document.getElementById("corrText").innerHTML = "r=" + R.toFixed(3);

    //回帰直線を描画
    if (document.getElementById('Regressionline').checked) {
        ctx.lineWidth = 3;
        ctx.strokeStyle = 'rgb(255,165,0)';
        ctx.setLineDash([]);
        ctx.beginPath();
        ctx.moveTo(ox, oy - a / 10 * B);
        ctx.lineTo(ox + a * 10, oy - a / 10 * B - A * (a * 10));
        ctx.stroke();
        ctx.closePath(); //追加
    }

    //説明率を描画
    if (document.getElementById('Suportline').checked) {
        var gx = new Array(3);
        for (i = 0; i < 3; i++) {
            gx[i] = new Array(81);
        }
        var gy = new Array(3);
        for (i = 0; i < 3; i++) {
            gy[i] = new Array(81);
        }
        var scale = 0;
        var StartPoint = 0;
        var mmPoint = [0, 0, 0];
        var cutPoint1 = [0, 0, 0];
        var cutPoint2 = [0, 0, 0];

        var MM = [];
        var SSD = [];
        var S = 0;
        var SS = 0;
        var xx, yy, YY;
        var ZZ = [];
        for (i = 0; i < PN; i++) {
            xx = Math.floor((x[i] - ox + w / 2) / (a * 10) * 100);
            yy = Math.floor((oy - y[i] - h / 2) / (a * 10) * 100);
            YY = Math.floor(A * xx + B);
            ZZ[i] = B - (YY - yy);
        }

        //青の描画
        S = 0;
        SS = 0;
        for (i = 0; i < PN; i++) {
            S = S + Math.floor(ZZ[i]);
        }
        MM[0] = S / NN;
        for (i = 0; i < PN; i++) {
            SS = SS + Math.pow(MM[0] - Math.floor(ZZ[i]), 2);
        }
        SSD[0] = Math.sqrt(SS / PN);

        MM[0] = MM[0] / 10;
        SSD[0] = SSD[0] / 10;

        BlueBellcurveCalc(0, SSD[0] / distance);

        i = 0;
        scale = Math.abs(MM[i] - (MM[i] - SSD[i])) / 20;
        StartPoint = MM[i] - scale * 50;

        for (j = 0; j < 101; j++) {
            gx[i][j] = StartPoint + j * scale;
            gy[i][j] = probabilityDensityBlue[j] * 10;
            if (gx[i][j] < MM[i]) mmPoint[i] = j + 1;
            if (gx[i][j] < MM[i] - SSD[i]) cutPoint1[i] = j + 1;
            if (gx[i][j] < MM[i] + SSD[i]) cutPoint2[i] = j + 1;
        }

        ctx.fillStyle = 'rgb(0,0,255,0.1)';
        ctx.beginPath();
        ctx.moveTo(ox + a * 10 * (i == 1), oy - a * gx[i][cutPoint1[i]]);
        for (j = cutPoint1[i]; j < cutPoint2[i]; j++) {
            ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][j] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][j]);
        }
        ctx.lineTo(ox + a * 10 * (i == 1), oy - a * gx[i][cutPoint2[i]]);
        ctx.fill();
        ctx.closePath();

        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgb(0,0,255)';
        ctx.setLineDash([3, 2]);
        ctx.beginPath();
        //* Math.pow(-1, i + 1) で正規分布曲線の向きを反転
        ctx.moveTo(ox + a * 10 * (i == 1) + a * gy[i][0] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][0]);
        for (j = 1; j < 101; j++) {
            ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][j] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][j]);
        }

        ctx.beginPath();
        ctx.moveTo(ox, oy - a * gx[i][mmPoint[i]]);
        ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][mmPoint[i]] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][mmPoint[i]]);
        ctx.stroke();
        ctx.closePath();

        ctx.beginPath();
        ctx.moveTo(ox + a * 10 * (i == 1), oy - a * gx[i][cutPoint1[i]]);
        ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][cutPoint1[i]] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][cutPoint1[i]]);
        ctx.stroke();
        ctx.closePath();

        ctx.beginPath();
        ctx.moveTo(ox + a * 10 * (i == 1), oy - a * gx[i][cutPoint2[i]]);
        ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][cutPoint2[i]] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][cutPoint2[i]]);
        ctx.stroke();
        ctx.closePath();

        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgb(0,0,255)';
        ctx.setLineDash([3, 2]);
        ctx.beginPath();
        //* Math.pow(-1, i + 1) で正規分布曲線の向きを反転
        ctx.moveTo(ox + a * 10 * (i == 1) + a * gy[i][0] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][0]);
        for (j = 1; j < 101; j++) {
            ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][j] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][j]);
        }
        ctx.stroke();
        ctx.closePath(); //追加

        //赤の描画
        S = 0;
        SS = 0;
        for (i = 0; i < PN; i++) {
            S = S + Math.floor((oy - y[i] - h / 2) / (a * 10) * 100);
        }
        MM[1] = S / NN;

        for (i = 0; i < PN; i++) {
            SS = SS + Math.pow(MM[1] - Math.floor((oy - y[i] - h / 2) / (a * 10) * 100), 2);
        }
        SSD[1] = Math.sqrt(SS / PN);

        MM[1] = MM[1] / 10;
        SSD[1] = SSD[1] / 10;

        RedBellcurveCalc(0, SSD[1] / distance);

        i = 1;
        scale = Math.abs(MM[i] - (MM[i] - SSD[i])) / 20;
        StartPoint = MM[i] - scale * 50;

        for (j = 0; j < 101; j++) {
            gx[i][j] = StartPoint + j * scale;
            gy[i][j] = probabilityDensityRed[j] * 10;
            if (gx[i][j] < MM[i]) mmPoint[i] = j + 1;
            if (gx[i][j] < MM[i] - SSD[i]) cutPoint1[i] = j + 1;
            if (gx[i][j] < MM[i] + SSD[i]) cutPoint2[i] = j + 1;
        }

        ctx.fillStyle = 'rgb(255,0,0,0.1)';
        ctx.beginPath();
        ctx.moveTo(ox + a * 10 * (i == 1), oy - a * gx[i][cutPoint1[i]]);
        for (j = cutPoint1[i]; j < cutPoint2[i]; j++) {
            ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][j] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][j]);
        }
        ctx.lineTo(ox + a * 10 * (i == 1), oy - a * gx[i][cutPoint2[i]]);
        ctx.fill();
        ctx.closePath();

        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgb(255,0,0)';
        ctx.setLineDash([3, 2]);
        ctx.beginPath();
        //* Math.pow(-1, i + 1) で正規分布曲線の向きを反転
        ctx.moveTo(ox + a * 10 * (i == 1) + a * gy[i][0] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][0]);
        for (j = 1; j < 101; j++) {
            ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][j] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][j]);
        }

        ctx.beginPath();
        ctx.moveTo(ox + a * 10 * (i == 1), oy - a * gx[i][mmPoint[i]]);
        ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][mmPoint[i]] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][mmPoint[i]]);
        ctx.stroke();
        ctx.closePath();

        ctx.beginPath();
        ctx.moveTo(ox + a * 10 * (i == 1), oy - a * gx[i][cutPoint1[i]]);
        ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][cutPoint1[i]] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][cutPoint1[i]]);
        ctx.stroke();
        ctx.closePath();

        ctx.beginPath();
        ctx.moveTo(ox + a * 10 * (i == 1), oy - a * gx[i][cutPoint2[i]]);
        ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][cutPoint2[i]] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][cutPoint2[i]]);
        ctx.stroke();
        ctx.closePath();

        ctx.lineWidth = 1;
        if (i === 0) ctx.strokeStyle = 'rgb(0,0,255)';
        if (i === 1) ctx.strokeStyle = 'rgb(255,0,0)';
        ctx.setLineDash([3, 2]);
        ctx.beginPath();
        //* Math.pow(-1, i + 1) で正規分布曲線の向きを反転
        ctx.moveTo(ox + a * 10 * (i == 1) + a * gy[i][0] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][0]);
        for (j = 1; j < 101; j++) {
            ctx.lineTo(ox + a * 10 * (i == 1) + a * gy[i][j] * 0.6 * Math.pow(-1, i + 1), oy - a * gx[i][j]);
        }
        ctx.stroke();
        ctx.closePath(); //追加

        //ピンクの描画
        S = 0;
        SS = 0;
        for (i = 0; i < PN; i++) {
            S = S + Math.round((x[i] - ox + w / 2) / (a * 10) * 100);
        }
        MM[2] = S / NN;

        for (i = 0; i < PN; i++) {
            SS = SS + Math.pow(MM[2] - Math.round((x[i] - ox + w / 2) / (a * 10) * 100), 2);
        }
        SSD[2] = Math.sqrt(SS / PN);

        MM[2] = MM[2] / 10;
        SSD[2] = SSD[2] / 10;

        PinkBellcurveCalc(0, SSD[2] / distance);

        i = 2;
        scale = Math.abs(MM[i] - (MM[i] - SSD[i])) / 20;
        StartPoint = MM[i] - scale * 50;

        for (j = 0; j < 101; j++) {
            gx[i][j] = StartPoint + j * scale;
            gy[i][j] = probabilityDensityPink[j] * 10;
            if (gx[i][j] < MM[i]) mmPoint[i] = j + 1;
            if (gx[i][j] < MM[i] - SSD[i]) cutPoint1[i] = j + 1;
            if (gx[i][j] < MM[i] + SSD[i]) cutPoint2[i] = j + 1;
        }

        // 平均±標準偏差の範囲の描画
        ctx.fillStyle = 'rgb(255,0,255,0.1)';
        ctx.beginPath();
        ctx.moveTo(ox + a * gx[i][cutPoint1[i]], oy - a * 10);
        for (j = cutPoint1[i]; j < cutPoint2[i]; j++) {
            ctx.lineTo(ox + a * gx[i][j], oy - a * 10 - a * gy[i][j] * 0.6);
        }
        ctx.lineTo(ox + a * gx[i][cutPoint2[i]], oy - a * 10);
        ctx.fill();
        ctx.closePath();

        // 正規分布曲線の描画
        ctx.setLineDash([3, 2]);
        ctx.strokeStyle = 'rgb(255,0,255)';
        ctx.beginPath();
        ctx.moveTo(ox + a * gx[i][0], oy - a * 10 - a * gy[i][0] * 0.6);
        for (j = 1; j < 101; j++) {
            ctx.lineTo(ox + a * gx[i][j], oy - a * 10 - a * gy[i][j] * 0.6);
        }
        ctx.stroke();
        ctx.closePath(); //追加

        // 平均と標準偏差の線の描画
        ctx.setLineDash([3, 2]);
        ctx.beginPath();
        ctx.moveTo(ox + a * gx[i][mmPoint[i]], oy - a * 10);
        ctx.lineTo(ox + a * gx[i][mmPoint[i]], oy - a * 10 - a * gy[i][mmPoint[i]] * 0.6);
        ctx.stroke();
        ctx.closePath();

        ctx.beginPath();
        ctx.moveTo(ox + a * gx[i][cutPoint1[i]], oy - a * 10);
        ctx.lineTo(ox + a * gx[i][cutPoint1[i]], oy - a * 10 - a * gy[i][cutPoint1[i]] * 0.6);
        ctx.stroke();
        ctx.closePath();

        ctx.beginPath();
        ctx.moveTo(ox + a * gx[i][cutPoint2[i]], oy - a * 10);
        ctx.lineTo(ox + a * gx[i][cutPoint2[i]], oy - a * 10 - a * gy[i][cutPoint2[i]] * 0.6);
        ctx.stroke();
        ctx.closePath();

    }
}
function DrawPoint() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    var PN = document.getElementById('PN_number').value;
    for (var i = 0; i < PN; i++) {
        // 画像を描画した時の情報を記憶
        images[i].drawOffsetX = x[i];
        images[i].drawOffsetY = y[i];
        images[i].drawWidth = w;
        images[i].drawHeight = h;

        // 画像を描画
        ctx.drawImage(images[i], x[i], y[i], w, h);
    }
}
function DrawText(tx, ty) {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    if (document.getElementById('Regressionline').checked) {
        ctx.font = "12px Arial";
        ctx.textAlign = "right";
        var x = Math.floor((tx - ox) * 10 / a);
        ctx.fillText(x, tx, oy + 16);
        var y = Math.floor(A * x + B);
        ctx.fillText(y, ox - 8, oy - y * a / 10);

        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgb(255,165,0)';
        ctx.setLineDash([]);
        ctx.beginPath();
        ctx.moveTo(tx, oy);
        ctx.lineTo(tx, oy - y * a / 10);
        ctx.stroke();
        ctx.beginPath();
        ctx.moveTo(tx, oy - y * a / 10);
        ctx.lineTo(ox, oy - y * a / 10);
        ctx.stroke();
        ctx.closePath(); //追加

    }
}
function DrawX() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    PN = document.getElementById('PN_number').value;

    if (document.getElementById('Suportline').checked) {
        var S = 0;
        for (var i = 0; i < PN; i++) {
            ctx.setLineDash([]);
            ctx.beginPath();
            ctx.lineWidth = 1;
            ctx.strokeStyle = 'rgb(255,0,255)';
            ctx.arc(x[i] + h / 2, oy - a * 10, 4, 0, 360);
            ctx.fillStyle = 'rgb(255,0,255)';
            ctx.fill();
            ctx.stroke();
            ctx.closePath(); //追加

            S += Math.round((x[i] - ox + w / 2) / (a * 10) * 100)
        }
        var M = S / NN;
        ctx.beginPath();
        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgb(255,0,255)';
        // ctx.arc(M * a / 10, oy - a * 10, 4, 0, 360);
        ctx.arc(ox + M * a / 10, oy - a * 10 - h / 2, 4, 0, 360);
        ctx.fillStyle = 'rgb(255,255,255)';
        ctx.fill();
        ctx.stroke();
        ctx.closePath(); //追加
    }
}
function DrawY() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    PN = document.getElementById('PN_number').value;

    if (document.getElementById('Suportline').checked) {
        var S = 0;
        for (var i = 0; i < PN; i++) {
            ctx.setLineDash([]);
            ctx.beginPath();
            ctx.lineWidth = 1;
            ctx.strokeStyle = 'rgb(255,0,0)';
            ctx.arc(ox + a * 10, y[i] + w / 2, 4, 0, 360);
            ctx.fillStyle = 'rgb(255,0,0)';
            ctx.fill();
            ctx.stroke();
            ctx.closePath(); //追加

            S += Math.floor((oy - y[i] - h / 2) / (a * 10) * 100);
        }
        var M = S / NN;
        ctx.beginPath();
        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgb(255,0,0)';
        ctx.arc(ox + a * 10 + w / 2, oy - M * a / 10, 4, 0, 360);
        ctx.fillStyle = 'rgb(255,255,255)';
        ctx.fill();
        ctx.stroke();
        ctx.closePath(); //追加
    }
}
function DrawYY() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    PN = document.getElementById('PN_number').value;
    var YY, ZZ;
    var xx, yy;

    if (document.getElementById('Suportline').checked) {
        for (var i = 0; i < PN; i++) {
            ctx.setLineDash([]);
            ctx.beginPath();
            ctx.lineWidth = 1;
            ctx.strokeStyle = 'rgb(0,0,255)';

            xx = Math.floor((x[i] - ox + w / 2) / (a * 10) * 100);
            yy = Math.floor((oy - y[i] - h / 2) / (a * 10) * 100);

            YY = Math.floor(A * xx + B);
            ZZ = B - (YY - yy);

            ctx.arc(ox, oy - ZZ * a / 10, 4, 0, 360);
            ctx.fillStyle = 'rgb(0,0,255)';
            ctx.fill();
            ctx.stroke();
            ctx.closePath(); //追加

            // ctx.strokeStyle = 'rgb(0,0,255,0.5)';
            ctx.strokeStyle = 'rgb(124,124,124,0.5)';
            ctx.beginPath();
            ctx.moveTo(x[i] + w / 2, y[i] + w / 2);
            ctx.lineTo(ox, oy - ZZ * a / 10);
            ctx.stroke();
            ctx.closePath(); //追加
        }

        ctx.beginPath();
        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgb(0,0,255)';
        ctx.arc(ox - w / 2, oy - B * a / 10, 4, 0, 360);
        ctx.fillStyle = 'rgb(255,255,255)';
        ctx.fill();
        ctx.stroke();
        ctx.closePath(); //追加
    }

}
function setCorr() {
    var PN = document.getElementById('PN_number').value;
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');
    var isDragging = false;
    var dragTarget = null; // ドラッグ対象の画像の添え字
    var isDown = false;
    var DownCount = 0;

    setData();
    DrawAxis();

    s_calc_corr();
    // images[PN - 1].addEventListener('load', function () {
    // }, false);

    DrawLine();

    DrawX();
    DrawY();
    DrawYY();

    DrawAxisNum();
    DrawPoint();

    Message();
}
function mainCorr() {
    var PN = document.getElementById('PN_number').value;
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');
    var isDragging = false;
    var dragTarget = null; // ドラッグ対象の画像の添え字

    setData();
    DrawAxis();

    s_calc_corr();
    DrawLine();

    DrawX();
    DrawY();
    DrawYY();

    DrawAxisNum();
    images[PN - 1].addEventListener('load', function () {
        DrawPoint();
    }, false);

    Message();

    // ドラッグ開始
    var mouseDown = function (e) {
        PN = document.getElementById('PN_number').value;
        var event;
        if (e.type === "mousedown") {
            event = e;
        } else {
            event = e.changedTouches[0];
        }

        // ドラッグ開始位置
        var posX = parseInt(event.clientX - canvas.getBoundingClientRect().left);
        var posY = parseInt(event.clientY - canvas.getBoundingClientRect().top);
        console.log(PN);
        var DData = document.getElementById("DataArea").value;
        for (var i = PN - 1; i >= 0; i--) {
            // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
            if (posX >= images[i].drawOffsetX - w / 2 &&
                posX <= (images[i].drawOffsetX + images[i].drawWidth + w / 2) &&
                posY >= images[i].drawOffsetY - h / 2 &&
                posY <= (images[i].drawOffsetY + images[i].drawHeight + h / 2)
            ) {
                dragTarget = i;
                isDragging = true;

                //点の削除
                if (document.getElementById("del").checked) {
                    var dd = [];
                    dd = DData.split("\n");
                    var d_str = [];
                    if (PN > 2) {
                        for (ii = 0; ii < PN; ii++) {
                            if (ii != dragTarget) {
                                d_str.push(dd[ii]);
                            }
                        }
                        document.getElementById("DataArea").value = d_str.join("\n");
                        checkData();
                        isDragging = false;
                    }
                }
                break;
            }
        }
    };

    // ドラッグ終了
    var mouseUp = function (e) {
        //点の追加
        var DData = document.getElementById("DataArea").value;
        var posX = parseInt(event.clientX - canvas.getBoundingClientRect().left);
        var posY = parseInt(event.clientY - canvas.getBoundingClientRect().top);
        var _x = 0;
        var _y = 0;
        if (document.getElementById("add").checked) {
            _x = Math.round((posX - ox) / (a * 10) * 100);
            _y = Math.round((oy - posY) / (a * 10) * 100);
            document.getElementById("DataArea").value = DData + "\n" + _x + "\t" + _y + "\n";
            checkData();
        }
        isDragging = false;
    };

    // canvasの枠から外れた
    var mouseOut = function (e) {
        // canvas外にマウスカーソルが移動した場合に，ドラッグ終了としたい場合はコメントインする
        // mouseUp(e);
    };

    // ドラッグ中
    var mouseMove = function (e) {

        var event;
        if (e.type === "mousemove") {
            event = e;
        } else {
            event = e.changedTouches[0];
        }

        // ドラッグ終了位置
        var posX = parseInt(event.clientX - canvas.getBoundingClientRect().left);
        var posY = parseInt(event.clientY - canvas.getBoundingClientRect().top);

        //フリックしたときに画面を動かさないようにデフォルト動作を抑制
        e.preventDefault();

        for (var i = PN - 1; i >= 0; i--) {
            // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
            if (posX >= images[i].drawOffsetX - w / 2 &&
                posX <= (images[i].drawOffsetX + images[i].drawWidth + w / 2) &&
                posY >= images[i].drawOffsetY - h / 2 &&
                posY <= (images[i].drawOffsetY + images[i].drawHeight + h / 2)
            ) {
                _dx = Math.round((x[i] - ox + w / 2) / (a * 10) * 100);
                _dy = Math.round((oy - y[i] - h / 2) / (a * 10) * 100);
                document.getElementById("dataText").innerHTML = "DATA:" + (i + 1) + "　(X,Y)=(" + _dx + "," + _dy + ")";
                break;
            } else {
                document.getElementById("dataText").innerHTML = "　";
            }
        }

        if ((posX < ox) || (posX > ox + a * 10) || (posY < oy - a * 10) || (posY > oy)) {
            isDragging = false;
        }

        if ((posX > ox) && (posX < ox + a * 10) && (posY > oy) && (posY < oy + 30)) {
            DrawAxis();
            DrawLine();

            DrawX();
            DrawY();
            DrawYY();

            DrawAxisNum();
            DrawPoint();
            DrawText(posX, posY);
        } else {
            DrawAxis();
            DrawLine();

            DrawX();
            DrawY();
            DrawYY();

            DrawAxisNum();
            DrawPoint();
        }

        if (isDragging) {
            var mx = 0;
            var my = 0;
            for (i = 0; i < PN; i++) {
                if (i == dragTarget) {
                    mx = posX - images[i].drawWidth / 2;
                    my = posY - images[i].drawHeight / 2;

                    // ドラッグが終了した時の情報を記憶
                    images[i].drawOffsetX = mx;
                    images[i].drawOffsetY = my;
                } else {
                    mx = images[i].drawOffsetX;
                    my = images[i].drawOffsetY;
                }
                w = images[i].drawWidth;
                h = images[i].drawHeight;

                x[i] = mx;
                y[i] = my;
            }

            DrawAxis();

            s_calc_corr();

            DrawLine();

            DrawX();
            DrawY();
            DrawYY();
            DrawAxisNum();
            DrawPoint();
        }
    };

    // canvasにイベント登録
    // canvas.addEventListener('mousedown', function (e) { mouseDown(e); }, { once: false }, false);
    // canvas.addEventListener('mousemove', function (e) { mouseMove(e); }, { once: false }, false);
    // canvas.addEventListener('mouseup', function (e) { mouseUp(e); }, { once: false }, false);
    // canvas.addEventListener('mouseout', function (e) { mouseOut(e); }, { once: false }, false);

    // canvas.addEventListener('touchstart', function (e) { mouseDown(e); }, { once: false }, false);
    // canvas.addEventListener('touchmove', function (e) { mouseMove(e); }, { once: false }, false);
    // canvas.addEventListener('touchend', function (e) { mouseUp(e); }, { once: false }, false);
    // canvas.addEventListener('touchleave', function (e) { mouseOut(e); }, { once: false }, false);

    canvas.addEventListener('mousedown', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('mousemove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('mouseup', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('mouseout', function (e) { mouseOut(e); }, false);

    canvas.addEventListener('touchstart', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('touchmove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('touchend', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('touchleave', function (e) { mouseOut(e); }, false);
}
function s_calc_corr() {
    var KK = 2;
    var M = [];
    var SD = [];

    var PN = document.getElementById('PN_number').value;
    NN = PN;

    for (var i = 0; i < PN; i++) {
        xx[i][0] = Math.round((x[i] - ox + w / 2) / (a * 10) * 100);
        xx[i][1] = Math.round((oy - y[i] - h / 2) / (a * 10) * 100);
    }

    //基本統計量
    var S = 0;
    var SS = 0;
    for (j = 0; j < KK; j++) {
        S = 0;
        SS = 0;
        for (i = 0; i < NN; i++) {
            S += xx[i][j];
            SS += Math.pow(xx[i][j], 2);
        }
        M[j] = S / NN;
        SD[j] = Math.sqrt(SS / NN - Math.pow(M[j], 2));
    }

    R = 0;
    var FF = 0;
    var F$ = "";

    var FF1, FF2, FF3;
    FF3 = f_tables(2, NN); //１％水準
    FF2 = f_tables(1, NN); //５％水準
    FF1 = f_tables(0, NN); //１０％水準

    S = 0;
    for (i = 0; i < NN; i++) {
        S += (xx[i][0] - M[0]) * (xx[i][1] - M[1]);
    }
    R = S / NN / SD[0] / SD[1];
    if (R > 0.9999) {
        if (Math.pow(R, 2) == 1) {
            FF = 0;
        } else {
            FF = 999.99;
        }
    } else {
        if (Math.pow(R, 2) == 1) {
            FF = 0;
        } else {
            FF = Math.pow(R, 2) / (1 - Math.pow(R, 2)) * (NN - 2);
        }
    }
    if (NN > 2) {
        if (FF > FF3) { //１％水準
            // F$ = " ** (p&lt;.01)";
            F$ = " p&lt;.01 ";
        } else if (FF > FF2) { //５％水準
            // F$ = " *  (p&lt;.05)";
            F$ = " p&lt;.05 ";
        } else if (FF > FF1) { //１０％水準
            // F$ = " + (.05&lt;p&lt;.10)";
            F$ = " .05&lt;p&lt;.10 ";
        } else {
            // F$ = " ns (.10&lt;p)";
            F$ = " ns ";
        }
    } else {
        // F$ = " ns (.10&lt;p)";
        F$ = " ns ";
    }

    //回帰直線の傾き
    A = R * (SD[1] / SD[0]);
    //回帰直線の切片
    B = M[1] - A * M[0];

    //説明率
    var SS1 = 0;
    for (i = 0; i < PN; i++) {
        SS1 += Math.pow(xx[i][1] - M[1], 2);
    }
    var SS2 = 0;
    for (i = 0; i < PN; i++) {
        YY = A * xx[i][0] + B;
        SS2 += Math.pow(xx[i][1] - YY, 2);
    }
    var ExplanationRate = (1 - SS2 / SS1).toFixed(3);

    //スピアマンの順位相関係数
    var trankedArray = [[], []];
    var countedArray2 = [[], []];

    var addedArray = [];
    var rerankedArray = [];
    var sortedArray = [];
    var rankedArray = [];
    var countedArray = [];

    for (k = 0; k < 2; k++) {
        addedArray.splice(0); //配列のすべての要素を削除
        rerankedArray.splice(0);

        for (i = 0; i < PN; i++) {
            addedArray.push(xx[i][k]);
        }

        sortedArray = addedArray.sort(compareNumbers);
        rankedArray.splice(0);
        for (i = 0; i < PN; i++) {
            rankedArray[i] = i + 1;
        }

        for (i = 0; i < PN; i++) {
            if (sortedArray[i] === sortedArray[i - 1]) {
                rankedArray[i] = rankedArray[i - 1];
            }
        }

        countedArray.splice(0);
        for (i = 0; i < PN; i++) {
            countedArray[i] = 0;
            for (j = 0; j < PN; j++) {
                if (rankedArray[i] === rankedArray[j]) {
                    countedArray[i]++;
                }
            }
        }

        rerankedArray.splice(0);
        for (i = 0; i < PN; i++) {
            rerankedArray[i] = (rankedArray[i] * 2 + countedArray[i] - 1) / 2;
        }

        for (i = 0; i < PN; i++) {
            for (ii = 0; ii < PN; ii++) {
                if (sortedArray[i] === xx[ii][k]) {
                    trankedArray[k][ii] = rerankedArray[i];
                    countedArray2[k][ii] = countedArray[i];
                }
            }
        }

        for (i = 0; i < PN - 1; i++) {
            for (j = i + 1; j < PN; j++) {
                if (trankedArray[k][i] == trankedArray[k][j]) {
                    countedArray2[k][j] = 0;
                }
            }
        }
    }

    var crX = 0; //Xの補正値
    var crY = 0; //Yの補正値
    var d = 0; //XとYの順位差の二乗和

    var _offset = 0;
    for (i = 0; i < PN; i++) {
        _offset = Math.pow(countedArray2[0][i], 3) - countedArray2[0][i];
        crX = crX + _offset;
    }
    crX = crX / 12;

    _offset = 0;
    for (i = 0; i < PN; i++) {
        _offset = Math.pow(countedArray2[1][i], 3) - countedArray2[1][i];
        crY = crY + _offset;
    }
    crY = crY / 12;

    for (i = 0; i < PN; i++) {
        d = d + Math.pow(trankedArray[0][i] - trankedArray[1][i], 2);
    }

    var N3N = Math.pow(NN, 3) - NN;

    var RS = (N3N / 6 - (d + crX + crY)) / Math.sqrt(N3N / 6 - 2 * crX) / Math.sqrt(N3N / 6 - 2 * crY);

    //結果出力
    document.getElementById("r").innerHTML = R.toFixed(3);
    document.getElementById("fratio").innerHTML = " ( F(1," + (NN - 2) + ")=" + FF.toFixed(2) + " , ";
    document.getElementById("test").innerHTML = F$ + ")";
    document.getElementById("ExplanationRate").innerHTML = ExplanationRate;
    document.getElementById("rs").innerHTML = RS.toFixed(3);

    //データ出力
    var corrData = [];
    for (i = 0; i < PN; i++) {
        corrData.push(xx[i][0] + "\t" + xx[i][1]);
    }
    document.getElementById("DataArea").value = corrData.join('\n');
    corrData = null;
}
function checkData() {
    var err = false;
    // DataAreaが空でない
    if (document.getElementById("DataArea").value != "") {

        var DData = dataremake5("DataArea");
        DData = crDel(DData);
        var dd = [];
        dd = DData.split(" ");

        // データが行列形式である
        var NN = countRowCol("DataArea")[0]; // 行数を取得
        var KK = countRowCol("DataArea")[1]; // 列数を取得
        if (KK === -1) {
            err = true;
            alert("データが行列形式ではありません");
        }

        //２変数である
        if (KK > 2) {
            err = true;
            alert("データが２変数ではありません");
        }

        //0～100の範囲である
        var rangeCheck = true;
        dd.forEach(function (value) {
            if (value > 100) {
                err = true;
                rangeCheck = false;
            }
            if (value < 0) {
                err = true;
                rangeCheck = false;
            }
        });
        if (rangeCheck === false) {
            alert("データ範囲は，0～100までです");
        }

        if (err === false) {
            dataDraw();
        }
    }
}
function dataDraw() {
    var i = 0;
    var j = 0;
    var k = 0;

    var NN = countRowCol("DataArea")[0]; // 行数を取得
    var KK = countRowCol("DataArea")[1]; // 列数を取得

    var DData = dataremake5("DataArea");
    DData = crDel(DData);
    var dd = [];
    dd = DData.split(" ");

    var xx = new Array(NN);
    for (i = 0; i < NN; i++) {
        xx[i] = new Array(KK);
    }

    var ddCount = 0;
    for (i = 0; i < NN; i++) {
        for (j = 0; j < KK; j++) {
            xx[i][j] = parseInt(dd[ddCount]);
            ddCount++;
            x[i] = parseFloat(ox + xx[i][0] / 100 * (a * 10) - w / 2, 10);
            y[i] = parseFloat(oy - xx[i][1] / 100 * (a * 10) - h / 2, 10);
        }
    }

    document.getElementById('PN_number').value = NN;

    DrawAxis();

    s_calc_corr();

    DrawX();

    DrawY();
    DrawYY();
    DrawAxisNum();

    DrawLine();

    DrawPoint();
}
function WriteText() {
    if (document.getElementById('Suportline').checked) {
        document.getElementById('curveText').innerHTML = "※ 正規分布曲線は理論形";
    } else {
        document.getElementById('curveText').innerHTML = "　";
    }

}