
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();
};
//canvasサイズ
var cw = 550; //幅
var ch = 320; //高さ

var a = 28; //座標の幅
// 原点の位置
var ox = (cw - a * 10) / 2;
var oy = a * 10 + (ch - a * 10) / 2;

var PN = 10; //群（点）の数

var images = []; //点の画像配列
var _rnd = Math.floor(Math.random() * (10000));
for (i = 0; i < PN; i++) {
    images[i] = new Image();
    var str = '?var=' + _rnd;
    images[i].src = '../image/point_puma.png' + str;
}
var w = 14; //点の幅
var h = 14; //点の高さ

//点の値
var x = [];
var y = [];

// var probabilityDensity = [
//     0.000, 0.000, 0.000, 0.000, 0.001, 0.001, 0.001, 0.002, 0.002,
//     0.003, 0.004, 0.006, 0.008, 0.010, 0.014, 0.018, 0.022, 0.028,
//     0.035, 0.044, 0.054, 0.066, 0.079, 0.094, 0.111, 0.130, 0.150,
//     0.171, 0.194, 0.218, 0.242, 0.266, 0.290, 0.312, 0.333, 0.352,
//     0.368, 0.381, 0.391, 0.397, 0.399, 0.397, 0.391, 0.381, 0.368,
//     0.352, 0.333, 0.312, 0.290, 0.266, 0.242, 0.218, 0.194, 0.171,
//     0.150, 0.130, 0.111, 0.094, 0.079, 0.066, 0.054, 0.044, 0.035,
//     0.028, 0.022, 0.018, 0.014, 0.010, 0.008, 0.006, 0.004, 0.003,
//     0.002, 0.002, 0.001, 0.001, 0.001, 0.000, 0.000, 0.000, 0.000
// ];

var probabilityDensity = [];

function BellcurveCalc(mean, sd) {
    var Mean = mean;
    var Sd = sd;
    var x = -5;
    for (var i = 0; i < 101; i++) {
        probabilityDensity[i] = 1 / (Math.sqrt(2 * Math.PI) * Sd) * Math.exp(-Math.pow((x - Mean), 2) / (2 * Math.pow(Sd, 2)));
        probabilityDensity[i] = probabilityDensity[i].toFixed(3);
        x = x + 0.1;
    }
}

//分散分析のための設定
var AA = 'A';
var LA = 3;

var NN = new Array(LA);
var NA = new Array(LA);

var M = new Array(LA);

var SD = new Array(LA);

function setUp() {
    setData();
    DrawAxis();
    DrawLine();
    DrawPoint();
    DrawTable();
    printData();
    s_calc_mean();
}
function setData() {
    for (var i = 0; i < PN; i++) {
        x[i] = ox + a * Math.floor(Math.random() * (100 - 0) + 0) / 10;
        y[i] = oy;
    }
    //データを昇順にソート
    x = x.sort(compareNumbers);
}
function DrawAxis() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    ctx.clearRect(0, 0, canvas.width, canvas.height);

    ctx.lineWidth = 1;
    ctx.strokeStyle = 'rgb(128,128,128)';

    ctx.setLineDash([3, 3]);
    ctx.beginPath();
    ctx.moveTo(ox + a * 2, oy);
    ctx.lineTo(ox + a * 2, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 8, oy);
    ctx.lineTo(ox + a * 8, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 10, oy);
    ctx.lineTo(ox + a * 10, oy - a * 10);
    ctx.stroke();

    for (i = 1; i < 11; i++) {
        ctx.beginPath();
        ctx.moveTo(ox + a * i, oy);
        ctx.lineTo(ox + a * i, oy - a * 10);
        ctx.stroke();
    }

    for (j = 1; j < 11; j++) {
        ctx.beginPath();
        ctx.moveTo(ox, oy - a * j);
        ctx.lineTo(ox + a * 10, oy - a * j);
        ctx.stroke();
    }

    ctx.strokeStyle = 'rgb(0,0,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox + a * 10, oy);
    ctx.stroke();

    ctx.font = "16px Arial";
    ctx.textAlign = "right";
    ctx.fillStyle = 'rgb(0,0,0)';
    ctx.fillText(0, ox + a * 0 + 10 - 8, oy + 20);
    //横軸
    for (i = 1; i < 11; i++) {
        ctx.fillText(i, ox + a * i + 10 - 5, oy + 20);
    }

    var figure = document.getElementById("figure").value;
    //縦軸
    if (figure === 'hist') {
        for (j = 1; j < 11; j++) {
            ctx.fillText(j, ox - 5, oy - a * j + 10);
        }
    }
    if (figure === 'curve') {
        for (j = 1; j < 11; j++) {
            ctx.fillText(j / 10, ox - 5, oy - a * j + 10);
        }
    }
}
function DrawLine() {
    var i;
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');

    var S = 0;
    var tX = [];
    for (i = 0; i < PN; i++) {
        tX[i] = (x[i] - ox) / a;
        S = S + tX[i];
    }
    var MM = S / PN;

    var SS = 0;
    for (i = 0; i < PN; i++) {
        SS = SS + Math.pow(MM - tX[i], 2);
    }
    var SSD = Math.sqrt(SS / PN);

    var gx = [];
    var gy = [];
    // var scale = Math.abs(MM - (MM - SSD)) / 20;
    // var StartPoint = MM - scale * 40;
    // var mmPoint = 0;
    // var cutPoint1 = 0;
    // var cutPoint2 = 0;
    // for (i = 0; i < 81; i++) {
    //     gx[i] = StartPoint + i * scale;
    //     gy[i] = probabilityDensity[i] * 10;
    //     if (gx[i] < MM) mmPoint = i + 1;
    //     if (gx[i] < MM - SSD) cutPoint1 = i + 1;
    //     if (gx[i] < MM + SSD) cutPoint2 = i + 1;
    // }

    BellcurveCalc(0, SSD);

    var scale = Math.abs(MM - (MM - SSD)) / 20;
    var StartPoint = MM - scale * 50;
    var mmPoint = 0;
    var cutPoint1 = 0;
    var cutPoint2 = 0;
    for (i = 0; i < 101; i++) {
        gx[i] = StartPoint + i * scale;
        gy[i] = probabilityDensity[i] * 10;
        if (gx[i] < MM) mmPoint = i + 1;
        if (gx[i] < MM - SSD) cutPoint1 = i + 1;
        if (gx[i] < MM + SSD) cutPoint2 = i + 1;
    }


    // var url = location.search;
    var url = new URL(window.location.href);
    var params = url.searchParams;
    var r = params.get('r');
    var k = params.get('k');
    var s = params.get('s');
    var b = params.get('b');

    //各素データから正規乱数を発生
    var rand = [];
    var rNum = 50; //発生させる乱数の数

    if (r !== null) rNum = r;

    var rCount = 0; //乱数の数をカウントする
    var r1, r2, z;
    var sd = 1.0;
    if (s !== null) sd = s;

    for (i = 0; i < 10; i++) {
        for (j = 0; j < rNum; j++) {
            r1 = Math.random();
            r2 = Math.random();
            z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
            rand[rCount] = (z * sd + tX[i]);
            rCount++;
        }
    }

    var kaikyu = [];
    var kaikyuNum = 18;

    if (k !== null) kaikyuNum = k;

    var khaba = 14 / kaikyuNum;
    for (j = 0; j < kaikyuNum + 1; j++) {
        kaikyu[j] = (j - 2) * khaba;
    }
    var dosu = [];
    for (j = 0; j < kaikyuNum + 2; j++) {
        dosu[j] = 0;
    }
    for (i = 0; i < rand.length; i++) {
        for (j = 0; j < kaikyuNum + 1; j++) {
            if (rand[i] >= -2 && rand[i] <= 14) {
                if (rand[i] < kaikyu[j]) break;
            }
        }
        dosu[j] = dosu[j] + 1;
    }
    var figure = document.getElementById("figure").value;

    //ヒストグラム
    var barSize = 1;
    if (b !== null) barSize = b;

    ctx.fillStyle = 'rgba(165,233,0,0.5)';
    ctx.beginPath();
    for (j = 0; j < kaikyuNum + 1; j++) {
        ctx.fillRect(ox + a * khaba * (j - 1 - 2), oy - dosu[j] * barSize, a * khaba, dosu[j] * barSize);
    }
    ctx.closePath();

    if (figure === 'barplot') {
        //平均を描画
        ctx.lineWidth = 3;
        ctx.strokeStyle = 'rgb(255,165,0)';
        ctx.setLineDash([]);
        ctx.beginPath();
        ctx.moveTo(ox + a * (MM - SSD), oy);
        ctx.lineTo(ox + a * (MM - SSD), oy - a * MM);
        ctx.moveTo(ox + a * (MM - SSD), oy - a * MM);
        ctx.lineTo(ox + a * (MM + SSD), oy - a * MM);
        ctx.moveTo(ox + a * (MM + SSD), oy - a * MM);
        ctx.lineTo(ox + a * (MM + SSD), oy);
        ctx.stroke();

        //標準偏差を描画
        ctx.lineWidth = 2;
        ctx.strokeStyle = 'rgb(255,165,0)';
        ctx.setLineDash([]);
        ctx.beginPath();
        ctx.moveTo(ox + a * (MM - 1), oy - a * (MM + SSD));
        ctx.lineTo(ox + a * (MM + 1), oy - a * (MM + SSD));
        ctx.moveTo(ox + a * MM, oy - a * MM);
        ctx.lineTo(ox + a * MM, oy - a * (MM + SSD));
        ctx.stroke();

        ctx.closePath();
    }

    if (figure === 'curve') {
        //正規分布を描画
        ctx.lineWidth = 3;
        ctx.strokeStyle = 'rgb(255,165,0)';
        ctx.setLineDash([]);
        ctx.beginPath();
        ctx.moveTo(ox + a * gx[0], oy - a * gy[0]);
        for (i = 1; i < 101; i++) {
            ctx.lineTo(ox + a * gx[i], oy - a * gy[i]);
        }
        ctx.stroke();

        ctx.lineWidth = 2;
        // ctx.strokeStyle = 'rgb(255,165,0)';
        ctx.strokeStyle = 'rgb(255,0,0)';
        ctx.setLineDash([6, 2]);
        ctx.beginPath();
        ctx.moveTo(ox + a * gx[mmPoint], oy);
        ctx.lineTo(ox + a * gx[mmPoint], oy - a * gy[mmPoint]);
        ctx.stroke();

        ctx.beginPath();
        ctx.moveTo(ox + a * gx[cutPoint1], oy);
        ctx.lineTo(ox + a * gx[cutPoint1], oy - a * gy[cutPoint1]);
        ctx.stroke();

        ctx.beginPath();
        ctx.moveTo(ox + a * gx[cutPoint2], oy);
        ctx.lineTo(ox + a * gx[cutPoint2], oy - a * gy[cutPoint2]);
        ctx.stroke();

        ctx.closePath();
    }
}
function DrawPoint() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');
    for (var i in images) {
        // 画像を描画した時の情報を記憶
        images[i].drawOffsetX = x[i];
        images[i].drawOffsetY = y[i];
        images[i].drawWidth = w;
        images[i].drawHeight = h;

        // 画像を描画
        ctx.drawImage(images[i], x[i] - w / 2, y[i] - h / 2, w, h);
    }
}
function DrawTable() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');
    ctx.lineWidth = 1;

    ctx.fillStyle = '#DDDDFF';
    ctx.beginPath();
    ctx.fillRect(ox, oy + a * (0 + 2), a * 2.5, a * 2);
    ctx.fillRect(ox + a * 5, oy + a * (0 + 2), a * 2.5, a * 2);
    ctx.closePath();

    ctx.strokeStyle = 'rgb(100,100,100)';
    ctx.setLineDash([]);
    ctx.beginPath();
    for (i = 0; i < 3; i++) {
        ctx.moveTo(ox, oy + a * (i + 2));
        ctx.lineTo(ox + a * 10, oy + a * (i + 2));
    }
    for (j = 0; j < 5; j++) {
        ctx.moveTo(ox + a * j * 2.5, oy + a * 2);
        ctx.lineTo(ox + a * j * 2.5, oy + a * 4);
    }
    ctx.stroke();
    ctx.closePath();

}
function printData() {
    var tX = []; //素データ
    var hX = []; //偏差
    var h2X = []; //偏差平方
    for (i = 0; i < PN; i++) {
        tX[i] = (x[i] - ox) / a;
        tX[i] = Math.round(tX[i] * 10) / 10; //小数第1位で四捨五入
    }

    var S = 0;
    for (i = 0; i < PN; i++) {
        S = S + tX[i];
    }
    var MM = S / PN;
    MM = Math.round(MM * 100) / 100; //小数第2位で四捨五入

    for (i = 0; i < PN; i++) {
        hX[i] = tX[i] - MM;
        hX[i] = Math.round(hX[i] * 10) / 10; //小数第1位で四捨五入
        h2X[i] = hX[i] * hX[i];
        h2X[i] = Math.round(h2X[i] * 100) / 100; //小数第1位で四捨五入
    }

    var name = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J"];
    for (i = 0; i < PN; i++) {
        document.getElementById(name[i] + '_x').innerHTML = tX[i].toFixed(1);
        document.getElementById(name[i] + '_S').innerHTML = hX[i].toFixed(1);
        document.getElementById(name[i] + '_SS').innerHTML = h2X[i].toFixed(2);
    }
}
function mainMean() {
    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');
    var dragTarget = null;
    var isDragging = false;

    setData();
    DrawAxis();
    DrawLine();

    images[PN - 1].addEventListener('load', function () {
        DrawPoint();
    }, false);

    DrawTable();
    printData();
    s_calc_mean();

    // ドラッグ開始
    var mouseDown = function (e) {

        var event;
        if (e.type === "mousedown") {
            event = e;
        } else {
            event = e.changedTouches[0];
        }

        // ドラッグ開始位置
        var posX = parseInt(event.clientX - canvas.getBoundingClientRect().left);
        var posY = parseInt(event.clientY - canvas.getBoundingClientRect().top);

        for (var i = images.length - 1; i >= 0; i--) {
            // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
            if (posX >= images[i].drawOffsetX - w / 2 &&
                posX <= (images[i].drawOffsetX + images[i].drawWidth + w / 2) &&
                posY >= images[i].drawOffsetY - h / 2 &&
                posY <= (images[i].drawOffsetY + images[i].drawHeight + h / 2)
            ) {
                dragTarget = i;
                isDragging = true;
                break;
            }
        }

    };

    // ドラッグ終了
    var mouseUp = function (e) {
        isDragging = false;
    };

    // canvasの枠から外れた
    var mouseOut = function (e) {
        // canvas外にマウスカーソルが移動した場合に，ドラッグ終了としたい場合はコメントインする
        // mouseUp(e);
    };

    // ドラッグ中
    var mouseMove = function (e) {

        var event;
        if (e.type === "mousemove") {
            event = e;
        } else {
            event = e.changedTouches[0];
        }

        // ドラッグ終了位置
        var posX = parseInt(event.clientX - canvas.getBoundingClientRect().left);
        var posY = parseInt(event.clientY - canvas.getBoundingClientRect().top);

        //フリックしたときに画面を動かさないようにデフォルト動作を抑制
        e.preventDefault();

        if ((posX < ox + a / 4) || (posX > ox + a * 10 + a / 4)) {
            isDragging = false;
        }

        if (isDragging) {
            var mx = 0;
            var my = 0;

            for (var i in images) {
                if (i == dragTarget) {
                    mx = posX - images[i].drawWidth / 2;
                    my = images[i].drawOffsetY;

                    // ドラッグが終了した時の情報を記憶
                    images[i].drawOffsetX = mx;
                    images[i].drawOffsetY = my;
                } else {
                    mx = images[i].drawOffsetX;
                    my = images[i].drawOffsetY;
                }
                w = images[i].drawWidth;
                h = images[i].drawHeight;

                x[i] = mx;
                y[i] = my;
            }

            DrawAxis();
            DrawLine();
            DrawPoint();
            DrawTable();

            printData();

            s_calc_mean();
        }
    };

    // canvasにイベント登録
    canvas.addEventListener('mousedown', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('mousemove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('mouseup', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('mouseout', function (e) { mouseOut(e); }, false);

    canvas.addEventListener('touchstart', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('touchmove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('touchend', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('touchleave', function (e) { mouseOut(e); }, false);

}
function s_calc_mean() {
    var strArray = [];
    var bar = "-----------------------------------------------------\n";

    var S = 0;
    var tX = [];
    for (i = 0; i < PN; i++) {
        tX[i] = (x[i] - ox) / a;
        tX[i] = Math.round(tX[i] * 10) / 10;
        S = S + tX[i];
    }
    var MM = S / PN;
    MM = Math.round(MM * 100) / 100;

    var SS = 0;
    for (i = 0; i < PN; i++) {
        SS = SS + Math.pow(MM - tX[i], 2);
    }
    //標準偏差はn-1で割る
    var SSD = Math.sqrt(SS / (PN - 1));

    var skewness = 0; //歪度
    var kurtosis = 0; //尖度

    var SSS = 0;
    for (i = 0; i < PN; i++) {
        SSS = SSS + Math.pow((tX[i] - MM) / SSD, 3);
    }
    skewness = PN / (PN - 1) / (PN - 2) * SSS;

    var SSSS = 0;
    for (i = 0; i < PN; i++) {
        SSSS = SSSS + Math.pow((tX[i] - MM), 4) / Math.pow(SSD, 4);
    }
    kurtosis = PN * (PN + 1) / ((PN - 1) * (PN - 2) * (PN - 3)) * SSSS - 3 * Math.pow(PN - 1, 2) / ((PN - 2) * (PN - 3));

    // document.getElementById("mean").innerHTML = MM.toFixed(2);
    // document.getElementById("sd").innerHTML = SSD.toFixed(2);
    // document.getElementById("skewness").innerHTML = skewness.toFixed(2);
    // document.getElementById("kurtosis").innerHTML = kurtosis.toFixed(2);
    // strArray = null;

    var canvas = document.getElementById('figureCanvas');
    var ctx = canvas.getContext('2d');
    ctx.lineWidth = 1;
    ctx.font = "13px Arial";
    ctx.textAlign = "center";
    ctx.fillStyle = 'rgb(0,0,0)';
    ctx.fillText("平均", ox + a + 5, oy + a * 2 + 20);
    ctx.fillText("標準偏差", ox + a * 6 + 5, oy + a * 2 + 20);
    ctx.fillText("歪度", ox + a + 5, oy + a * 3 + 20);
    ctx.fillText("尖度", ox + a * 6 + 5, oy + a * 3 + 20);

    ctx.font = "15px Arial";
    ctx.textAlign = "right";
    ctx.fillText(MM.toFixed(2), ox + a * 5 - 10, oy + a * 2 + 20);
    ctx.fillText(SSD.toFixed(2), ox + a * 10 - 10, oy + a * 2 + 20);
    ctx.fillText(skewness.toFixed(2), ox + a * 5 - 10, oy + a * 3 + 20);
    ctx.fillText(kurtosis.toFixed(2), ox + a * 10 - 10, oy + a * 3 + 20);
}