/**
 * ｔ検定
 * Ts(参加者間)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeTsSetting();
	// ChangeAsInput(0);

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var i = 0;
	var LA = 2;
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}

	var elmCount = 0;
	for (i = 0; i < LA; i++) {
		elmCount += NN[i];
	}

	var result = confirm("データを消去します");
	if (result === true) {

		// Asには要因名があるが，Tsにはない
		// document.getElementById("factorA_name").value = "A";

		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;

	var LA = 2;
	var NN = [];

	var elmCount = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		elmCount += NN[i];
	}

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_Ts();
			//ノンパラ
			mainCalc_Median();
			mainCalc_Median2();
			mainCalc_Utest();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_Ts() {
	var i = 0;
	var j = 0;
	var ii = 0;

	var AA = "A";
	var LA = 2;
	var NN = [];

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NX);
	}

	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var M = new Array(NX); //平均
	var S2 = []; //分散
	var SD = []; //標準偏差

	var D_M = 0; //水準１と水準２の差の平均
	var D_S2 = 0; //水準１と水準２の差の分散
	var D_SD = 0; //水準１と水準２の差の標準偏差

	var strArray = [];
	var bar = "------------------------------------------------\n";

	//平均・標準偏差
	strArray.push("[ 対応のないｔ検定(Welch's t-Test) ]\n\n");
	strArray.push(" == Mean & S.D. ( SDは標本標準偏差 ) ==\n\n");
	strArray.push(bar);
	strArray.push("        N      Mean      S.D.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN[i]; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}
		M[i] = S / NN[i];
		S2[i] = SS / NN[i] - Math.pow(M[i], 2);
		SD[i] = Math.sqrt(S2[i]);

		M[i] = parseFloat(M[i].toFixed(2));
		S2[i] = parseFloat(S2[i].toFixed(2));
		SD[i] = parseFloat(SD[i].toFixed(2));

		strArray.push(('群' + (i + 1) + NN[i].format(" ", 6) + M[i].format(" ", 10) + SD[i].format(" ", 10) + '\n'));
	}
	strArray.push(bar);

	//T値
	var T = Math.abs(M[0] - M[1]) / Math.sqrt(S2[0] / (NN[0] - 1) + S2[1] / (NN[1] - 1));
	T = parseFloat(T.toFixed(4));

	//自由度
	var wC = (S2[0] / (NN[0] - 1)) / (S2[0] / (NN[0] - 1) + S2[1] / (NN[1] - 1));
	var DF = (NN[0] - 1) * (NN[1] - 1) / ((NN[0] - 1) * Math.pow(1 - wC, 2) + (NN[1] - 1) * Math.pow(wC, 2));
	DF = Math.floor(DF);

	var PP2 = t_table(DF, T);

	var ppStr = "";
	if (PP2 === 0.01) {
		ppStr = "   ** (p<.01)";
	}
	if (PP2 === 0.05) {
		ppStr = "   *  (p<.05)";
	}
	if (PP2 === 0.10) {
		ppStr = "   +  (.05<p<.10)";
	}
	if (PP2 === 1) {
		ppStr = "   ns (.10<p)";
	}
	strArray.push((' t(' + DF + ')= ' + T + ' , ' + ppStr + '\n'));

	strArray.push(bar);
	// strArray.push('※ S.D.は標本標準偏差\n');
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム
	(function () {
		var rcmArray = [];
		var spc = "          ";

		if (document.getElementById("Bayes").checked) {
			rcmArray.push("##### BF_参観者間ｔ検定\n");
			rcmArray.push("\n");
			rcmArray.push("# パッケージ psych       が必要\n");
			rcmArray.push("# パッケージ BayesFactor が必要\n");
		} else {
			rcmArray.push("##### 参加者間ｔ検定\n");
			rcmArray.push("\n");
			rcmArray.push("# パッケージ psych          が必要\n");
			rcmArray.push("# パッケージ exactRankTests が必要\n");
			rcmArray.push("# パッケージ brunnermunzel  が必要\n");
		}

		rcmArray.push("\n");
		rcmArray.push("## js-STARからの入力\n");
		for (i = 0; i < LA; i++) {
			rcmArray.push("g" + (i + 1) + " <- c(");
			for (j = 0; j < NN[i]; j++) {
				rcmArray.push(xx[i][j]);
				if (j < NN[i] - 1) rcmArray.push(", ");
			}
			rcmArray.push(") # 群" + (i + 1) + "\n");
		}
		rcmArray.push("\n");

		if (document.getElementById("Bayes").checked === false) {
			var shinrai = document.getElementById("shinrai").value;
			rcmArray.push("shinrai= " + shinrai + " # 信頼水準\n");
			rcmArray.push("\n");
		}

		rcmArray.push("### js-STARからの入力おわり\n");
		rcmArray.push("\n");

		document.getElementById("RcmArea").value = rcmArray.join("");
		rcmArray = null;

		//ベイズへの分岐
		if (document.getElementById("Bayes").checked) {
			outputR_Bayes_Ts();
		} else {
			outputR_Ts();
		}
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		chartClear();

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg0";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < LA; i++) {
			data[i] = parseFloat(M[i].toFixed(1), 10);
		}

		var max_y = M[0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			if (max_y < M[i]) max_y = parseFloat(M[i].toFixed(1), 10);
			if (min_y > M[i]) min_y = parseFloat(M[i].toFixed(1), 10);
		}

		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var datasetKey = [];
		for (i = 0; i < 1; i++) {
			datasetKey[i] = [];
		}
		for (i = 0; i < 1; i++) {
			datasetKey[i].label = '群';
			datasetKey[i].data = data;
			datasetKey[i].backgroundColor = chartClrAry[i % chartClrAry.length];
			datasetKey[i].borderColor = chartClrAry[i % chartClrAry.length];
			datasetKey[i].pointBorderWidth = 3;
			datasetKey[i].borderWidth = 1;
			datasetKey[i].lineTension = 0;
		}

		var labelData = [];
		for (i = 0; i < LA; i++) {
			labelData.push('群' + (i + 1));
		}

		var datasetData = [];
		for (i = 0; i < 1; i++) {
			datasetData[i] = datasetKey[i];
		}

		var myChart = new Chart(ctx, {
			type: 'bar',
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right'
				},
				title: {
					display: true,
					text: 'Mean'
				}
			}
		});

		//箱ひげ図
		var addData = [];
		var myData = [];
		var arrayCol = [];
		for (i = 0; i < LA; i++) {
			arrayCol = [];
			for (j = 0; j < NN[i]; j++) {
				arrayCol.push(xx[i][j]);
			}
			myData.push(arrayCol);
		}

		chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg1";
		ctx = document.getElementById("chart").appendChild(chartImg);

		var boxplotData = {
			labels: labelData,
			datasets: [{
				label: 'A',
				backgroundColor: chartClrAry[0] + '33',
				borderColor: chartClrAry[0],
				borderWidth: 1,
				padding: 10,
				outlierRadius: 3,
				itemRadius: 3,
				outlierColor: '#999999',
				data: myData
			}]
		};

		var myChart2 = new Chart(ctx, {
			type: 'boxplot',
			data: boxplotData,
			options: {
				responsive: true,
				scales: {
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
				},
				title: {
					display: true,
					text: 'Boxplot'
				}
			}
		});
	}());	//グラフ描画ここまで

	// document.getElementById("RcmArea").focus();
}
function changeTsSetting() {
	var h = 3;
	var htmArray = [];

	// htmArray.push("<div class=\"btnlayout\">");
	// htmArray.push("<ul class=\"menubutton\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"clearCellData();\"><span>データ消去</span></a></li>");
	// htmArray.push("<li><input type=\"file\" class=\"file_input\" id=\"readFileData\" accept=\".txt,.csv\" onchange=\"readFile(this);\"><a href=\"#\" onclick=\"document.getElementById('readFileData').click();\"><span>データ読込</span></a></li>");
	// htmArray.push("</ul>");
	// htmArray.push("</div>");

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");
	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">群1 参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"A1_subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeTsTable();\">");
	} else {
		htmArray.push("<select id=\"A1_subjNum\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'群１：参加者数');changeTsTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">群2 参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"A2_subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeTsTable();\">");
	} else {
		htmArray.push("<select id=\"A2_subjNum\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'群２：参加者数');changeTsTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("ts_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeTsTable();
}
function changeTsTable() {
	var i = 0;
	var j = 0;
	var LA = 2;
	var NN = [];

	var cellCount = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		cellCount += NN[i];
	}

	var htmArray = [];
	var cellId = 1;
	var sCount = 1;

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("群");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("データ");
	htmArray.push("</td>");
	htmArray.push("</tr>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<tr>");
		htmArray.push("<td ROWSPAN=\"" + NN[i] + "\" class=\"hyou_midashi_3d_title\">");
		htmArray.push("群" + (i + 1));
		htmArray.push("</td>");

		for (j = 0; j < NN[i]; j++) {
			if (j === 0) {
				htmArray.push("<td class=\"hyou_midashi_3d_top\">");
			} else {
				htmArray.push("<td class=\"hyou_midashi_3d\">");
			}
			htmArray.push(sCount);
			htmArray.push("</td>");
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum();\">");
			htmArray.push("</td>");
			htmArray.push("</tr>");
			cellId++;
			sCount++;
		}
	}

	htmArray.push("</table>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("ts_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
// メディアン検定
function mainCalc_Median() {
	var i = 0;
	var j = 0;
	var ii = 0;

	var LA = 2;
	var NN = [];

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NX);
	}

	//メディアンを計算して，２×２にクロス集計
	var addedArray = [];
	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
			addedArray.push(xx[i][j]);
		}
	}
	var sortedArray = addedArray.sort(compareNumbers);
	var median = 0;
	if (sortedArray.length % 2 === 1) {
		median = sortedArray[(sortedArray.length - 1) / 2];
	} else {
		median = (sortedArray[sortedArray.length / 2 - 1] + sortedArray[sortedArray.length / 2]) / 2;
	}
	var countedArray = [];
	countedArray[0] = xx[0].filter(function (x) {
		if (x >= median) return x;
	});
	countedArray[1] = xx[1].filter(function (x) {
		if (x >= median) return x;
	});

	var DD1 = countedArray[0].length;
	var DD2 = NN[0] - DD1;
	var DD3 = countedArray[1].length;
	var DD4 = NN[1] - DD3;

	//2x2
	var A = DD1;
	var B = DD2;
	var C = DD3;
	var D = DD4;

	var M1 = A + B; //  A   B  | M1
	var M2 = C + D; //  C   D  | M2
	var M3 = B + D; //---------+----
	var M4 = A + C; //  M4  M3 | NN

	var NNN = A + B + C + D;
	//document.getElementById("cell_sum").value = NNN;

	var svA = A; //A～Dの値を保存(save)しておく
	var svB = B;
	var svC = C;
	var svD = D;

	var raA = (A / (A + B)).toFixed(4);  //A～Dの比率(ratio)
	var raB = (B / (A + B)).toFixed(4);
	var raC = (C / (C + D)).toFixed(4);
	var raD = (D / (C + D)).toFixed(4);

	var PP2 = 0; //両側確率
	var PP = 0;  //片側確率
	var K1 = 0;  //片側確率(計算１)
	var K2 = 0;  //片側確率(計算２)
	var wPP = []; //それぞれの場合のP値
	var KS = []; //交差 A*C-B*D

	var strArray = [];
	var rcmArray = [];

	var Dummy = 0;
	while ((M2 < M1) || (M3 < M1) || (M4 < M1)) { //M1が一番小さくなるまでABCDの値を変更する
		Dummy = A;
		A = B;
		B = Dummy;

		Dummy = A;
		A = D;
		D = Dummy;

		Dummy = A;
		A = C;
		C = Dummy;

		M1 = A + B;
		M2 = C + D;
		M3 = B + D;
		M4 = A + C;
	}

	var AA = A; //Aの値を保存しておく

	var LT = []; //logの値を代入して計算を高速化する
	var maxM = Math.max(M1, M2, M3, M4);
	for (i = 0; i < maxM + 1; i++) {
		LT[i] = logfact(i);
	}
	LT[NNN] = logfact(NNN);

	var iA, iB, iC, iD;
	var myConst = LT[M1] + LT[M2] + LT[M3] + LT[M4] - LT[NNN];
	for (iA = 0; iA < M1 + 1; iA++) {
		iB = M1 - iA;
		iC = M4 - iA;
		iD = M3 - iB;
		KS[iA] = iA * iD - iB * iC;
		wPP[iA] = Math.exp(myConst - LT[iA] - LT[iB] - LT[iC] - LT[iD]);
		wPP[iA] = wPP[iA] * 1000000000000000; //計算結果が16桁目に誤差がでるのを防ぐ
		wPP[iA] = Math.round(wPP[iA]);
		wPP[iA] = wPP[iA] / 1000000000000000;
	}

	for (iA = 0; iA < M1 + 1; iA++) {
		if (wPP[iA] <= wPP[AA]) {
			PP2 = PP2 + wPP[iA];
		}
		//交差で判断
		if (KS[AA] <= KS[iA]) {
			K1 = K1 + wPP[iA];
		}
		if (KS[AA] >= KS[iA]) {
			K2 = K2 + wPP[iA];
		}
	}

	var ppStr = "";
	if (PP2 < 0.01) {
		ppStr = "   ** (p<.01)";
	} else if (PP2 < 0.05) {
		ppStr = "   *  (p<.05)";
	} else if (PP2 < 0.10) {
		ppStr = "   +  (.05<p<.10)";
	} else {
		ppStr = "   ns (.10<p)";
	}

	strArray.push("[メディアン検定]\n\n");
	strArray.push("中央値　：　" + median + "\n\n");
	strArray.push("\t中央値以上\t中央値未満\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("群１\t" + DD1 + "\t" + DD2 + "\n");
	strArray.push("\t" + "(" + raA + ")" + "\t" + "(" + raB + ")" + "\n");
	strArray.push("群２\t" + DD3 + "\t" + DD4 + "\n");
	strArray.push("\t" + "(" + raC + ")" + "\t" + "(" + raD + ")" + "\n");
	strArray.push("-----------------------------------------" + "\n\n");
	strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");

	if (K1 < K2) {
		PP = K1;
	} else {
		PP = K2;
	}

	var pp2Str = "";
	if (PP < 0.01) {
		pp2Str = "   ** (p<.01)";
	} else if (PP < 0.05) {
		pp2Str = "   *  (p<.05)";
	} else if (PP < 0.10) {
		pp2Str = "   +  (.05<p<.10)";
	} else {
		pp2Str = "   ns (.10<p)";
	}

	strArray.push("片側検定  :  p=" + PP.toFixed(4) + pp2Str + "\n\n");

	//Phiの計算（常に出力する）
	M1 = svA + svB;
	M2 = svC + svD;
	M3 = svA + svC;
	M4 = svB + svD;

	var Phi = Math.sqrt(Math.pow(svA * svD - svB * svC, 2) / (M1 * M2 * M3 * M4));
	var phi = Phi.toFixed(3);

	strArray.push("連関係数 : Phi=" + phi + "\n");

	//効果量の計算（常に出力する）
	var effectSizeH = 2 * Math.asin(Math.sqrt(raA)) - 2 * Math.asin(Math.sqrt(raC));
	strArray.push("効果量 : h=" + effectSizeH.toFixed(4) + "\n");
	strArray.push("\t\t（大=0.8 , 中=0.5 , 小=0.2）\n");

	// strArray.push("-----------------------------------------\n");
	// strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//出力
	document.getElementById("RltArea").value += "\n\n" + strArray.join("");

	strArray = null;
}
function mainCalc_Median2() {
	var i = 0;
	var j = 0;
	var ii = 0;

	var LA = 2;
	var NN = [];

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NX);
	}

	var addedArray = [];
	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			addedArray.push(xx[i][j]);
			cellId++;
		}
	}

	var sortedArray = addedArray.sort(compareNumbers);
	console.log(sortedArray);

	var median = 0;
	if (sortedArray.length % 2 === 1) {
		median = sortedArray[(sortedArray.length - 1) / 2];
	} else {
		median = (sortedArray[sortedArray.length / 2 - 1] + sortedArray[sortedArray.length / 2]) / 2;
	}
	console.log(median);

	var countedArray = [];
	countedArray[0] = xx[0].filter(function (x) {
		if (x > median) return x;
	});
	countedArray[1] = xx[1].filter(function (x) {
		if (x > median) return x;
	});

	var DD1 = countedArray[0].length;
	var DD2 = NN[0] - DD1;
	var DD3 = countedArray[1].length;
	var DD4 = NN[1] - DD3;

	// var i = 0;

	var A = DD1;
	var B = DD2;
	var C = DD3;
	var D = DD4;

	var M1 = A + B; //  A   B  | M1
	var M2 = C + D; //  C   D  | M2
	var M3 = B + D; //---------+----
	var M4 = A + C; //  M4  M3 | NN

	var NNN = A + B + C + D;
	//document.getElementById("cell_sum").value = NNN;

	var svA = A; //A～Dの値を保存(save)しておく
	var svB = B;
	var svC = C;
	var svD = D;

	var raA = (A / (A + B)).toFixed(4);  //A～Dの比率(ratio)
	var raB = (B / (A + B)).toFixed(4);
	var raC = (C / (C + D)).toFixed(4);
	var raD = (D / (C + D)).toFixed(4);

	var PP2 = 0; //両側確率
	var PP = 0;  //片側確率
	var K1 = 0;  //片側確率(計算１)
	var K2 = 0;  //片側確率(計算２)
	var wPP = []; //それぞれの場合のP値
	var KS = []; //交差 A*C-B*D

	var strArray = [];
	var rcmArray = [];

	var Dummy = 0;
	while ((M2 < M1) || (M3 < M1) || (M4 < M1)) { //M1が一番小さくなるまでABCDの値を変更する
		Dummy = A;
		A = B;
		B = Dummy;

		Dummy = A;
		A = D;
		D = Dummy;

		Dummy = A;
		A = C;
		C = Dummy;

		M1 = A + B;
		M2 = C + D;
		M3 = B + D;
		M4 = A + C;
	}

	var AA = A; //Aの値を保存しておく

	var LT = []; //logの値を代入して計算を高速化する
	var maxM = Math.max(M1, M2, M3, M4);
	for (i = 0; i < maxM + 1; i++) {
		LT[i] = logfact(i);
	}
	LT[NNN] = logfact(NNN);

	var iA, iB, iC, iD;
	var myConst = LT[M1] + LT[M2] + LT[M3] + LT[M4] - LT[NNN];
	for (iA = 0; iA < M1 + 1; iA++) {
		iB = M1 - iA;
		iC = M4 - iA;
		iD = M3 - iB;
		KS[iA] = iA * iD - iB * iC;
		wPP[iA] = Math.exp(myConst - LT[iA] - LT[iB] - LT[iC] - LT[iD]);
		wPP[iA] = wPP[iA] * 1000000000000000; //計算結果が16桁目に誤差がでるのを防ぐ
		wPP[iA] = Math.round(wPP[iA]);
		wPP[iA] = wPP[iA] / 1000000000000000;
	}

	for (iA = 0; iA < M1 + 1; iA++) {
		if (wPP[iA] <= wPP[AA]) {
			PP2 = PP2 + wPP[iA];
		}
		//交差で判断
		if (KS[AA] <= KS[iA]) {
			K1 = K1 + wPP[iA];
		}
		if (KS[AA] >= KS[iA]) {
			K2 = K2 + wPP[iA];
		}
	}

	var ppStr = "";
	if (PP2 < 0.01) {
		ppStr = "   ** (p<.01)";
	} else if (PP2 < 0.05) {
		ppStr = "   *  (p<.05)";
	} else if (PP2 < 0.10) {
		ppStr = "   +  (.05<p<.10)";
	} else {
		ppStr = "   ns (.10<p)";
	}

	// strArray.push("[直接確率計算２×２]\n\n");
	strArray.push("\t中央値より大\t中央値以下\n");
	strArray.push("-----------------------------------------\n");
	strArray.push("群１\t" + DD1 + "\t" + DD2 + "\n");
	strArray.push("\t" + "(" + raA + ")" + "\t" + "(" + raB + ")" + "\n");
	strArray.push("群２\t" + DD3 + "\t" + DD4 + "\n");
	strArray.push("\t" + "(" + raC + ")" + "\t" + "(" + raD + ")" + "\n");
	strArray.push("-----------------------------------------" + "\n\n");
	strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");

	if (K1 < K2) {
		PP = K1;
	} else {
		PP = K2;
	}

	var pp2Str = "";
	if (PP < 0.01) {
		pp2Str = "   ** (p<.01)";
	} else if (PP < 0.05) {
		pp2Str = "   *  (p<.05)";
	} else if (PP < 0.10) {
		pp2Str = "   +  (.05<p<.10)";
	} else {
		pp2Str = "   ns (.10<p)";
	}

	strArray.push("片側検定  :  p=" + PP.toFixed(4) + pp2Str + "\n\n");

	//Phiの計算（常に出力する）
	M1 = svA + svB;
	M2 = svC + svD;
	M3 = svA + svC;
	M4 = svB + svD;

	var Phi = Math.sqrt(Math.pow(svA * svD - svB * svC, 2) / (M1 * M2 * M3 * M4));
	var phi = Phi.toFixed(3);

	strArray.push("連関係数 : Phi=" + phi + "\n");

	//効果量の計算（常に出力する）
	var effectSizeH = 2 * Math.asin(Math.sqrt(raA)) - 2 * Math.asin(Math.sqrt(raC));
	strArray.push("効果量 : h=" + effectSizeH.toFixed(4) + "\n");
	strArray.push("\t\t（大=0.8 , 中=0.5 , 小=0.2）\n");

	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//出力
	document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	strArray = null;
}
// マン・ホイットニーU検定
function mainCalc_Utest() {
	var i = 0;
	var j = 0;
	var ii = 0;

	var LA = 2;
	var NN = [];

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NX);
	}

	var a = [[], []];
	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
			a[i].push(xx[i][j]);
		}
	}

	//平均，標準偏差
	var M = [];
	var SD = [];

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN[i]; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}
		M[i] = S / NN[i];
		SD[i] = Math.sqrt(SS / NN[i] - Math.pow(M[i], 2));

		M[i] = parseFloat(M[i].toFixed(2));
		SD[i] = parseFloat(SD[i].toFixed(2));
	}

	//最大値，最小値
	var MAX = [];
	var MIN = [];
	for (i = 0; i < LA; i++) {
		MAX[i] = xx[i][0];
		MIN[i] = xx[i][0];
		for (j = 0; j < NN[i]; j++) {
			if (MAX[i] < xx[i][j]) MAX[i] = xx[i][j];
			if (MIN[i] > xx[i][j]) MIN[i] = xx[i][j];
		}
	}

	var N = [0, 0];
	N[0] = a[0].length;
	N[1] = a[1].length;

	var addedArray = a[0].concat(a[1]);
	var sortedArray = addedArray.sort(compareNumbers);
	var rankedArray = [];
	for (i = 0; i < sortedArray.length; i++) {
		rankedArray[i] = i + 1;
	}

	for (i = 1; i < sortedArray.length; i++) {
		if (sortedArray[i] === sortedArray[i - 1]) {
			rankedArray[i] = rankedArray[i - 1];
		}
	}

	var countedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		countedArray[i] = 0;
		for (j = 0; j < rankedArray.length; j++) {
			if (rankedArray[i] === rankedArray[j]) {
				countedArray[i]++;
			}
		}
	}

	var rerankedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		rerankedArray[i] = (rankedArray[i] * 2 + countedArray[i] - 1) / 2;
	}

	var trankedArray = [[], []];
	for (i = 0; i < sortedArray.length; i++) {
		for (var j1 = 0; j1 < a[0].length; j1++) {
			if (sortedArray[i] === a[0][j1]) {
				trankedArray[0][j1] = rerankedArray[i];
			}
		}
		for (var j2 = 0; j2 < a[1].length; j2++) {
			if (sortedArray[i] === a[1][j2]) {
				trankedArray[1][j2] = rerankedArray[i];
			}
		}
	}

	var R = [0, 0];
	for (j = 0; j < 2; j++) {
		for (i = 0; i < trankedArray[j].length; i++) {
			R[j] = R[j] + trankedArray[j][i];
		}
	}

	var U1 = 0;
	var U2 = 0;
	U1 = N[0] * N[1] + (N[0] * (N[0] + 1) / 2) - R[0];
	U2 = N[0] * N[1] - U1;

	var U = U1;
	if (U1 > U2) U = U2;

	var uM = N[0] * N[1] / 2;
	var uSD = Math.sqrt(N[0] * N[1] * (N[0] + N[1] + 1) / 12);
	var z = parseFloat(Math.abs((U - uM) / uSD).toFixed(2));

	var strArray = [];
	strArray.push("[マン・ホイットニーU検定]\n\n");
	strArray.push(" == Mean & S.D. ( SDは標本標準偏差 ) ==\n\n");
	strArray.push("         N      Mean      S.D.       MAX       MIN\n");
	strArray.push("------------------------------------------------------\n");
	strArray.push(('群１' + N[0].format(" ", 6) + M[0].format(" ", 10) + SD[0].format(" ", 10) + MAX[0].format(" ", 10) + MIN[0].format(" ", 10) + "\n"));
	strArray.push(('群２' + N[1].format(" ", 6) + M[1].format(" ", 10) + SD[1].format(" ", 10) + MAX[1].format(" ", 10) + MIN[1].format(" ", 10) + "\n"));
	strArray.push("------------------------------------------------------\n\n");

	var ppStr = "";
	var PP2 = 0;
	if (N[0] <= 20 && N[1] <= 20) {
		strArray.push('         N    平均順位    統計量U\n');
		strArray.push("-----------------------------------------\n");
		strArray.push('群１' + N[0].format(" ", 6) + R[0].format(" ", 10) + U1.format(" ", 10) + '\n');
		strArray.push('群２' + N[1].format(" ", 6) + R[1].format(" ", 10) + U2.format(" ", 10) + '\n');
		strArray.push("-----------------------------------------\n");
		strArray.push('統計量U  ：' + U.format(" ", 6) + '\n');

		PP2 = U_tables(N[0], N[1], U);
		if (PP2 === 9) {
			strArray.push("データ数が少ないため，計算できません\n");
		} else {
			if (PP2 === 0.01) {
				ppStr = "   ** (p<.01)";
			}
			if (PP2 === 0.05) {
				ppStr = "   *  (p<.05)";
			}
			if (PP2 === 1) {
				ppStr = "   ns (.10<p)";
			}
			strArray.push("両側検定  :" + ppStr + "\n");
		}
	} else {
		var wSD = parseFloat(uSD.toFixed(2));
		strArray.push('平均E(U)  分散V(U)   統計量U    統計量z\n');
		strArray.push("-----------------------------------------\n");
		strArray.push(uM.format(" ", 8) + wSD.format(" ", 10) + U.format(" ", 10) + z.format(" ", 10) + '\n');
		strArray.push("-----------------------------------------\n");

		PP2 = z_tables(z);
		if (PP2 < 0.01) {
			ppStr = "   ** (p<.01)";
		} else if (PP2 < 0.05) {
			ppStr = "   *  (p<.05)";
		} else if (PP2 < 0.10) {
			ppStr = "   +  (.05<p<.10)";
		} else {
			ppStr = "   ns (.10<p)";
		}
		strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");
	}

	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	// //出力
	document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	strArray = null;

	var RltAreaObj = document.getElementById("RltArea");
	RltAreaObj.focus();
	RltAreaObj.setSelectionRange(RltAreaObj.value, 0);
	RltAreaObj.scrollTop = 0;
}
function saveData_Ts() {
	var i, j;

	var strArray = [];

	var LA = 2;
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}

	//#0
	strArray.push("Ts" + "\n");
	//#1
	strArray.push("#" + "\n");
	for (i = 0; i < LA; i++) {
		if (i !== LA - 1) {
			strArray.push(NN[i] + ",");
		} else {
			strArray.push(NN[i]);
		}
	}
	strArray.push("\n");
	//#2
	strArray.push("#" + "\n");
	var cellId = 1;
	var x;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			x = document.getElementById("cell_" + cellId).value;
			strArray.push(x + "\n");
			cellId++;
		}
	}

	var Stream = strArray.join("");
	var fineName = "Ts_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_Ts() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "Ts") {
		var LA = 2;
		var nn_text = crDel(dd[1]);
		var NN = [];
		NN = nn_text.split(",");
		for (i = 0; i < LA; i++) {
			document.getElementById("A" + (i + 1) + "_subjNum").value = parseInt(NN[i], 10);
		}
		changeTsTable();
		document.getElementById("CandPArea").value = delTopCR(dd[2]);
	}
}
function simulation_Ts(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_shift = (key_event.shiftKey);

	var LA = 2;
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}

	var min = 5;
	var max = 30;
	if ((NN[0] === 2) && (NN[1] === 2)) {
		NN[0] = Math.floor(Math.random() * (max - min + 1) + min);
		NN[1] = Math.floor(Math.random() * (max - min + 1) + min);
	}

	for (i = 0; i < LA; i++) {
		document.getElementById("A" + (i + 1) + "_subjNum").value = parseInt(NN[i], 10);
	}

	changeTsTable();

	var result = "rnd1:9*" + (NN[0] + NN[1]);

	document.getElementById("CandPArea").value = random_number_generation(result);

	copipe('CandPArea', 'text');
	inputTextArea(document.getElementById('CandPArea'), 0);
	// inputBtnTextClear(this);

	mainCalc_Ts();
	mainCalc_Median();
	mainCalc_Median2();
	mainCalc_Utest();
}
function outputR_Ts() { //通常のR出力
	var rcmArray = [];
	var spc = "          ";

	rcmArray.push("# main\n");
	rcmArray.push("Title=\"平均と標準偏差(不偏分散の平方根)\"\n");
	rcmArray.push("hk= c(mean(g1),mean(g2) )\n");
	rcmArray.push("sd= c(sd(g1),sd(g2) )\n");
	rcmArray.push("mi= c(min(g1),min(g2) )\n");
	rcmArray.push("ma= c(max(g1),max(g2) )\n");
	rcmArray.push("n1=length(g1); n2=length(g2)\n");
	rcmArray.push("N= n1+n2\n");
	rcmArray.push("library(psych)\n");
	rcmArray.push("library(exactRankTests)\n");
	rcmArray.push("library(brunnermunzel)\n");
	rcmArray.push("txD= c()\n");
	rcmArray.push("txD= rbind(describe(g1)[c(5,10:13)], describe(g2)[c(5,10:13)] )\n");
	rcmArray.push("rownames(txD)= c(\"群１\",\"群２\" )\n");
	rcmArray.push("colnames(txD)= c(\"Median\",\"Range\",\"歪度\",\"尖度\",\"SE\" )\n");
	rcmArray.push("\n");
	rcmArray.push("## 作図\n");
	rcmArray.push("mitsdo= c( 0, 20 )   # バーの斜線密度\n");
	rcmArray.push("xjik= c(0, 3)        # ｘ軸の範囲\n");
	rcmArray.push("bai = 2              # ｙ軸の拡幅倍率\n");
	rcmArray.push("shoh= min(min(hk),0) # 最小平均か，ゼロ\n");
	rcmArray.push("dais= max(sd)        # 最大ＳＤ\n");
	rcmArray.push("yjik= c(shoh+dais*bai*sign(shoh), max(hk)+dais*bai )\n");
	rcmArray.push("\n");
	rcmArray.push("for( L in 1:2 )\n");
	rcmArray.push("{\n");
	rcmArray.push("if( L==1 ) Sd=sd else { Sd=txD[,5]; Title=\"平均とSE(標準誤差)\" }\n");

	if (navigator.platform.indexOf("Win") != -1) {
		rcmArray.push("windows()\n");
	}
	if (navigator.platform.indexOf("Mac") != -1) {
		rcmArray.push("quartz()\n");
	}

	rcmArray.push("antx= barplot(hk, xli=xjik, yli=yjik,\n");
	rcmArray.push("    las=1, tck=0.02,   # ｙ軸の目盛デザイン\n");
	rcmArray.push("    col=1, den=mitsdo, # バーの色，斜線密度\n");
	rcmArray.push("    names.arg=c(\"群1\",\"群2\"),\n");
	rcmArray.push("    xlab=\"\", ylab=\"平　均\",\n");
	rcmArray.push("    main=Title, cex.main=1.5, cex.lab=1.2, cex.names=1.2 )\n");
	rcmArray.push("arrows(antx,hk, antx,hk+Sd*sign(hk), lwd=L,ang=90,len=0.2 )\n");
	rcmArray.push("if(L==2) arrows(antx,hk,antx,hk-Sd*sign(hk),lwd=L,ang=90,len=0.2 )\n");
	rcmArray.push("}\n");
	rcmArray.push("\n");
	rcmArray.push("## 平均\n");
	rcmArray.push("tx0= c()\n");
	rcmArray.push("tx0= matrix( round( c(n1,n2, hk,sd, mi,ma), 4), nr=2 )\n");
	rcmArray.push("rownames(tx0)= c(\"群１\",\"群２\")\n");
	rcmArray.push("colnames(tx0)= c(\" ｎ\",\"  Mean\",\"   SD\",\"  Min.\",\"  Max.\" )\n");
	rcmArray.push("\n");
	rcmArray.push("## 分散均一\n");
	rcmArray.push("kx0= c()\n");
	rcmArray.push("kx0= var.test(g1, g2)\n");
	rcmArray.push("\n");
	rcmArray.push("txV= c()\n");
	rcmArray.push("txV= matrix( round( c(\n");
	rcmArray.push("     kx0$stat, kx0$para, kx0$p.va, kx0$conf[1:2]), 4), nr=1, by=1 )\n");
	rcmArray.push("mds= paste(shinrai*100,\"％信頼下限\", sep=\"\" )\n");
	rcmArray.push("rownames(txV)=\"Ｆ検定\"\n");
	rcmArray.push("colnames(txV)= c(\"  Ｆ比\",\" df1\",\" df2\",\"   ｐ値\",mds,\"   上限\"　)\n");
	rcmArray.push("\n");
	rcmArray.push("## 両側\n");
	rcmArray.push("kx1= c() # 分散同等\n");
	rcmArray.push("kx1= t.test(g1,g2,var=1, conf=shinrai )\n");
	rcmArray.push("tch=abs(kx1$stat); df=kx1$para; pch=kx1$p.va\n");
	rcmArray.push("esd=tch*sqrt(1/n1+1/n2)\n");
	rcmArray.push("cr1=qt(0.025,df); cr2=qt(0.975,df)\n");
	rcmArray.push("pow= pt(cr1,df,tch)+pt(cr2,df,tch,low=0)\n");
	rcmArray.push("tx1= matrix(round(c(tch,df,pch,esd,pow), 4), nr=1 )\n");
	rcmArray.push("\n");
	rcmArray.push("kx2= c() # ウェルチ\n");
	rcmArray.push("kx2= t.test(g1,g2, conf=shinrai )\n");
	rcmArray.push("Tch=abs(kx2$stat); DF=kx2$para; Pch=kx2$p.va\n");
	rcmArray.push("ESd= Tch*sqrt(1/n1+1/n2)\n");
	rcmArray.push("Cr1=qt(0.025,DF); Cr2=qt(0.975,DF)\n");
	rcmArray.push("Pow= pt(Cr1,DF,Tch)+pt(Cr2,DF,Tch,low=0)\n");
	rcmArray.push("tx2= rbind(tx1, matrix(round(c(Tch,DF,Pch,ESd,Pow),4),nr=1,by=1) )\n");
	rcmArray.push("\n");
	rcmArray.push("PCH= pt(tch,DF,low=F)*2\n");
	rcmArray.push("POW= pt(Cr1,DF,tch)+pt(Cr2,DF,tch,low=0) # ウェルチ改\n");
	rcmArray.push("\n");
	rcmArray.push("mds=c(\"分散同等\",\"分散不等\"); tmp=c()\n");
	rcmArray.push("if( tch<Tch )\n");
	rcmArray.push("{\n");
	rcmArray.push(" tmp=\"ｔ値不変\"\n");
	rcmArray.push(" tx2= rbind(tx2, matrix(round(c(tch,DF,PCH,esd,POW),4),nr=1,by=1) )\n");
	rcmArray.push("}\n");
	rcmArray.push("rownames(tx2)= c(mds,tmp )\n");
	rcmArray.push("colnames(tx2)= c(\"    ｔ\",\"   df\",\"   ｐ値\",\"効果量ｄ\",\" 検出力\" )\n");
	rcmArray.push("\n");
	rcmArray.push("NN= c(NA,NA) # パワ\n");
	rcmArray.push("if( Pow<0.80 )\n");
	rcmArray.push("{\n");
	rcmArray.push(" for( i in (N-1):10000 )\n");
	rcmArray.push("   {\n");
	rcmArray.push("    NCP= ESd/sqrt( 1/(i/2)+1/(i/2) )\n");
	rcmArray.push("    pow= pt(qt(0.975,i-2),i-2,NCP, low=0 )\n");
	rcmArray.push("    if( pow>0.80 ){ NN=c(i,pow, NN); break }\n");
	rcmArray.push("   }\n");
	rcmArray.push("} else {\n");
	rcmArray.push(" for( i in (N+1):0 )\n");
	rcmArray.push("   {\n");
	rcmArray.push("    NCP= ESd/sqrt( 1/(i/2)+1/(i/2) )\n");
	rcmArray.push("    pow= pt(qt(0.975,i-2),i-2,NCP, low=0 )\n");
	rcmArray.push("    if( pow<0.80 ) break\n");
	rcmArray.push("    NN= c(i,pow, NN )\n");
	rcmArray.push("   }\n");
	rcmArray.push("}\n");
	rcmArray.push("tx5= c()\n");
	rcmArray.push("tx5= matrix( round( c(ESd,0.05,NN[2],NN[1],N), 4), nr=1 )\n");
	rcmArray.push("rownames(tx5)=\"\"\n");
	rcmArray.push("colnames(tx5)= c(\"効果量ｄ\",\"   α\",\"  検出力\",\"次回のＮ\",\"今回のＮ\" )\n");
	rcmArray.push("\n");
	rcmArray.push("cnf= kx2$conf[1:2] # 区間推定\n");
	rcmArray.push("tx9= c()\n");
	rcmArray.push("dif= hk[1]-hk[2]\n");
	rcmArray.push("tx9= matrix( round(c(dif,kx1$conf[1:2],dif,cnf), 4), nc=3,by=1 )\n");
	rcmArray.push("rownames(tx9)= mds\n");
	rcmArray.push("colnames(tx9)= c(\"平均の差\",paste(shinrai*100,\"％信頼下限\",sep=\"\"),\"    上限\" )\n");
	rcmArray.push("\n");
	rcmArray.push("# 片側\n");
	rcmArray.push("if( dif>0 ) H1=\"g\" else H1=\"l\"\n");
	rcmArray.push("\n");
	rcmArray.push("kx3=c(); tx3=c() # 分散同等\n");
	rcmArray.push("kx3= t.test(g1,g2,var=1,conf=shinrai, al=H1 )\n");
	rcmArray.push("Pwr= pt(qt(0.95,N-2),N-2,tch,low=0 )\n");
	rcmArray.push("tx3= matrix( round( c(tch,df,kx3$p.va,esd,Pwr), 4), nr=1 )\n");
	rcmArray.push("\n");
	rcmArray.push("kx4=c(); tx4=c() # 不等\n");
	rcmArray.push("kx4= t.test(g1,g2, conf=shinrai, al=H1 )\n");
	rcmArray.push("Pwr= pt(qt(0.95,DF),DF,Tch,low=0 )\n");
	rcmArray.push("tx4= rbind(tx3, matrix(round(c(Tch,DF,kx4$p.va,ESd,Pwr),4),nr=1,by=1) )\n");
	rcmArray.push("rownames(tx4)= c(\"分散同等\",\"分散不等\")\n");
	rcmArray.push("colnames(tx4)= c(\"    ｔ\",\"   df\",\"  ｐ値\",\"効果量ｄ\",\" 検出力\" )\n");
	rcmArray.push("\n");
	rcmArray.push("tx8= c() # 区間推定\n");
	rcmArray.push("tx8= matrix( round(c(dif,kx3$conf[1:2],dif,kx4$conf[1:2]),4), nc=3,by=1 )\n");
	rcmArray.push("rownames(tx8)= mds\n");
	rcmArray.push("colnames(tx8)= c(\"平均の差\",paste(shinrai*100,\"％信頼下限\",sep=\"\"),\"    上限\" )\n");
	rcmArray.push("\n");
	rcmArray.push("\n");
	rcmArray.push("# ■結果の書き方\n");
	rcmArray.push("PV= function(x) floor(x*1000)/1000\n");
	rcmArray.push("txt=c()\n");
	rcmArray.push("if( sum(sd==0)>0 ) txt=\"※分散=0 の群があります。全データが同じ値です。以下の分析は信頼性がありません。\\n\\n\"\n");
	rcmArray.push("txt= paste(txt,\"　各群の○○得点について基本統計量をTable(tx0) or Fig.■に示す。\\n　Welchの方法によるｔ検定を行った結果，両群の平均の差は有意\", sep=\"\" )\n");
	// rcmArray.push("fuki= paste(\" (t=\",round(Tch,3),\", df=\",round(DF,3),\", p=\",PV(Pch),\", d=\",round(ESd,3),\", 1-β=\",round(Pow,3),\", 両側検定)\", sep=\"\" )\n");
	rcmArray.push("if( n1==n2 ) ciLU=round(d.ci(ESd,n=N), 3) else ciLU=round(d.ci(ESd,n1=n1,n2=n2), 3)\n");
	rcmArray.push("ci95= paste(\" [95%CI \",ciLU[1],\" - \",ciLU[3],\"]\", sep=\"\" )\n");
	rcmArray.push("fuki= paste(\" (t=\",round(Tch,3),\", df=\",round(DF,3),\", p=\",PV(Pch),\", d=\",round(ESd,3),ci95,\", 1-β=\",round(Pow,3),\", 両側検定)\", sep=\"\" )\n");

	rcmArray.push("goku=\"，\"\n");
	rcmArray.push("if( Pch<0.05 ) tmp=\"であり\" else\n");
	rcmArray.push("if( Pch<0.10 ) tmp=\"傾向であり\" else { tmp=\"でなかった\"; goku=\"。\" }\n");
	rcmArray.push("txt=paste(txt, tmp,fuki,goku, sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("if( Pch<0.10 )\n");
	rcmArray.push("  {\n");
	rcmArray.push("   if( hk[1]>hk[2] ) goku=\"大き\" else goku=\"小さ\"\n");
	rcmArray.push("   tmp=\"い傾向があった。\"; if( Pch<0.05 ) tmp=\"かった。\"\n");
	rcmArray.push("   txt= paste(txt, \"群１の平均が群２の平均よりも有意に\",goku,tmp, sep=\"\" )\n");
	rcmArray.push("  }\n");
	rcmArray.push("if( ESd>=0.79 ) tmp=\"大きい\" else\n");
	rcmArray.push("if( ESd>=0.49 ) tmp=\"中程度以上\" else\n");
	rcmArray.push("if( ESd>=0.46 ) tmp=\"ほぼ中程度\" else tmp=\"小さい\"\n");
	rcmArray.push("txt= paste(txt, \"効果量dは便宜的基準 (Cohen, 1992) によると\",tmp,\"と判断される。\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("tmp=\"\"; goku=\"\"\n");
	rcmArray.push("if( Pch<0.10 )\n");
	rcmArray.push("  {\n");
	rcmArray.push("   if( Pow<0.70 ){ goku=\"ただし\"; tmp=\"不十分であり，信頼性が低い。\" } else\n");
	rcmArray.push("   if( Pow<0.76 ) tmp=\"やや低いが0.70以上あり不十分ではない。\" else\n");
	rcmArray.push("   if( Pow<0.80 ) tmp=\"ほぼ十分といえる。\" else tmp=\"十分である。\"\n");
	rcmArray.push("   txt= paste(txt, goku,\"検出力 (1-β) は\",tmp, sep=\"\" )\n");
	rcmArray.push("  }\n");
	rcmArray.push("\n");
	rcmArray.push("goku=\"と推定される。\"; fuki=\"\"\n");
	rcmArray.push("if( Pch<0.10 & sum(cnf<0)!=1 )\n");
	rcmArray.push("{\n");
	rcmArray.push(" diff= min(abs(cnf))\n");
	rcmArray.push(" if( diff>1 ){ tmp=\"以上\"; posa=floor(diff) } else { tmp=\"近い差\"; posa=1 }\n");
	rcmArray.push(" if( diff<0.80 ) goku=\"とはいえない。\"\n");
	rcmArray.push(" fuki= paste(\"であり，実質的に最小差は\",posa,\"ポイント\",tmp,\"を生じる\", sep=\"\" )\n");
	rcmArray.push("}\n");
	rcmArray.push("txt= paste(txt, \"\\n　平均の差の\",shinrai*100,\"％信頼区間は\",round(cnf[1],3),\" - \",round(cnf[2],3),fuki,goku, sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("pch= PV(kx0$p.va) # 分散比\n");
	rcmArray.push("tmp= kx0$para[1:2]\n");
	rcmArray.push("fuki= paste(\" (F(\",tmp[1],\",\",tmp[2],\")=\",round(kx0$stat,3),\", p=\",pch,\", 両側検定)\", sep=\"\" )\n");
	rcmArray.push("goku=\"，\"\n");
	rcmArray.push("if( pch<0.05 ) tmp=\"であり\" else\n");
	rcmArray.push("if( pch<0.10 ) tmp=\"傾向であり\" else { tmp=\"でないことを確認した\"; goku=\"。\" }\n");
	rcmArray.push("txt= paste(txt, \"\\n　両群の分散比の検定結果は有意\",tmp,fuki,goku, sep=\"\" )\n");
	rcmArray.push("if( pch<0.10 ) txt=paste(txt, \"効果は平均ではなく分散の差に表れた可能性があるかもしれない。\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("txt= paste(txt, \"\\n\\n［引用文献］\\n\",\n");
	rcmArray.push("\"Cohen, J. (1992). A power primer. Psychological Bulletin, 112, 155-159.\\n\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("txt= paste(txt, \"\\n\\n⇒データ分布が正規形を仮定できない場合，または誤差分散（標準偏差）が等しいと仮定できない場合，下の記述を参照してください。\\n\", sep=\"\" )\n");
	rcmArray.push("Tmp= function( pc )\n");
	rcmArray.push("{\n");
	rcmArray.push(" if( pc<0.05 ) Tmp=\"であった\" else \n");
	rcmArray.push(" if( pc<0.10 ) Tmp=\"傾向であった\" else Tmp=\"でなかった\"\n");
	rcmArray.push(" Tmp\n");
	rcmArray.push("}\n");
	rcmArray.push("\n");
	rcmArray.push("BM= brunnermunzel.test(g1, g2 )\n");
	rcmArray.push("pc= BM$p.va\n");
	rcmArray.push("fuki= paste(\" (BM's t=\",round(abs(BM$stat),3),\", df=\",round(BM$para,3),\", p=\",PV(pc),\", 両側検定)。\\n\", sep=\"\" )\n");
	rcmArray.push("txt= paste(txt, \"\\n　Brunner-Munzel検定を行った結果，両群の順位の差は有意\",Tmp(pc),fuki, sep=\"\" )\n");
	rcmArray.push("BMp= function(g1,g2) cat(paste(\"順列化Brunner-Munzel検定, p=\",round(brunnermunzel.permutation.test(g1,g2)$p.val, 4),\"（両側検定）\\n\", sep=\"\") )\n");
	rcmArray.push("\n");
	rcmArray.push("kx= wilcox.exact(g1, g2 )\n");
	rcmArray.push("pc= kx$p.va\n");
	rcmArray.push("fuki= paste(\" (W=\",round(kx$stat,3),\", p=\",PV(pc),\", 両側検定)。\\n\", sep=\"\" )\n");
	rcmArray.push("txt= paste(txt, \"\\n　Wilcoxonの順位和検定 (Mann-WhitneyのＵ検定) を行った結果，両群の順位和の差は有意\",Tmp(pc),fuki, sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("med= median(c(g1,g2)) # median.test\n");
	rcmArray.push("hx = c(); fsP = c(); tmp = c(\"超\",\"以下\",\"以上\",\"未満\")\n");
	rcmArray.push("for (i in 0: 1 )\n");
	rcmArray.push("{\n");
	rcmArray.push("	if (i == 0) { d11 = sum(g1 > med); d21 = sum(g2 > med) }\n");
	rcmArray.push("	if (i == 1) { d11 = sum(g1 >= med); d21 = sum(g2 >= med) }\n");
	rcmArray.push("	hx = c(hx, d11, n1 - d11, d21, n2 - d21)\n");
	rcmArray.push("	fsP = c(fsP, fisher.test(matrix(hx[(1 + i * 4): (4 + i * 4)], nc = 2, by = 1))$p.va)\n");
	rcmArray.push("}\n");
	rcmArray.push("if (fsP[1] < fsP[2]) id = 0 else id = 1\n");
	rcmArray.push("Median2x2 = matrix(hx[(1 + id * 4): (4 + id * 4)], nc = 2, by = 1)\n");
	rcmArray.push("rownames(Median2x2) = c(paste(\"群1(n=\",n1,\")\",sep=\"\"), paste(\"群2(n=\",n2,\")\",sep=\"\") )\n");
	rcmArray.push("colnames(Median2x2) = c(paste(\"Med=\",med,tmp[1+id*2],sep=\"\"),paste(med,tmp[2+id*2],sep=\"\") )\n");
	rcmArray.push("pc = fsP[id + 1]\n");
	rcmArray.push("txt= paste(txt, \"\\n　Fisherの正確検定を用いたメディアン検定を行った結果，両群の分割表 (オプション(Median2x2)参照) における度数の差は有意\",Tmp(pc),\" (p=\",PV(pc),\", 両側検定)。\\n\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("n= c(n1,n2)\n");
	rcmArray.push("dx= c(g1, g2 )\n");
	rcmArray.push("dx= dx[order(dx)] # 並び替え。昇順\n");
	rcmArray.push("dz= dx[1]\n");
	rcmArray.push("for( i in 2:N ) if( dx[i]>dx[i-1] ) dz=c(dz, dx[i] )\n");
	rcmArray.push("Nz= length(dz)    # 異なり数\n");
	rcmArray.push("\n");
	rcmArray.push("dosu=c(); mds=c() # 区切り番号を入れる\n");
	rcmArray.push("yuis=0; Pch=c(); minP=1\n");
	rcmArray.push("hyo=c(); EXP2x2=c()\n");
	rcmArray.push("for( i in 1:(Nz-1) )\n");
	rcmArray.push("{\n");
	rcmArray.push(" ds1= sum( g1<=dz[i] )\n");
	rcmArray.push(" ds2= sum( g2<=dz[i] )\n");
	rcmArray.push(" hyo= matrix(c(ds1,n1-ds1, ds2,n2-ds2), nc=2,by=1 )\n");
	rcmArray.push(" pch= fisher.test(hyo)$p.va\n");
	rcmArray.push(" Pch=c(Pch,pch); dosu=c(dosu, as.numeric(hyo)); mds=c(mds,i)\n");
	rcmArray.push("}  # for(i)\n");
	rcmArray.push("\n");
	rcmArray.push("# 結果の書き方\n");
	rcmArray.push("txt= paste(txt, \"\\n　探索的集計検定 (※）の結果，\", sep=\"\" )\n");
	rcmArray.push("tmp= c(paste(\" 群1（n=\",n1,\"）\",sep=\"\"), paste(\" 群2（n=\",n2,\"）\",sep=\"\") )\n");
	rcmArray.push("\n");
	rcmArray.push("junb=order(Pch); bang=junb[1] # 最小ｐ値の番号\n");
	rcmArray.push("yuis= sum( Pch<0.10 )\n");
	rcmArray.push("hyo= matrix(dosu[ (1+4*(bang-1)):(4*bang) ], nc=2 )\n");
	rcmArray.push("hyo= rbind(hyo, c(NA,NA) )\n");
	rcmArray.push("rownames(hyo)= c(tmp, paste(\"両側ｐ=\",PV(Pch[bang]),sep=\"\") )\n");
	rcmArray.push("colnames(hyo)= c(paste(dz[1],\"～\",dz[mds[bang]],sep=\"\"), paste(\"  \",dz[mds[bang]+1],\"～\",dz[Nz],sep=\"\") )\n");
	rcmArray.push("\n");
	rcmArray.push("if( yuis==0 ) txt=paste(txt, \"有意な２×２分割表は見いだされなかった (下記Table(hyo)参照）。\", sep=\"\" ) else\n");
	rcmArray.push("{\n");
	rcmArray.push("keko=\"傾向\"; if( Pch[bang]<0.05 ) keko=\"\"\n");
	rcmArray.push("txt= paste(txt, \"下記のTable(hyo)においてFisherの正確検定により有意\",keko,\"差が見いだされた (p=\",PV(Pch[bang]),\", 両側検定)。\", sep=\"\" )\n");
	rcmArray.push("}\n");
	rcmArray.push("txt= paste(txt, \"\\n※js-STAR_XR+のメニュー［ｔ検定(参加者間)／ノンパラ］に実装。\", sep=\"\" )\n");
	rcmArray.push(" tab= c()\n");
	rcmArray.push(" if( yuis>1 )\n");
	rcmArray.push("{\n");
	rcmArray.push("txt=paste(txt, \"\\n　他の有意性を示した２×２表はオプション［探索的集計検定］を参照してください。\", sep=\"\" )\n");
	rcmArray.push("for( i in 2:yuis )\n");
	rcmArray.push("{\n");
	rcmArray.push(" haba= c(paste(dz[1],\"～\",dz[mds[junb[i]]],sep=\"\"), paste(dz[mds[junb[i]]+1],\"～\",dz[Nz],sep=\"\") )\n");
	rcmArray.push(" tab= paste(tab, \"--------\\n            \",haba[1],\"   \",haba[2],\"\\n\", sep=\"\" )\n");
	rcmArray.push(" for( j in 1:2 )\n");
	rcmArray.push("   {\n");
	rcmArray.push("    tab= paste(tab, \"群\",j,\" (n=\",format(n[j],w=3),\") \", sep=\"\" )\n");
	rcmArray.push("    for( k in 1:2 ) tab=paste(tab, format(dosu[1+4*(junb[i]-1)+(j-1)+(k-1)*2],w=nchar(haba[j])+1+3*(k-1)), sep=\"\" )\n");
	rcmArray.push("    tab= paste(tab,\"\\n\",sep=\"\" )\n");
	rcmArray.push("   }\n");
	rcmArray.push(" tab= paste(tab, \"Fisher's exact p=\",PV(Pch[junb[i]]),\" (両側)\\n\", sep=\"\" )\n");
	rcmArray.push("} # for(i)\n");
	rcmArray.push("} # if(yuis>1\n");
	rcmArray.push("txt= paste(txt,\"\\n\\n\", sep=\"\" )\n");
	rcmArray.push("EXP2x2= tab\n");
	rcmArray.push("\n");
	rcmArray.push("options(digits=5)\n");
	rcmArray.push("options(scipen=5)\n");
	rcmArray.push("################################\n");
	rcmArray.push("#   参加者間ｔ検定  片側検定\n");
	rcmArray.push("#\n");
	rcmArray.push("#   対立仮説： 平均1＞平均2\n");
	rcmArray.push("#           or 平均1＜平均2\n");
	rcmArray.push("################################\n");
	rcmArray.push("tx0 # 基本統計量  ※SDは不偏分散の平方根\n");
	rcmArray.push("\n");
	rcmArray.push("tx4 # ｔ検定（分散不等はWelchの方法による）\n");
	rcmArray.push("# 効果量ｄの評価：大=0.80, 中=0.50, 小=0.20\n");
	rcmArray.push("\n");
	rcmArray.push("tx8 # 平均の差の信頼区間推定\n");
	rcmArray.push("\n");
	rcmArray.push("\n");
	rcmArray.push("################################\n");
	rcmArray.push("#   参加者間ｔ検定  両側検定\n");
	rcmArray.push("#\n");
	rcmArray.push("#   対立仮説：平均1≠平均2\n");
	rcmArray.push("################################\n");
	rcmArray.push("tx0 # 基本統計量  ※SDは不偏分散の平方根\n");
	rcmArray.push("# 歪度,尖度,SEなどは『オプション』参照\n");
	rcmArray.push("\n");
	rcmArray.push("txV # 分散の同質性検定と分散比の信頼区間推定\n");
	rcmArray.push("# p>α なら「真の分散比＝１」(→分散同等)\n");
	rcmArray.push("# p<α なら「真の分散比≠１」(→分散不等)\n");
	rcmArray.push("\n");
	rcmArray.push("tx2 # ｔ検定（分散不等はWelchの方法による）\n");
	rcmArray.push("# 効果量ｄの評価：大=0.80, 中=0.50, 小=0.20\n");
	rcmArray.push("\n");
	rcmArray.push("tx9 # 平均の差の信頼区間推定\n");
	rcmArray.push("\n");
	rcmArray.push("tx5 # 追試用パワーアナリシス(分散不等を仮定)\n");
	rcmArray.push("# αと検出力は次回の想定値\n");
	rcmArray.push("\n");
	rcmArray.push("cat(txt) # 結果の書き方\n");
	rcmArray.push("\n");
	rcmArray.push("hyo # 探索的集計検定の結果\n");
	rcmArray.push("\n");
	rcmArray.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
	if (navigator.platform.indexOf("Win") != -1) {
		rcmArray.push("# windows();boxplot(g1,g2) # 各群の箱ひげ図\n");
	}
	if (navigator.platform.indexOf("Mac") != -1) {
		rcmArray.push("# quartz();boxplot(g1,g2) # 各群の箱ひげ図\n");
	}
	rcmArray.push("# txD        # Median,歪度,尖度,SEなど\n");
	rcmArray.push("# Median2x2  # メディアン検定の分割表\n");
	rcmArray.push("# BMp(g1,g2) # 順列化BMの正確検定(使用はn<15推奨)\n");
	rcmArray.push("# cat(EXP2x2) # 探索的集計検定（他の２×２表）\n");
	rcmArray.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
	rcmArray.push("\n");
	rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

	document.getElementById("RcmArea").value = document.getElementById("RcmArea").value + rcmArray.join("");
	rcmArray = null;
}
function outputR_Bayes_Ts() { //ベイズ統計のR出力
	var rcmArray = [];
	var spc = "          ";

	rcmArray.push("  rscale=0.707   # medium ※尺度設定\n");
	rcmArray.push("# rscale=1       # wide\n");
	rcmArray.push("# rscale=sqrt(2) # ultrawide\n");
	rcmArray.push("\n");
	rcmArray.push("BFkj= 3 # BFの評価基準\n");
	rcmArray.push("\n");
	rcmArray.push("  Gosa=1 # 1%以下.誤差\n");
	rcmArray.push("# Gosa=2 # 2%以下\n");
	rcmArray.push("# Gosa=5 # 5%以下\n");
	rcmArray.push("\n");
	rcmArray.push("# hk\n");
	rcmArray.push("library( psych )\n");
	rcmArray.push("library( BayesFactor )\n");
	rcmArray.push("Title=\"平均と標準偏差(不偏分散の平方根)\"\n");
	rcmArray.push("tx0=c(); txD=c()\n");
	rcmArray.push("kx= rbind(describe(g1), describe(g2) )\n");
	rcmArray.push("tx0= as.numeric(c(kx$n,kx$mean,kx$sd,kx$se,kx$min,kx$max) )\n");
	rcmArray.push("tx0= matrix(round(tx0,4), nr=2 )\n");
	rcmArray.push("rownames(tx0)= c(\"群１\",\"群２\")\n");
	rcmArray.push("colnames(tx0)= c(\" ｎ\",\"   Mean\",\"SD\",\"標準誤差\",\"Min\",\"Max\" )\n");
	rcmArray.push("\n");
	rcmArray.push("txD= as.numeric(c(kx$med,kx$range,kx$skew,kx$kurt,kx$se) )\n");
	rcmArray.push("txD= matrix(round(txD,4), nr=2 )\n");
	rcmArray.push("rownames(txD)= rownames(tx0)\n");
	rcmArray.push("colnames(txD)= c(\"Median\",\"Range\",\"歪度\",\"尖度\",\"SE\" )\n");
	rcmArray.push("hk=tx0[,2]; sd=tx0[,3]\n");
	rcmArray.push("maru=3; if( min(abs(tx0[,2]))<0.05 ) maru=4\n");
	rcmArray.push("\n");
	rcmArray.push("## 作図\n");
	rcmArray.push("mitsdo= c( 0, 20 )   # バーの斜線密度\n");
	rcmArray.push("xjik= c(0, 3)        # ｘ軸の範囲\n");
	rcmArray.push("bai = 2              # ｙ軸の拡幅倍率\n");
	rcmArray.push("shoh= min(min(hk),0) # 最小平均か，ゼロ\n");
	rcmArray.push("dais= max(sd)        # 最大ＳＤ\n");
	rcmArray.push("yjik= c(shoh+dais*bai*sign(shoh), max(hk)+dais*bai )\n");
	rcmArray.push("\n");
	rcmArray.push("for( L in 1:2 )\n");
	rcmArray.push("{\n");
	rcmArray.push("if( L==1 ) Sd=sd else { Sd=txD[,5]; Title=\"平均とSE(標準誤差)\" }\n");

	if (navigator.platform.indexOf("Win") != -1) {
		rcmArray.push("windows()\n");
	}
	if (navigator.platform.indexOf("Mac") != -1) {
		rcmArray.push("quartz()\n");
	}

	rcmArray.push("antx= barplot(hk, xli=xjik, yli=yjik,\n");
	rcmArray.push("    las=1, tck=0.02,   # ｙ軸の目盛デザイン\n");
	rcmArray.push("    col=1, den=mitsdo, # バーの色，斜線密度\n");
	rcmArray.push("    names.arg=c(\"群1\",\"群2\"),\n");
	rcmArray.push("    xlab=\"\", ylab=\"平　均\",\n");
	rcmArray.push("    main=Title, cex.main=1.5, cex.lab=1.2, cex.names=1.2 )\n");
	rcmArray.push("arrows(antx,hk, antx,hk+Sd*sign(hk), lwd=L,ang=90,len=0.2 )\n");
	rcmArray.push("if(L==2) arrows(antx,hk,antx,hk-Sd*sign(hk),lwd=L,ang=90,len=0.2 )\n");
	rcmArray.push("}\n");
	rcmArray.push("\n");
	rcmArray.push("# ttestBF\n");
	rcmArray.push("Bxt=c(); scOpt=c(0.707, 1, sqrt(2) )\n");
	rcmArray.push("kaisu= 1e+4\n");
	rcmArray.push("for( i in 1:3 ) # scaling\n");
	rcmArray.push("{\n");
	rcmArray.push("kx= ttestBF(g1,g2, rscale=scOpt[i] )\n");
	rcmArray.push("Er= extractBF(kx)[2]*100\n");
	// rcmArray.push("while( Er>1 )\n");
	// rcmArray.push("{\n");
	rcmArray.push("hnpk=0\n");
	rcmArray.push("while( Er>Gosa )\n");
	rcmArray.push("{\n");
	rcmArray.push(" hnpk=hnpk+1\n");
	rcmArray.push(" if( hnpk==4 ){ Gosa=Gosa+1; hnpk=0 }\n");
	rcmArray.push(" kx= recompute(kx)\n");
	rcmArray.push(" Er= extractBF(kx)[2]*100\n");
	rcmArray.push("}\n");
	rcmArray.push("bf= as.vector(kx)\n");
	rcmArray.push("Bxt= rbind(Bxt, c(round(as.numeric(bf),3),round(as.numeric(Er),2)) )\n");
	rcmArray.push("}\n");
	rcmArray.push("Bxt= cbind(Bxt, round(1/Bxt[,1], 3) )\n");
	rcmArray.push("rownames(Bxt)= c(\"rscale=0.707\",\"rscale=1\",\"rscale=√2\")\n");
	rcmArray.push("colnames(Bxt)= c(\"    BF\", \" err%\",\"   1/BF\")\n");
	rcmArray.push("\n");
	rcmArray.push("pos= posterior(kx, iter=kaisu )\n");
	rcmArray.push("tmp= summary(pos )\n");
	rcmArray.push("Bxt2= matrix( round( c(\n");
	rcmArray.push("      tmp$stat[4,1:2], tmp$quant[4,c(3,1,5)]\n");
	rcmArray.push("      ), maru), nr=1 )\n");
	rcmArray.push("rownames(Bxt2)=\"delta\"\n");
	rcmArray.push("colnames(Bxt2)= c(\"Mean\",\"SD\",\" Median\",\" CI 2.5%\",\"- 97.5%\")\n");
	rcmArray.push("delta= Bxt2[1,1]\n");
	rcmArray.push("\n");
	rcmArray.push("# 片側gr,Ls\n");
	rcmArray.push("BgL=c(); bfs=c()\n");
	rcmArray.push("for( i in 1:3 ) # scaling\n");
	rcmArray.push("{\n");
	rcmArray.push("kz= ttestBF(g1,g2,rscale=scOpt[i], nullInterval=c(0,Inf) )\n");
	rcmArray.push("bfs= c(bfs,\n");
	rcmArray.push(" round(as.numeric(as.vector(kz[1])), 3),\n");
	rcmArray.push(" round(as.numeric(extractBF(kz)[1,2]*100), 2),\n");
	rcmArray.push(" round(as.numeric(as.vector(kz[2])), 3),\n");
	rcmArray.push(" round(as.numeric(extractBF(kz)[2,2]*100), 2)\n");
	rcmArray.push(" )\n");
	rcmArray.push("}\n");
	rcmArray.push("BgL= matrix(bfs, nc=4,by=1 )\n");
	rcmArray.push("rownames(BgL)= c(\"BF_0.707\",\"BF_1\",\"BF_√2\")\n");
	rcmArray.push("colnames(BgL)= c(\"μ1>μ2\",\" err%\",\" μ1<μ2\",\" err%\")\n");
	rcmArray.push("\n");
	rcmArray.push("BgL2= c()\n");
	rcmArray.push("posg= summary( posterior(kz[1], iter=kaisu) )\n");
	rcmArray.push("posL= summary( posterior(kz[2], iter=kaisu) )\n");
	rcmArray.push("BgL2= matrix( round( as.numeric( c(\n");
	rcmArray.push(" posg$stat[4,1:2], posg$quant[4,c(3,1,5)],\n");
	rcmArray.push(" posL$stat[4,1:2], posL$quant[4,c(3,1,5)]\n");
	rcmArray.push(" ) ), 3), nr=2,by=1 )\n");
	rcmArray.push("rownames(BgL2)= c(\"H1:δ>0\",\"H1:δ<0\")\n");
	rcmArray.push("colnames(BgL2)= colnames(Bxt2)\n");
	rcmArray.push("\n");
	rcmArray.push("# deltaの評価\n");
	rcmArray.push("ESd= function(size)\n");
	rcmArray.push("{\n");
	rcmArray.push("TXT= c()\n");
	rcmArray.push("size= abs(size)\n");
	rcmArray.push("int1=c(size, Inf ); int0=c(0, size )\n");
	rcmArray.push("if( delta<0 ){ int1=c(-Inf, -1*size); int0=c(-1*size, 0) }\n");
	rcmArray.push("\n");
	rcmArray.push("bf1= ttestBF(g1,g2,rscale=rscale, nullInterval=int1 )\n");
	rcmArray.push("bf0= ttestBF(g1,g2,rscale=rscale, nullInterval=int0 )\n");
	rcmArray.push("BF= bf1[1] / bf0[1]\n");
	rcmArray.push("TXT= c(as.vector(BF), attributes(BF)$bayesFactor[1,2]*100 )\n");
	rcmArray.push("TXT= matrix(round(as.numeric(TXT), 3), nr=1 )\n");
	rcmArray.push("rownames(TXT)= paste(\"|δ|＞\",size, sep=\"\")\n");
	rcmArray.push("colnames(TXT)= c(\"    BF\",\" err(%)\")\n");
	rcmArray.push("TXT\n");
	rcmArray.push("}\n");
	rcmArray.push("tmp=c(); kjun=c(0.2, 0.5, 0.8 )\n");
	rcmArray.push("for( kj in 1:3 ) tmp=c(tmp, ESd(kjun[kj])[1,] )\n");
	rcmArray.push("Bxt3= matrix(round(c(tmp[c(1,3,5)],1/tmp[c(1,3,5)],tmp[c(2,4,6)]), 3), nc=3,by=1 )\n");
	rcmArray.push("rownames(Bxt3)= c(\"BF10\",\"BF01\",\"err(%)\")\n");
	rcmArray.push("colnames(Bxt3)= c(\"|δ|>0.2\",\" |δ|>0.5\",\" |δ|>0.8\")\n");
	rcmArray.push("\n");
	rcmArray.push("# ■結果の書き方\n");
	rcmArray.push("options(digits=5)\n");
	rcmArray.push("options(scipen=5)\n");
	rcmArray.push("mds= paste(\"※事前分布：Cauchy(rscale=\",rscale,\")\", sep=\"\" )\n");
	rcmArray.push("H=matrix(\"\"); colnames(H)=mds; rownames(H)=\"\"\n");
	rcmArray.push("txt= c()\n");
	rcmArray.push("if( sum(sd==0)>0 ) txt=\"※分散=0 の水準があります。全データが同じ値です。以下の分析は信頼性がありません。\\n\\n\"\n");
	rcmArray.push("\n");
	rcmArray.push("tsBF= function(bf)\n");
	rcmArray.push("{\n");
	rcmArray.push("TXT= c()\n");
	rcmArray.push("if( bf>150) TXT=\"非常に有力\" else\n");
	rcmArray.push("if( bf> 20) TXT=\"有力\"       else\n");
	rcmArray.push("if( bf>=BFkj) TXT=\"有効\"\n");
	rcmArray.push("TXT\n");
	rcmArray.push("}\n");
	rcmArray.push("\n");
	rcmArray.push("gyo= (order(scOpt==rscale, decreasing=T)[1]-1)*2+1\n");
	rcmArray.push("bf=Bxt[gyo, 1]; Er=Bxt[gyo, 2]\n");
	rcmArray.push("fuki= paste(\"（BF=\",bf,\", error=\",Er,\"%，両側検定）。\", sep=\"\" )\n");
	rcmArray.push("if( bf>=BFkj ) goku=\"であった\" else goku=\"有効水準に達しなかった\"\n");
	rcmArray.push("txt= paste(txt, \"　各群の○○得点について基本統計量をTable(tx0) or Fig.■に示す。\\n　ベイズファクタ分析（有効水準=\",BFkj,\"）を行った結果（Table(Bxt)参照），BF値は\",tsBF(bf),goku,fuki, sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("if( bf>=BFkj )\n");
	rcmArray.push("{\n");
	rcmArray.push(" if( hk[1]-hk[2]>0 ) tmp=\"大きい\" else tmp=\"小さい\"\n");
	rcmArray.push(" txt= paste(txt, \"したがって群１の平均\",hk[1],\"が群２の平均\",hk[2],\"よりも実質的に\",tmp,\"ことが示された。\", sep=\"\" )\n");
	rcmArray.push("}\n");
	rcmArray.push("txt= paste(txt, \"事後分布における効果量δのメディアンは\",Bxt2[1,3],\"であり, その95％確信区間は\",Bxt2[1,4],\" - \",Bxt2[1,5],\"と推定された。\\n\", sep=\"\" )\n");
	rcmArray.push("if( (1/bf)>=BFkj ) txt=paste(txt, \"　逆に，対立仮説に比して帰無仮説が\",tsBF(1/bf),\"であり (BF=\",round(1/bf,3),\")，２平均に実質的な差はないことが見いだされた。\\n\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("if( bf>=BFkj )\n");
	rcmArray.push("{\n");
	rcmArray.push(" rets= sum( Bxt3[1,]>=3 )\n");
	rcmArray.push(" if( rets>0 ){\n");
	rcmArray.push(" atai=kjun[rets]; bf3=Bxt3[1,rets]; Er3=Bxt3[3,rets]\n");
	rcmArray.push(" gawa=\"が\"\n");
	rcmArray.push(" if( bf3>=BFkj ){ gok1=\"であり\"; gok2=\"以上\" } else { gawa=\"は\"; gok1=\"有効水準に達せず\"; gok2=\"以下\" }\n");
	rcmArray.push(" txt= paste(txt, \"\\n　さらに効果量δの範囲についてベイズファクタによる検定を行った結果（Table(Bxt3)参照），|δ|＞\",atai,\"のBF値\",gawa,tsBF(bf3),gok1,\"（BF=\",bf3,\", error=\",round(Er3, 2),\"%），効果量δの大きさは絶対値\",atai,gok2,\"と想定される。\\n\", sep=\"\" )\n");
	rcmArray.push("} }\n");
	rcmArray.push("\n");
	rcmArray.push("txt= paste(txt, \"\\n　以上のBF値の計算にはＲパッケージBayesFactor (Morey & Rouder, 2021) を使用し，事前分布をCauchy(rscale=\",rscale,\")としたほかは各種設定はデフォルトに従った。MCMC法による推定回数は1万回とした。\\n\", sep=\"\" )\n");
	rcmArray.push("\n");
	rcmArray.push("txt= paste(txt, \"\\n\\n⇒データ分布に正規形を仮定できない場合，下の記述を参照してください。\\n\", sep=\"\" )\n");
	rcmArray.push("n1=length(g1); n2=length(g2); n=c(n1,n2); N=n1+n2\n");
	rcmArray.push("dx=c(g1, g2); dx=dx[order(dx)] # 昇順\n");
	rcmArray.push("dz= dx[1]\n");
	rcmArray.push("for( i in 2:N ) if( dx[i]>dx[i-1] ) dz=c(dz, dx[i] )\n");
	rcmArray.push("Nz= length(dz)    # 異なり数\n");
	rcmArray.push("dosu=c(); mds=c() # 区切り番号\n");
	rcmArray.push("yuis=0; BFs=c()\n");
	rcmArray.push("hyo=c(); EXP2x2=c()\n");
	rcmArray.push("for( i in 1:(Nz-1) )\n");
	rcmArray.push("{\n");
	rcmArray.push(" ds1= sum( g1<=dz[i] )\n");
	rcmArray.push(" ds2= sum( g2<=dz[i] )\n");
	rcmArray.push(" hyo= matrix(c(ds1,n1-ds1, ds2,n2-ds2), nc=2,by=1 )\n");
	rcmArray.push(" bfs= as.vector(contingencyTableBF(hyo,sample=\"indepMulti\",fix=\"rows\") )\n");
	rcmArray.push(" BFs=c(BFs, bfs); dosu=c(dosu, as.numeric(hyo)); mds=c(mds,i)\n");
	rcmArray.push("}  # for(i)\n");
	rcmArray.push("txt= paste(txt, \"\\n　探索的集計検定 (※）の結果，\", sep=\"\" )\n");
	rcmArray.push("tmp= c(paste(\" 群1（n=\",n1,\"）\",sep=\"\"), paste(\" 群2（n=\",n2,\"）\",sep=\"\") )\n");
	rcmArray.push("\n");
	rcmArray.push("junb=order(BFs, decreasing=T); bang=junb[1] # 最大BF値\n");
	rcmArray.push("yuis= sum( BFs>=BFkj )\n");
	rcmArray.push("hyo= matrix(dosu[ (1+4*(bang-1)):(4*bang) ], nc=2 )\n");
	rcmArray.push("rownames(hyo)=c(tmp); bx=paste(\"BF=\",round(BFs[bang], 3),\", error=0% (両側検定)\\n\", sep=\"\")\n");
	rcmArray.push("colnames(hyo)= c(paste(dz[1],\"～\",dz[mds[bang]],sep=\"\"), paste(\"  \",dz[mds[bang]+1],\"～\",dz[Nz],sep=\"\") )\n");
	rcmArray.push("\n");
	rcmArray.push("if( yuis==0 ) txt=paste(txt, \"有効以上のBF値を示した２×２分割表は見いだされなかった (下記Table(hyo)参照）。\", sep=\"\" ) else\n");
	rcmArray.push("{\n");
	rcmArray.push("txt= paste(txt, \"下記のTable(hyo)において有効以上のBF値が示され，２群間には列１の比率（または列２の比率）に実質的な差があることが見いだされた (BF=\",round(BFs[bang], 3),\", error=0%, 両側検定)。なおBF値の計算にはＲパッケージBayesFactor (Morey & Rouder, 2021) を使用し，各種設定はデフォルトに従った。\", sep=\"\" )\n");
	rcmArray.push("}\n");
	rcmArray.push("txt= paste(txt, \"\\n※js-STAR_XR+のメニュー［ｔ検定(参加者間)／ノンパラ］に実装。\", sep=\"\" )\n");
	rcmArray.push(" tab= c()\n");
	rcmArray.push(" if( yuis>1 )\n");
	rcmArray.push("{\n");
	rcmArray.push("txt=paste(txt, \"\\n　他の有効性を示した２×２表はオプション［探索的集計検定］を参照してください。\", sep=\"\" )\n");
	rcmArray.push("for( i in 2:yuis )\n");
	rcmArray.push("{\n");
	rcmArray.push(" haba= c(paste(dz[1],\"～\",dz[mds[junb[i]]],sep=\"\"), paste(dz[mds[junb[i]]+1],\"～\",dz[Nz],sep=\"\") )\n");
	rcmArray.push(" tab= paste(tab, \"--------\\n            \",haba[1],\"   \",haba[2],\"\\n\", sep=\"\" )\n");
	rcmArray.push(" for( j in 1:2 )\n");
	rcmArray.push("   {\n");
	rcmArray.push("    tab= paste(tab, \"群\",j,\" (n=\",format(n[j],w=3),\") \", sep=\"\" )\n");
	rcmArray.push("    for( k in 1:2 ) tab=paste(tab, format(dosu[1+4*(junb[i]-1)+(j-1)+(k-1)*2],w=nchar(haba[k])+1+2*(k-1)), sep=\"\" )\n");
	rcmArray.push("    tab= paste(tab,\"\\n\",sep=\"\" )\n");
	rcmArray.push("   }\n");
	rcmArray.push(" tab= paste(tab, \"BF=\",round(BFs[junb[i]], 3),\" (両側検定)\\n\", sep=\"\" )\n");
	rcmArray.push("} # for(i)\n");
	rcmArray.push("} # if(yuis>1\n");
	rcmArray.push("txt= paste(txt,\"\\n\\n\", sep=\"\" )\n");
	rcmArray.push("EXP2x2= tab\n");
	rcmArray.push("\n");
	rcmArray.push("#################################\n");
	rcmArray.push("#  ■ベイズファクタ分析\n");
	rcmArray.push("#  　２標本の平均の差の検定\n");
	rcmArray.push("#  　片側仮説：μ1＞μ2,μ1＜μ2\n");
	rcmArray.push("#\n");
	rcmArray.push("#  　参加者間ｔ検定 対応\n");
	rcmArray.push("H################################\n");
	rcmArray.push("tx0 # 基本統計量　※SDは不偏分散の平方根\n");
	rcmArray.push("\n");
	rcmArray.push("BgL # 片側仮説のベイズファクタ分析\n");
	rcmArray.push("# BF値の便宜的評価：有効>3, 有力>20\n");
	rcmArray.push("\n");
	rcmArray.push("BgL2 # 効果量δ(delta)の事後分布\n");
	rcmArray.push("# 便宜的評価：大=|0.8|,中=|0.5|,小=|0.2|\n");
	rcmArray.push("\n");
	rcmArray.push("\n");
	rcmArray.push("##############################\n");
	rcmArray.push("#  ■ベイズファクタ分析\n");
	rcmArray.push("#  　２標本の平均の差の検定\n");
	rcmArray.push("#  　両側仮説：μ1≠μ2\n");
	rcmArray.push("#\n");
	rcmArray.push("#  　参加者間ｔ検定 対応\n");
	rcmArray.push("H#############################\n");
	rcmArray.push("tx0 # 基本統計量　※SDは不偏分散の平方根\n");
	rcmArray.push("# 歪度,尖度ほかは『オプション』参照\n");
	rcmArray.push("\n");
	rcmArray.push("Bxt # 両側仮説のベイズファクタ分析\n");
	rcmArray.push("# BF値の便宜的評価：有効>3, 有力>20\n");
	rcmArray.push("\n");
	rcmArray.push("Bxt2 # 効果量δ(delta)の事後分布\n");
	rcmArray.push("\n");
	rcmArray.push("Bxt3 # 効果量δ(delta)の範囲の検定\n");
	rcmArray.push("# BF10はH1:|δ|＞0.2, 0.5, 0.8のBF値\n");
	rcmArray.push("# BF01はH0:|δ|≦0.2, 0.5, 0.8のBF値\n");
	rcmArray.push("\n");
	rcmArray.push("cat(txt) # 結果の書き方\n");
	rcmArray.push("\n");
	rcmArray.push("hyo;cat(bx) # 探索的集計検定の結果\n");
	rcmArray.push("\n");
	rcmArray.push("# ■オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
	if (navigator.platform.indexOf("Win") != -1) {
		rcmArray.push("# windows();boxplot(g1,g2) # 各群の箱ひげ図\n");
	}
	if (navigator.platform.indexOf("Mac") != -1) {
		rcmArray.push("# quartz();boxplot(g1,g2) # 各群の箱ひげ図\n");
	}
	rcmArray.push("# txD           # Median,歪度,尖度,SEなど\n");
	rcmArray.push("# pos           # 事後推定データ(大量注意)\n");
	rcmArray.push("# summary(pos)  # 事後分布の要約統計量\n");
	rcmArray.push("# plot(pos[,4]) # MCMC出力図：効果量δ\n");
	rcmArray.push("# ESd( 0.5 )    # δの範囲検定(絶対値入力)\n");
	rcmArray.push("# cat(EXP2x2)   # 探索的集計検定（他の２×２表）\n");
	rcmArray.push("# write(txt,file.choose(),ap=T) # 結果のファイル保存\n");
	rcmArray.push("\n");
	rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/\n");

	document.getElementById("RcmArea").value = document.getElementById("RcmArea").value + rcmArray.join("");
	rcmArray = null;
}